{*********************************
 *   Rem Floor Demo v010 *
 *********************************


}

CON

  _clkmode = xtal1 + pll8x  ' ?
  _xinfreq = 10_000_000 + 0_000 ' Set to 10Mhz and add 5000 to fix crystal imperfection of hydra prototype
  '_stack = ($300 - 200) >> 2           'accomodate display memory and stack
  _memstart = $10                   ' memory starts $10 in!!! (this took 2 headaches to figure out)

  paramcount = 14
  SCANLINE_BUFFER = $7F00
  ' Define list of intercog global variable: they start right next to the video scanlinebuffer
  spin_request_scanline = SCANLINE_BUFFER-4
  spin_vertical_scroll = SCANLINE_BUFFER-8
  spin_horizontal_scroll = SCANLINE_BUFFER-12
  spin_top_y = SCANLINE_BUFFER-16
  spin_bottom_y = SCANLINE_BUFFER-20
  spin_stop_y = SCANLINE_BUFFER-24
  spin_tilemap_adr = SCANLINE_BUFFER-28
  spin_tiles_adr = SCANLINE_BUFFER-32
  spin_gamepad = SCANLINE_BUFFER-36
  spin_framecount_adr = SCANLINE_BUFFER-40
  spin_mousex_adr = SCANLINE_BUFFER-44
  spin_mousey_adr = SCANLINE_BUFFER-48

  NES_RIGHT  = %00000001
  NES_LEFT   = %00000010
  NES_DOWN   = %00000100
  NES_UP     = %00001000
  NES_START  = %00010000
  NES_SELECT = %00100000
  NES_B      = %01000000
  NES_A      = %10000000

VAR
  long tv_status      '0/1/2 = off/visible/invisible           read-only
  long tv_enable      '0/? = off/on                            write-only
  long tv_pins        '%ppmmm = pins                           write-only
  long tv_mode        '%ccinp = chroma,interlace,ntsc/pal,swap write-only
  long tv_screen      'pointer to screen (words)               write-only
  long tv_colors      'pointer to colors (longs)               write-only               
  long tv_hc          'horizontal cells                        write-only
  long tv_vc          'vertical cells                          write-only
  long tv_hx          'horizontal cell expansion               write-only
  long tv_vx          'vertical cell expansion                 write-only
  long tv_ho          'horizontal offset                       write-only
  long tv_vo          'vertical offset                         write-only
  long tv_broadcast   'broadcast frequency (Hz)                write-only
  long tv_auralcog    'aural fm cog                            write-only

  long temp1

  ' param for rem_engine:
  long cog_number
  long cog_total
  
  long colors[1]

OBJ

  tv    : "rem_tv_014.spin"
  gfx   : "rem_gfx_engine_014.spin"
  mouse : "mouse_iso_010.spin"
  loader : "REM_LOADER_KERNEL_001.spin" ' loader kernel (boots paged cogs)


PUB start      | i, j, k, kk, dx, dy, pp, pq, rr, numx, numchr
  DIRA[0] := 1
  outa[0] := 0

  longfill(@colors, $02020202, 1)

  long[spin_tiles_adr] := @floor000

  cog_number := 0
  cog_total := 4
  gfx.start(@cog_number)
  repeat 10000 ' Allow some time for previous cog to boot up before setting 'cog_number' again
  cog_number := 1
  gfx.start(@cog_number)
  repeat 10000 ' Allow some time for previous cog to boot up before setting 'cog_number' again
  cog_number := 2
  gfx.start(@cog_number)
  repeat 10000 ' Allow some time for previous cog to boot up before setting 'cog_number' again
  cog_number := 3
  gfx.start(@cog_number)
  repeat 10000 ' Allow some time for previous cog to boot up before setting 'cog_number' again

  'start tv
  longmove(@tv_status, @tvparams, paramcount)
  tv_colors := @colors
  tv.start(@tv_status)

  mouse.start(2)

  loader.start(@GAMEINIT_START)

  long[spin_top_y] := 0
  long[spin_bottom_y] := 192
  long[spin_stop_y] := 192


  ' Start of main loop here
  repeat
    repeat while tv_status == 1
    repeat while tv_status == 2

    long[spin_mousex_adr] := long[spin_mousex_adr] + mouse.delta_x #> 0 <# 255
    long[spin_mousey_adr] := long[spin_mousey_adr] - mouse.delta_y #> 0 <# 191


'end of main
'---------------------------------------------


DAT

tvparams                long    0               'status
                        long    1               'enable
                        long    %011_0000       'pins
                        long    %0000           'mode
                        long    0               'screen
                        long    0               'colors
                        long    16              'hc
                        long    12              'vc
                        long    10              'hx
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    60_000_000'_xinfreq<<4  'broadcast
                        long    0               'auralcog

                        org
GAMEINIT_START
                        mov dira, #1            ' Prepare led debug
loop
                        'xor outa, #1

                        rdlong framecount, framecount_adr

                        call #waitvbl

                        add framecount, #1
                        wrlong framecount, framecount_adr

                        rdlong r0, horizontal_scroll
                        add r0, hscroll_speed
                        wrlong r0, horizontal_scroll

                        jmp #loop

waitvbl                 
:wait_status_1          rdlong r0, request_scanline
                        cmp r0, #191            wz
        if_ne           jmp #:wait_status_1
:wait_status_2          rdlong r0, request_scanline
                        cmp r0, #192            wz
        if_ne           jmp #:wait_status_2

waitvbl_ret             ret

request_scanline        long SCANLINE_BUFFER-4
vertical_scroll         long SCANLINE_BUFFER-8
horizontal_scroll       long SCANLINE_BUFFER-12
top_y_adr               long SCANLINE_BUFFER-16
bottom_y_adr            long SCANLINE_BUFFER-20
stop_y_adr              long SCANLINE_BUFFER-24
tilemap_adr             long SCANLINE_BUFFER-28
tiles_adr               long SCANLINE_BUFFER-32
gamepad                 long SCANLINE_BUFFER-36
framecount_adr          long SCANLINE_BUFFER-40
framecount              long 0

hscroll_speed           long 165536

GAMEINIT_END

fit 440 ' real maximum is 448

' /////////////////////////////////////////////////////////////////////////////
' GLOBAL REGISTERS ////////////////////////////////////////////////////////////
' /////////////////////////////////////////////////////////////////////////////

                        org                     $1e0

r0                      long                    $0
r1                      long                    $0
r2                      long                    $0
r3                      long                    $0
r4                      long                    $0
r5                      long                    $0
r6                      long                    $0
r7                      long                    $0

' /////////////////////////////////////////////////////////////////////////////
' LOADER REGISTERS ////////////////////////////////////////////////////////////
' /////////////////////////////////////////////////////////////////////////////

                        org                     $1c0                        
__loader_return         res                     7
__loader_call           res                     6
__loader_execute

                        org                     $1e0                            ' general registers 1e0-1ef
__loader_registers
__g0                    res                     1 ' g0..g7 : Global COG Registers
__g1                    res                     1
__g2                    res                     1
__g3                    res                     1
__g4                    res                     1
__g5                    res                     1
__g6                    res                     1
__g7                    res                     1

__t0                    res                     1
__t1                    res                     1
__t2                    res                     1
__loader_ret            res                     1
__loader_stack          res                     1
__loader_page           res                     1
__loader_size           res                     1
__loader_jmp            res                     1

' //////////////////////////////////////////////////////////////////////////
' HUB VARIABLES ////////////////////////////////////////////////////////////
' //////////////////////////////////////////////////////////////////////////

org
floor000 long $CB8B02BB,$590203BB,$01590202,$0202CA5A,$02025A02,$03025A02,$02025ACB,$8B5A0202,$BBCB5A02,$02020202,$025A0259,$5ACB0299,$02030202,$02BBCB02,$02020202,$02020101,$02020202,$CB590202,$02590202,$02020202,$4902CC5B,$02590202,$5959025A,$02037A02,$CA025959,$59598B03,$02030202,$021B5BCB,$0259CB02,$0202CB02,$02CC5A02,$5A015901,$5B025A5A,$D95A8B02,$CB03CB59,$59025A02,$02025ACA,$0202CB02,$CA5ACA5A,$CB010202,$0202025A,$D801CB8B,$D8020202,$D8025949,$5A030302,$01590259,$01020202,$02010101,$02029959,$02CA0202,$02CA025A,$02CB0202,$01020202,$02020202,$02020202,$DB5A5A8A,$5BBB02CB,$5ACA02BB,$5A03CA02,$0201CB03,$59CB5A02,$02020202,$5ACBCB02,$5ACA03CA
        long $CBCB0202,$02CA5A5A,$59020202,$59028A02,$02DBCB02,$5A5A0202,$5ACB5ACA,$59010202,$5CCB5902,$020202DC,$028BCB8B,$590102D9,$03CBCB02,$015948D8,$01010101,$99019901,$020259D8,$025A0202,$BB5A0202,$0202025A,$03CB0202,$02595902,$02029902,$5A029A02,$CB5A02CA,$EC02595A,$0202025A,$02CB5B02,$D8024902,$01020202,$03020259,$5A035C4C,$5B02DB5A,$02020202,$5A028B8B,$02027A02,$02030202,$DA5A0202,$021BCB5A,$025A0202,$5B59E801,$0249592C,$02CA5ADA,$0202CA59,$5A5A0201,$59E95902,$59D859E8,$0202CA59,$99495959,$02020259,$02020249,$025902CA,$CB5ACB02,$5A020202,$025959CB,$0102028B,$02025959,$5C020202,$020259DA,$BB6C5A02,$0202CB02,$02CB0249,$035A0101,$CB03DB03
        long $CB020202,$0202D859,$8B020202,$0202025A,$025A8B9A,$02025902,$5ACB0202,$02020202,$02020202,$0101E802,$025ACA59,$CA020202,$02010102,$02590201,$02020102,$9A02CB01,$0202D802,$02CCCB02,$02590299,$CA020202,$59020259,$02020202,$990102CB,$CB5A5BCB,$0202028B,$0102FC03,$0202BC5A,$0202D802,$598B5A59,$031B0202,$0259025A,$0259021B,$CB025ACB,$595A0202,$02025A02,$0201028B,$0202CA02,$599902CA,$CA495901,$02020149,$03CA0202,$02025902,$02010101,$020259D8,$0102BBCB,$59020259,$01995902,$02020101,$02020102,$02020259,$0259D959,$02020202,$CB0202BB,$010259BB,$49020259,$5ADB0202,$5BD80202,$02DA5BCC,$99028B02,$E959BB02,$CA020299,$03030202,$0202CBDC,$49010202
        long $0202CA02,$02CB0259,$0202CBCA,$59020259,$02595902,$CA02DC02,$4949E902,$02020202,$0259DA02,$0202CA02,$02020102,$5A025901,$5902CB5B,$D859E8E8,$01020159,$01989898,$01484801,$E80102D8,$5B990299,$025959DA,$02020202,$BCCB0201,$CB590101,$D8590202,$59590202,$02025901,$02020202,$02010249,$4959D802,$5A5A0249,$5ACB5ACB,$020202CB,$59590202,$02590101,$02CB5B5A,$8B020202,$0102CA8B,$5902CB02,$02595A02,$02CA0201,$D8025902,$02594959,$02020202,$020102CB,$02010202,$02599959,$5ACA015A,$0202DACB,$02E801D8,$01020259,$02495901,$99E90202,$02990202,$59590202,$02020202,$02CBCB49,$D859CA02,$02020101,$CB020202,$7CCA02EC,$025902CB,$02590201,$02021B02,$CBCB025B
        long $D8020202,$5A02CA02,$020159D8,$5A020202,$02030202,$02590101,$E859DC02,$02020202,$030259CB,$590102CB,$5ACB0259,$D85902CB,$01010102,$9902CB02,$1B010259,$5BEC5C03,$02010101,$01990201,$02029901,$5A024901,$CB020202,$5902CB03,$02020202,$025C0259,$01595902,$59019959,$5B020202,$0202DCEC,$CB02CB5B,$02020202,$1B025A1B,$5BCB5A02,$0259E802,$02590201,$02995A03,$02020202,$59BB0201,$02990259,$02020202,$025ACA5A,$02020202,$02020203,$02CA49D8,$5ACBCA5A,$0202CA03,$025BDB02,$595902D8,$DC5C03CB,$98014902,$0148E899,$02D85901,$02010159,$BBCC5A99,$02CB5A5A,$02590202,$02020299,$59D80201,$01010101,$DA590259,$02025C3C,$1B025B02,$1B020202,$1B5A1B02,$CC03CB02
        long $5A02CA5A,$02590102,$0202DA49,$03035902,$D8010102,$99025999,$025A0202,$0202025A,$02010199,$02020202,$CB5B0102,$02020202,$CA590202,$5902025A,$01D84959,$03030259,$02020202,$01025902,$02590101,$58990299,$5B03DA58,$028BCABB,$4902BB02,$02020202,$D8590102,$01015801,$59025901,$038B0202,$01020302,$02020202,$5A020202,$5ACB5BDB,$02025C03,$02D85ACA,$02020202,$EC024902,$020289CB,$4902CA5A,$E8020202,$CA02CB02,$01020202,$01590202,$CB495999,$8B025902,$02D89903,$D8010101,$02020259,$49020101,$CBBB0201,$02CC5902,$02990101,$D8490149,$CB5C0288,$02DC2CCB,$02025B02,$02025902,$01590202,$01014801,$CA035948,$03DB0202,$03BC0201,$491B4902,$02020249,$5959025B
        long $02020249,$02025902,$020202CB,$5BE8028B,$89025902,$02010202,$59CA0199,$02020201,$028B0202,$02020202,$02020202,$0101CB5A,$03025ACA,$0202CB02,$0202E859,$D8480102,$5ACB5A02,$595BD802,$01590148,$CB020199,$02594849,$025A5A5A,$020202CB,$02020202,$01010101,$01015901,$03DB0101,$EC4C7C02,$BBCB59CB,$5A020202,$020201CA,$02494902,$02495902,$02010202,$CA59025A,$CB590159,$0102595B,$01015902,$02025902,$02020202,$CADB4902,$01015902,$02CB0202,$025902CB,$037CCB02,$D8597CCB,$59590102,$02D85902,$8BCB02AB,$02010202,$01E89801,$0201D849,$019801D8,$010101CA,$02020202,$0202025A,$59010102,$590101E8,$02020202,$5A03DC02,$49590202,$5ACA02CB,$0202025B,$020259D8
        long $49590202,$59025A02,$020102CA,$5A010202,$018858DB,$02590101,$02020101,$5A02025A,$5B5B59CA,$0202DA5A,$02020202,$7B020203,$5ADA0202,$59020202,$49D85902,$7B590149,$025ACA5A,$0202CA59,$02020159,$59015901,$01D80202,$01020201,$02990249,$015902CA,$01010159,$01015902,$02020101,$0202BB02,$020202BB,$5A025959,$028B02DB,$02490259,$02DA5A02,$02020201,$025A0259,$CA590299,$0158015A,$0102CA01,$5A0259E8,$DB49DBCB,$59020203,$025ACB02,$020303CB,$020202BB,$02020202,$020202CA,$59010149,$02015902,$02025ACA,$02CB5901,$020201D8,$02CA7BCA,$59CB5A02,$59020259,$02010202,$99CA5A5A,$02CA0201,$01E84801,$02020199,$01020202,$02020259,$03DB0202,$020102CA,$0259E85A
        long $5902CBCB,$5902CB02,$0102DA02,$5A99021B,$0102BBCA,$98035C99,$02590259,$02590259,$02CA0249,$CB5A5A02,$CB030202,$02590202,$025A8BCB,$02020202,$02020202,$024801E8,$0202025A,$02014802,$5A015902,$5902025A,$D85A03CB,$0202CB02,$02025ACA,$CB5A02CA,$02BB0249,$0259D858,$7B590101,$7B8B0202,$99599902,$02595901,$0202028B,$02020202,$0259025B,$DBDB5A02,$0159CB5B,$02590249,$CBAB0202,$5BCBCA59,$02020202,$03020101,$02025902,$CB0202D8,$02030202,$0102CA59,$CA5A0303,$0202025A,$02ECDA02,$0102DC02,$D8590102,$01010159,$02990159,$02CA5A8B,$59020259,$02020101,$5902CA02,$5A025959,$AC5A01BA,$99580101,$D8010101,$DA020202,$49CA0202,$0259D801,$DB5ACA5A,$5A02028B
        long $CBCB025A,$03025902,$D8025ADB,$9802D859,$CA590159,$FC5B5902,$DBCB5AEC,$EC020102,$01D802CB,$5A010259,$02CB0202,$01CA5902,$5ACA5A01,$02020202,$CA590159,$01025B49,$590299D8,$01010202,$020159D8,$5902AB02,$DC025901,$02024901,$D85A0202,$CBD80101,$03020203,$48015998,$01015858,$02024959,$02015902,$CA020102,$CB5A0202,$CA035A02,$5B02CB02,$CB020203,$5A5A5902,$01590202,$59020299,$03030202,$5B030203,$CB0202CB,$02025A02,$0202CA02,$CB025ACB,$5A02025A,$0201CA02,$CA020202,$01590202,$5902D859,$02020259,$59990299,$01010159,$02025ACA,$49D80159,$02025901,$02024959,$01590159,$0102CB59,$0102CA49,$48780259,$02010101,$0202D802,$025B0259,$02CA035B,$5A020249
        long $594902CB,$5A021BCA,$DA020102,$02020303,$59CB5ACB,$5B020202,$020202DB,$015A5A02,$02590202,$02025959,$02CA4902,$02029902,$02025AAB,$02020202,$CACA0202,$02490102,$01020101,$D8595902,$01585901,$02CA7B02,$02590202,$59020202,$025959E8,$028B0201,$48010159,$010202CA,$010102D8,$0201E848,$CB0102DB,$02DA0201,$025BDB02,$CBCA4901,$59CA5A49,$02027C03,$02020202,$02CB035A,$CA5ACA49,$02010203,$0201BBFC,$0259D802,$E8594901,$0202D859,$01590202,$02020249,$0259D802,$02020202,$02020202,$D8025A02,$D8019859,$0159D801,$8858E801,$025A0201,$5959D859,$484802D8,$01E80101,$02020201,$01010202,$0102025A,$01010101,$02020259,$02CB03CB,$CB034902,$02030202,$02025902
        long $59030202,$0302FC02,$0204049C,$59490202,$49CA4901,$021B025A,$02CB5A5A,$CB02025A,$CB020202,$02020149,$CB030303,$995959D8,$9901025A,$02020202,$02020202,$5A5A0202,$010102CB,$99010101,$CA5A0258,$02990101,$02020202,$01010202,$01590202,$02599848,$58010202,$02015902,$01590202,$02020259,$CB5A0202,$021BCA02,$025AEB49,$020259D8,$0C03CB02,$DC490202,$025ACC5C,$59020259,$59025902,$59AB0202,$02020202,$CB5A0202,$5ACA5A02,$02DB015A,$ECECCCCB,$49E8595A,$014902CB,$02020259,$02020202,$02029949,$7B02CA5A,$CB590202,$03CB0259,$59020202,$02020202,$59010202,$020259D8,$01010101,$D8BB0201,$0101E888,$01020299,$02020248,$5902DB02,$02025A02,$02027B02,$0202CB01
        long $035B5A02,$030103EC,$025902DC,$02495902,$CA020249,$CBCA5903,$0203CA02,$5B02D859,$02025A02,$010202CA,$5BCB5A49,$CC02CB02,$CBCA02CB,$02020201,$02020202,$02DA03CA,$025902CB,$5A020202,$038B0102,$01030202,$02020259,$01019902,$49CA5A01,$01010101,$5B4CEC01,$01018802,$99020201,$02595901,$02020202,$02025AD8,$02020202,$1B030259,$035A0259,$5902035B,$49020201,$010102DA,$02494901,$02595902,$03EC6C02,$5A01BB5A,$5ACB5ACB,$5ACBCB02,$025ACBCB,$03DB5A02,$02020303,$02CA5902,$5A025959,$02010203,$02D8025A,$CBD85902,$59D8015A,$CA025902,$02020259,$59590202,$CB5A1B02,$01015902,$02590201,$014801CB,$02595901,$0303DACA,$59015902,$02020202,$02020201,$5A030259
        long $1BCB0299,$CB025BDB,$0203DC02,$02CB5A02,$59020101,$CACBDA02,$025ACA59,$5901025A,$025ACA5B,$CBCB0202,$02DC0303,$6C5B0202,$1B5959CB,$5A5A0202,$020102CA,$02020259,$02025902,$020102CA,$010202CB,$0201D802,$E859D859,$01D85B59,$02490101,$59990202,$02020202,$01880259,$02485898,$03035A5A,$CA5902DB,$029902CB,$D8025901,$CBCB0102,$025A0202,$5ABB0259,$CA030302,$0302CA59,$02595903,$6C5B0302,$49590149,$01CB1B02,$02025ACA,$025A5A02,$02CB035A,$49480203,$5A020202,$DA03CB8B,$0102025A,$CB8B0202,$035ACA5A,$0201025A,$5A020202,$02CB4902,$59010199,$0101DA59,$0159D801,$DA49D859,$02020202,$0102CA59,$02D80148,$5ADA5A02,$8B020203,$02CA5A5A,$02010102,$02490202
        long $59CB025A,$495B0259,$595A0248,$4C5A0202,$02494904,$03035A02,$02024902,$595BCA49,$CBCA5A02,$02CACB59,$02020259,$59024949,$02020302,$02020259,$0102CB02,$CB5A5902,$01591B59,$01590202,$BB5A0202,$5B020203,$029949DB,$015902D8,$02010102,$02CB0202,$0202CA5A,$CBCB5BCA,$995A0259,$5A020202,$CA020102,$025A8BCB,$CB5ACBAB,$5A02025A,$02035ACA,$02D859CA,$59D80159,$02CB03DA,$5959595B,$5A02D802,$02020203,$02025949,$5902CB02,$025902DB,$5BCB59CA,$02D8025A,$03CB0202,$590201CA,$D8020202,$02590203,$02029901,$59990201,$CB020159,$5A0259CB,$01025902,$CBCA5A59,$CA59015A,$CB025901,$02010202,$CA5ACB5B,$02CB9902,$01590201,$02590102,$5ACB8B02,$02CB03BB,$DB020202
        long $0203CA49,$49595A5A,$DA5A5B02,$CB03BB5A,$59D859E8,$02CB5959,$49494902,$02BB0201,$02025ACB,$02590202,$02020202,$02590202,$035B4959,$590259DB,$59590202,$01DBCBCB,$CA020249,$01020259,$02010302,$59010203,$020202D8,$5959DA02,$5A0202D8,$590148CA,$02010101,$02BB5A5A,$02495959,$020202CA,$02890199,$03035ACA,$8BBB035B,$025A02CA,$02020202,$02020202,$5A020249,$CBCB02CB,$01015902,$5BBB5AD8,$59594902,$59020202,$0302025A,$02035A02,$02024959,$CA5B5AD8,$0101D85A,$01D80249,$025959E8,$CB5B035A,$02024902,$025A0202,$02025999,$0159CB5A,$CA020202,$02015902,$DCCCCC02,$E801028B,$48010259,$59BBCB02,$CA0102CA,$5ACA595A,$02010102,$5ACB0202,$030303CB,$0202CA5B
        long $01590202,$5A020202,$D84902DB,$02020202,$5ADB025A,$025A028B,$02CA0202,$02CB03BB,$0202CB02,$020302DB,$CB5BCB02,$02CA5A59,$595902CB,$5B010202,$5802CB02,$CC0202D8,$02020203,$DB5ACA02,$BC02D81B,$02020202,$02020202,$02020202,$030303CB,$590202CB,$01D80202,$01025901,$5A015959,$CB020102,$5999018B,$02598902,$03030202,$02025A9C,$5B025959,$03DA0259,$0259DC03,$CC0299AB,$ECCB025A,$030201CB,$CB0202CB,$CA7BCBBB,$025C1B59,$59594902,$03025902,$02025902,$02024902,$027C0201,$0102021B,$035A5901,$025A0202,$02CB0202,$BB02025A,$01CB5902,$02020202,$02020202,$02CA7B02,$D8020202,$0202D801,$5901E801,$390249E8,$02024902,$99590102,$6A898901,$5B020202,$029902DB
        long $030201DB,$033C0201,$03025902,$5A49DC03,$5B020202,$020202BB,$59CC5B5A,$CB490101,$02030202,$BBCB0259,$01010202,$0101597B,$59CA4959,$015A0259,$01025901,$CA02CA5A,$0202D859,$02025901,$0202CBCB,$01CB025A,$59025902,$01010202,$02025999,$025A0259,$CB5A0202,$01590101,$02395959,$CB590202,$02985903,$98598959,$0202597A,$8B59027A,$02030203,$01595902,$CBCB0201,$0101035A,$BB5A0202,$01020202,$CA5A0202,$0CCB5959,$8C0201EC,$CB0299EC,$019C0303,$02020202,$0203DB5A,$CA035AD8,$49590102,$5A025ACA,$02020202,$59590202,$5B1B5ACB,$5B03CBDB,$02020202,$990202CB,$9959D801,$CB490202,$CB5A0202,$49015902,$4902E801,$5BD85B49,$0101EC04,$59890198,$79995989,$029A7959
        long $02020202,$02CB59CA,$025ACB59,$DCCB0202,$03CCDB03,$0102EC03,$CB030201,$4C5CCB5B,$0259CBEC,$02CA5ACB,$02025A5B,$CA5A8A02,$DA5A025A,$5ACB0259,$02BBCB59,$CBCA025A,$025A5BCB,$0203DA02,$CB5ADB5B,$DB49025B,$0304FC0C,$0202CB02,$02020249,$030249CB,$01020203,$5959CBCB,$49015949,$59490202,$58017CFC,$79015888,$01019A59,$02025958,$03CB49CB,$595B5902,$02025A01,$035C0202,$03030303,$8B025A03,$02594902,$03EC0349,$59CA5A5B,$5A5B5A49,$02020202,$034CDB02,$5B4C0302,$59590202,$020203CA,$02020159,$5BCBCA59,$CA5A02CB,$0303DC5B,$025902DB,$EC034CFC,$0202496C,$CB0202CA,$FC0202CB,$0202CB5C,$02DB5B02,$01490202,$48D85901,$01025901,$58787858,$59895901,$0289897A
        long $CB5A0202,$DB02DA5B,$02020202,$1CEC0259,$031C03EC,$BB8B01DB,$5902CBBB,$5BCB4901,$025902CA,$CA0202CB,$59020202,$035B4902,$0203DA02,$CBBC0303,$5B590202,$020202CA,$CB490202,$5A02021B,$031C1CDB,$CB59025A,$ECECFC04,$CBCB0203,$5B025A5A,$5A59D88B,$9949BBCB,$CB5B0259,$59CBDC02,$01015949,$02020202,$59E80101,$02595999,$597A027A,$5ADB5A01,$5B1B5A5B,$0201025C,$035CCB01,$EC5C1C03,$8BCB0203,$CABB038B,$02595902,$5A020202,$5A49CB5C,$0102CB02,$02020202,$59014949,$5CDC0302,$0201015A,$02CB025A,$0203035A,$02020249,$02035C1B,$5B49CA02,$7CEC5C0C,$02025A02,$CB02CA5B,$02035BDC,$01020201,$5B020102,$59025B02,$020159E8,$5A5A0201,$98020259,$8A010149,$027A025A
        long $025A0202,$02030302,$020249DB,$5CDC5BCB,$03DC4CEC,$59025903,$01019902,$02CA0259,$EB020202,$DB59490C,$025B025B,$02025902,$01025B02,$CC4CCB02,$01010203,$BC025901,$5A025902,$59CB0299,$0202CB02,$DB025A02,$025CEC04,$02020201,$02BB0202,$CB04025A,$01490202,$59990101,$8A0202E8,$01D80259,$02010198,$01595ACB,$5A01D802,$027A7A8A,$5ADA5B02,$5B03CBCB,$5ACB5A5B,$02025902,$0C0C03CB,$99020103,$49010159,$5B02CB02,$5A495A03,$03020103,$02CB5A02,$59025949,$01020249,$031B5A02,$014859CB,$5A0159D8,$020102DC,$59595949,$59025901,$5902CA02,$0202DC03,$02590203,$02020202,$0202E802,$0202031B,$02030302,$59595A02,$0202028A,$01025901,$02D80202,$01890202,$028A5A59
        long $49025902,$02CB0259,$025C0202,$0148E801,$02025959,$03590102,$595902CB,$CB5A5A02,$0102BB5A,$5B0259D8,$035ADACB,$02CBCB02,$02025901,$5A8BCA59,$02020249,$0202CA5A,$49590202,$02E80102,$CA490159,$59CA0202,$02020249,$03010202,$02024903,$020102BB,$0202CC7C,$03CB5B02,$5902CA02,$01590202,$018B0302,$02025901,$01590202,$02020298,$03020203,$5B5B5B1C,$02CBCB02,$01010102,$01590102,$03020259,$0102DA3C,$025ACA49,$8B5ACB5A,$CB02CB02,$03CB5ACB,$02025903,$CC59025A,$02020202,$0202CCCB,$CB020202,$E9020102,$015ACA49,$1B0202D8,$0202025A,$CB02DACB,$025ACA5B,$02020202,$0359035A,$CB03EC5C,$02025902,$01020101,$01598A02,$01590201,$5A8B0101,$5A020202,$6C010102
        long $031B5ACB,$DA025B4B,$1B5ACB02,$02490202,$02020202,$02010202,$590202CB,$02020202,$CB02025A,$5A02035A,$1B5BCB5A,$037C0202,$5902ECDC,$02494959,$02595B02,$02590201,$0101D802,$0204FCBC,$0249CB02,$FC5B0202,$CB025A4C,$5A0202CB,$030303CB,$CB025ACA,$026C03CB,$59020202,$02485801,$5A8A5A8A,$59D85859,$CB020101,$02020202,$03CB5A02,$CB590202,$5B020202,$BC5A0201,$02025A03,$02BB025A,$0202495A,$02025902,$02027B01,$02010202,$025ACB02,$02CB5ACA,$CB030202,$02DCEC5A,$4902CBD8,$01010202,$02020102,$595A5A02,$BBCB03CB,$02025A5A,$035BCB5A,$5959CB03,$BBCB0102,$5ACA5A02,$5A018B03,$035A5A03,$CA0202BC,$02889802,$8A027A6B,$D8025A8B,$02010202,$EB5A5A8B,$5BCB025A
        long $0102CC03,$02495949,$02020202,$5949EC03,$02020202,$020202DA,$CB5ACB1B,$99595901,$02CB0259,$025959CA,$02025949,$03020203,$6CDC5BCB,$03CB0259,$59E859EB,$02995999,$03DBCB49,$CB495901,$5BCB5ACB,$03035BDA,$0202CB5B,$025902CB,$0202CB5B,$010103CB,$CB020202,$5999025A,$5978E802,$5A8A5A8A,$59029B02,$48990202,$5A020259,$0202CA7B,$5A5ACB02,$8BDA5949,$02020302,$02025B02,$5A0249E8,$02021B5B,$CB495902,$DB030202,$020202CB,$CA020249,$025AD85A,$DB495A5A,$034C035B,$CB020202,$0159015C,$0259E959,$5ACB5A02,$5A020202,$1B5ADA5A,$0303035A,$CB4C03DB,$4902CB02,$03594902,$58590202,$01010102,$0259D801,$8A014801,$5A8A6B5A,$99025A7B,$02020299,$CB0201D8,$02028BCA
        long $CA595A03,$0303CA02,$02499959,$03020259,$0202595A,$025BCA02,$02025ACB,$4CFCCB59,$02025C03,$030BDBCB,$025ACB49,$010202CA,$59025901,$02590201,$D801595B,$02D85959,$020202CB,$CB020101,$5ACB5A02,$2CEC03CB,$02CB595B,$02010159,$02CBCB02,$CBCA0159,$CB020303,$48595902,$59020201,$7B5A8A8A,$0159CB5A,$0202E859,$8BCA5959,$0303CB03,$5ADB0202,$DB5B5C03,$03030259,$03DCCCEB,$49024903,$CA025B03,$CBCBEB03,$CB020259,$4903EC03,$03DB5B02,$02CA5ADA,$02CB0202,$02020202,$03CA49DB,$010101DB,$02010101,$014901CB,$59480102,$03CB0202,$CB5B5B03,$02590102,$025A5BCB,$02035A59,$03BB5A02,$5959037C,$59D80202,$59595A89,$02025A8B,$02D85999,$02595848,$CB029959,$DB5B025B
        long $035B4902,$02030303,$03CB5902,$03035B03,$0202021C,$49020302,$035B5B03,$5B4902CB,$011C0C4C,$5B1BCB01,$02BB02CB,$02020202,$02024902,$0302025B,$0259CA6C,$0202CA02,$59CAEC5A,$48994902,$5B024901,$025B0203,$03CB0202,$7CDBDA5A,$020202D8,$0303CBCB,$E859CA5B,$59025902,$59895901,$0289025A,$02015902,$59010202,$CB5902E8,$5B59CACB,$DA020302,$5902DB5B,$CB020102,$0303EB03,$024949CB,$59494902,$03030303,$5AD85A03,$49ECFCFC,$DA5A0201,$CC035A49,$DB5ADB5B,$03CBCB5B,$035A0303,$02CB5A03,$CA5B5B02,$49025B02,$490202D8,$01010101,$02015959,$4B035902,$5B5B5BDB,$5A994902,$5B5B5A5A,$99025ADA,$49D80159,$02595999,$02027B02,$028B0202,$02CA5ACA,$CB599901,$02035A5B
        long $5949DC5B,$CB5ACB02,$CB5A03EC,$03036C03,$CA025949,$0159CB5B,$030303CB,$02010203,$5A5B6CEC,$CB0249D8,$03030302,$DC02595A,$03030303,$0303DC03,$CB020203,$49CBCBCB,$02E80202,$02025902,$02025901,$01D802CA,$03030259,$02030303,$0201CBCB,$1BCA0202,$02025A02,$59010149,$59990202,$0202028B,$02CB5ACB,$5BCB595A,$02025959,$0302CB03,$015903CB,$03490259,$5A02EC5C,$1BDC035A,$025BCBCA,$02EC0302,$02CB0349,$5902025A,$59E84902,$59010149,$CBCB03DB,$030202CA,$03030303,$CB590303,$CB5A0203,$02025ACB,$59010102,$02020202,$CB5A0201,$015B035A,$034BCBE8,$CB1B0303,$0202CB5B,$8B025901,$020303CA,$01010102,$59595901,$03CB02CB,$0259025B,$CB020102,$5A9901CA,$025A02CB
        long $02025A01,$02020101,$D8015A5A,$59020259,$02030249,$024C5C59,$01015901,$02CA0202,$DA5A0202,$02025902,$5B03CB5B,$035959CB,$03030CFC,$5959DC1C,$5ACBCA02,$02010101,$0101025A,$02025901,$5ACA0201,$03BB5ADA,$5ACB5A02,$4901CB1B,$02015902,$5959D859,$CB5ACB02,$7B020201,$CB02E802,$5A5A4959,$01028BDA,$02990102,$5A010102,$02030202,$5A02025A,$5ACC6C02,$025B0202,$CB590159,$03030202,$FCEC03CB,$CB025902,$01020202,$5ACA5A59,$0302E802,$CB035BDB,$5902025B,$FCEC0301,$0202034C,$59025A02,$0202CBCA,$485902CB,$0259D859,$5A5A0201,$02CB5ACB,$CA020259,$0259015A,$59590202,$0259CB02,$02025A02,$02020202,$5A020102,$99D80159,$0303CB59,$020102CB,$02590202,$CB5B03DC
        long $02494902,$02CB5A49,$0202CB02,$02020202,$5AFC0302,$5C035A02,$0202025B,$59025902,$5A0202D8,$03CC0202,$037C0303,$02020202,$02595901,$DC035A02,$CA020202,$02DC035B,$02DC0302,$59010101,$5A025801,$0102025A,$025ACA59,$02490259,$CA590202,$CB0203CB,$5902CB5A,$59020202,$02020198,$02020202,$8B030259,$025BBB5B,$5ACBAB5A,$02CB02EC,$49595902,$020258E8,$5A1B0259,$035BCB02,$02CB5BCB,$035BDA5A,$02024902,$59CBCB02,$02590101,$5A010102,$CB0303CB,$49020201,$025ADBCB,$0C0C0C02,$CB020159,$02CBCBCB,$03CBCB02,$02014802,$CA010102,$CB02CA5A,$02020159,$49020101,$03030202,$5A0202BB,$CA7C03CB,$01029959,$02020249,$018B02CB,$CA5ACB02,$0202CB5A,$CBCB5902,$0202495B
        long $5B020202,$02025ACB,$035ACA02,$5CDC1C03,$0202021C,$0202495A,$02590202,$5BEC03CB,$0102CA02,$02020202,$49010149,$0102DB5B,$02CB0201,$036CECDC,$CB02021B,$03BB5B5A,$CB5B0202,$020202DB,$0102CB02,$030203CB,$CB0249BB,$59010103,$5A020149,$035959CB,$02021B5B,$02025B02,$CB020202,$0102015A,$5BCB5A02,$01BB5ACB,$02015902,$02020202,$DCCC7CCB,$CBCCECCC,$1CDB0203,$03035B02,$03025B0C,$49010102,$03020202,$0303CBCB,$035A015A,$035A02CB,$02015A03,$DB030302,$025A0201,$1B02CB5A,$5B0303CB,$03CBCA02,$02025902,$5901025B,$59594949,$025A035B,$5B03CC5C,$E8CBEC03,$02020102,$DA024802,$01015902,$02990202,$02020259,$590101CB,$CB5BCA02,$5A03025B,$49CA0201,$035A0299
        long $6C03DB5A,$02036C03,$6C594902,$1B030202,$5B49CB03,$04CB4902,$03021B03,$03030303,$CB025902,$03DA025A,$01CBDC03,$5B030202,$59030CCB,$CB5B4CDA,$0BDB035A,$5B5B025A,$CA0259BB,$49495902,$02D859D8,$CBCBCB02,$02035ACB,$02040402,$5BCB0202,$0259025A,$02025A02,$02020259,$02020202,$0101027B,$5BBB5B02,$CCCB02CB,$015902BB,$5BCA0202,$0303CB02,$02030303,$5902CB02,$5A5A5949,$03DB5B5B,$035B0249,$0302595C,$02030303,$02010249,$035BCB02,$01030303,$02020259,$02CB7C5B,$5B02EC4C,$CB5B1BDB,$CB8B02DB,$495ACB5B,$4949D802,$5A020101,$CB5A5ACB,$0303025B,$03030249,$CA5B020C,$0101CB5A,$59020259,$02020299,$9A5A8BCA,$017BCB5A,$59590202,$03030202,$9902027C,$025A0249
        long $0303035B,$5ADA5CCC,$D803035B,$02020202,$030303DA,$5B03DB02,$5B020203,$025A03CB,$01010249,$5B020249,$0103DCDB,$48E80101,$03024959,$DB49DC5C,$5BDB5B5B,$CB49595A,$DBECCB5B,$0159025B,$02DA0202,$5A1BCA5A,$CBCB5ADA,$EC5901CB,$CB5A591C,$02025A5A,$0202CA02,$02020202,$DBCB5B5A,$02CB02BB,$D8995901,$03CB5A59,$59CB0103,$5A020202,$CC03CB59,$DC030303,$5BFC0202,$0202DB5A,$03030303,$DB030302,$CA025A03,$0202025A,$03CB0202,$CB5A0202,$49DA5B5A,$49020259,$020259D8,$03590202,$1B030B5B,$5A5902CB,$03035B02,$DB030303,$5B5A0303,$CB5ACB5A,$5ACBCB5B,$5BE8034C,$5B020203,$5A02DBCB,$01025CDC,$8B027B02,$035BDA5A,$0202025A,$AC5BCA02,$5A020202,$59020102,$020202D8
        long $5A025ACB,$04040C03,$035C0203,$49025B02,$5A035B03,$5B035B02,$5949025A,$4902DA02,$5B020102,$5AD85AEB,$025A0202,$020202E8,$02020202,$0301CB02,$030202CB,$01DB032C,$03035BDA,$03030303,$0202CA5B,$03DB5BCA,$0249CB03,$024902CB,$02590202,$CA5ACB5A,$0159CB03,$028B0202,$CB03CB5A,$59030202,$5A020202,$8B025A8B,$010101CB,$02025959,$0C0C0303,$040C4C1C,$025B1C04,$0203DA02,$0203DB59,$025A0202,$0202DA02,$CC030302,$0202CB03,$DB5A035A,$59010102,$02025A59,$02590102,$02015902,$035B0259,$022C5B5B,$03030302,$CBCB5BDB,$0202025B,$5A020259,$0CCB5ACB,$49590203,$02010101,$59025A02,$02030202,$5ACB0201,$02035ACA,$01CB5999,$027B5A02,$5A02CA5A,$01D85A03,$03CA0101
        long $040C030C,$0C0C040C,$CB1BCC04,$031B025A,$02020202,$DA02DA5A,$EC0C5C03,$CB5A5B02,$02035B5A,$030202CA,$59E8020C,$02020202,$BB7B0259,$0102CB03,$1B031B59,$02031B03,$DB030359,$5B1BCB5B,$CB0203CB,$49010102,$0C031CDB,$01590203,$01484849,$02494901,$03025949,$DB020199,$0202CB5A,$48010202,$5ACACB59,$02BB5BCB,$0159CB7B,$5A8B0202,$FC0C4CEC,$040C0C0C,$015AFC04,$5A5ACB02,$030202CB,$5C5B49CC,$ECCC0303,$5BDA0203,$01DB0303,$02585959,$59010303,$590202DA,$8BDA5A02,$CB038B03,$5B5A0202,$02025B1B,$5B03DB59,$5ACB5BCB,$010102CB,$CB590199,$4C4C5C03,$03FC1B5B,$02025901,$49020159,$02013902,$010102CB,$01015901,$49020249,$5A5ACB01,$8BCB5B5A,$CA5ACB5A,$02020159
        long $4C0C0C5C,$4C040404,$02030C04,$5ACA1B02,$02595BDA,$CC0202CB,$5CDC0303,$021B5BEC,$5B030302,$01025ACB,$48010302,$02020202,$5A5ACA02,$035A03BB,$020259CB,$59020202,$DB5CCBE8,$5ACB0303,$CB0259CA,$02025BCB,$FCFC0C5B,$04FCCB5A,$EC0349DB,$02490202,$02490249,$01025A5B,$035A0201,$020259CB,$02CB5A59,$5A020202,$028B02CB,$595BDB02,$0CFCEC5A,$040C4C04,$EC0C4C0C,$5A5A0249,$59CBDA5A,$CB029902,$0303035C,$595958CB,$03CB5901,$ECECECCC,$0149025A,$D8015901,$CA027B5A,$5ABB035A,$020202CC,$FC1CDB02,$02CB5902,$CB015902,$037CCC03,$02CCEC03,$4CDC5B02,$030C5CDA,$4CCB02EC,$49490203,$F8490249,$025A0202,$1CCA0201,$025903EC,$CA7B0201,$025A8B5A,$02015903,$01CA0202
        long $4C030249,$041C0C4C,$025ADB0C,$CA025A99,$02CB5A02,$0201020C,$030303CB,$02020202,$02594902,$5CEC035A,$02CA04FC,$59020202,$028BCACB,$03BB5ACA,$1CCB5A03,$4C5B032C,$020159FC,$02010259,$03030303,$8B030303,$02020101,$0CFC4C49,$5C1B025C,$02F8CB1C,$49490202,$03020101,$035A020C,$FCDC0303,$02025AEC,$02BBBB02,$020202CB,$02020202,$FC025959,$4B031C4C,$01023C0C,$025A0259,$59020202,$025C6C02,$EC03CB02,$02020202,$02020202,$5A025902,$025CCB02,$9902CB03,$8B5A5ACB,$035ACB5A,$03020203,$0CCB4BDC,$CA02DA4C,$59020302,$0303CB02,$CA036C03,$9A038B02,$04ECDC02,$CB0202EC,$49495A03,$59E849F8,$0B024902,$0302CB03,$CB03025A,$028BEC6C,$8B5A0202,$02020202,$027B0202
        long $0202DB5A,$EC0CEC5C,$DB5B035C,$0259D849,$49E85901,$02DC5902,$03030202,$02020202,$02020102,$02020202,$03CB5ACA,$49025A03,$5ACA8B02,$8B5A02CB,$030201BB,$5BDB034B,$03025AEC,$010CFC03,$CB5A0202,$02CA5ACB,$CBCBCB02,$CB5BCB5A,$5A02025A,$0101025B,$01591B02,$5B01E802,$CB595A03,$5A0202DC,$59CB0302,$CA025999,$028A0202,$02029902,$49595ACB,$03BB0259,$03490203,$0259025B,$DB03030C,$CB020202,$02020202,$02020202,$02025949,$02020202,$5A020202,$5902CBCB,$CB5B02CA,$02CA8B5A,$02010159,$5C1B0303,$02020203,$01CB0349,$02020201,$01590202,$5ACB8B02,$5A0201CB,$03DA4902,$1B020259,$DA048C03,$02025A01,$49020202,$1C02BBDB,$0C0303DC,$0159CBDC,$99595901,$99010102
        long $03025B02,$024902CB,$4902035B,$CB1B5A02,$0C0C4CEC,$BB020202,$5A025902,$49024902,$CB03DA02,$02020202,$D8020202,$59CA5A02,$5A025A5A,$49025ACA,$594902CB,$5B5A0201,$0203021B,$02014802,$01580102,$59020201,$CB03CB01,$FCEC0202,$5A5A01DB,$59020202,$5C03CB02,$0303CB02,$5A020203,$03030202,$5CEC0C03,$CBECECEC,$01020102,$034802DB,$02DB025A,$0203CC5B,$030302DB,$025ADCEB,$5B5C035B,$02020202,$CBCBCB02,$5901015A,$ECFC5C03,$5999CB03,$59025902,$01025902,$9A02CA02,$5B015902,$02DB1C03,$02E80149,$49020259,$03DB0202,$0203ECCC,$CB030302,$5ACB5B01,$CCCC5A01,$02590103,$01590202,$02020249,$5A020202,$DA5BDC03,$1B025902,$EC0CEC5B,$5BEC5BDC,$4802CA02,$4C580202
        long $5A030202,$02EC5BCA,$DC035B02,$CA5AEC4C,$49035B02,$CC5C0302,$4B030303,$D859CBEC,$FCECCC03,$CB0C4C4C,$CB03CA59,$5902CA02,$59020101,$5AD80102,$035A5BDB,$490102DC,$DA490102,$03030303,$CC0C0303,$03035B02,$0202D859,$03DB0202,$02020202,$02020202,$595ACB02,$02020202,$0202CB02,$02025902,$036C5A02,$025A5A5B,$01025A02,$02585958,$0202021B,$5B03CA5A,$0303DB59,$59CB4CEC,$02020202,$0C0303CB,$03025B2C,$595B0C03,$8C8C4C02,$CB5CECEC,$5A5A0259,$CBCB5A5A,$CBCB5902,$02025B03,$035BDA5A,$DB02035B,$03CB021B,$03030303,$5C031C03,$024901DB,$BBCB5A5A,$02020102,$5A020202,$02020202,$02CBCB02,$02CA0202,$02020202,$0202015A,$5A020202,$027A0202,$59897A59,$02995998
        long $0249DC03,$0CCB5B1B,$CC030202,$025BEC6C,$49594902,$1C1C5C5B,$1B02DB03,$59DA2C03,$6C040359,$0202CB03,$CA020202,$5B5ACB5A,$0202CB5C,$1B0202CB,$5BDA5A02,$49025BDB,$03035B02,$1CDC0303,$0303DC03,$DA5A0203,$5A5ACB02,$01025A03,$02CA0201,$02020202,$7B025A5A,$01020202,$03030299,$025901CB,$027A5902,$7A59597A,$59595959,$03025989,$02CCFC5A,$5C5BCB7B,$CB024803,$02DB035B,$0202DA5A,$030303DB,$CB1B5B5B,$0202035B,$DA5B0201,$5A02025A,$5A020202,$02CB5B02,$020103CB,$CB020102,$5ACB1B8B,$5902CB1B,$1C03DB02,$03031C03,$DC0303DC,$02CB1B5A,$CACB5B5B,$025B5A02,$02590158,$CA020202,$CB1BCA5A,$5A020102,$038B5ACB,$5A0259BB,$5A025A7A,$597A0259,$7A597A02,$59795959
        long $02025901,$03025A02,$590102FC,$5B5B0302,$021C4BCB,$03035B02,$5BCB0303,$02595B03,$02020102,$02CB025A,$5BCA5A02,$CB025ADA,$0102035B,$5B015901,$CB5BCB03,$02DB5ACB,$035BCB02,$03030303,$CB0303DB,$0202025A,$5A5A0203,$0402025A,$590202EC,$02020202,$02020202,$BBCB8B7B,$03CB035B,$597A02BB,$59027A5A,$7A59597A,$59595959,$01897959,$027A0179,$03CB0202,$5902DA5C,$02CB0202,$1CDC0303,$1B025902,$DB5A1BCB,$03CA0202,$010203CC,$025A0202,$DA5A0202,$1B5BCB5A,$5B025ACB,$E8010202,$5B020202,$025A0303,$03DB0259,$5BDB5BDB,$0202CB5A,$49025ACB,$CBDACBCB,$030302DB,$02CB5B4C,$02029A02,$02020202,$CB5A0202,$5A5A5A5A,$7A020159,$597A0259,$59027A59,$597A027A,$89595979
        long $7A990202,$035B0202,$CB595903,$025BDB4C,$03030303,$49024903,$59020201,$4C035901,$CB7CCCEC,$02020102,$02020202,$5A02025A,$DB4902CB,$0303DC02,$02DB0303,$CBCB4902,$1B5A0201,$5B1BCB5B,$02025BDA,$5902CB03,$5B5A5B59,$4C03025B,$025B03FC,$02025A02,$028B0202,$02027B01,$02CACB02,$025A8959,$7A02597A,$5A595A59,$02025902,$02027A99,$59025A5A,$CB020202,$CCCB4902,$59025AFC,$49024902,$5A020202,$BB5A5902,$EC0202CB,$ECCC5CCC,$0302CA5B,$0203030C,$01590101,$02CA0202,$CB5A0249,$034CDC03,$5902CACB,$8BCA0101,$CA5A1B5A,$0202025B,$01CA5B03,$02025901,$DA5BCBDB,$59030259,$0259D859,$02020202,$BB5A0201,$0202025A,$7A020102,$5A7A5A59,$027A5902,$7A7A027A,$02025959
        long $8A5A8A02,$0202025A,$4C02CB02,$0203CB7C,$59590101,$5BDA0249,$5AD80202,$5A010203,$ECECFCEC,$030249CB,$EC5B0303,$01590202,$03035B02,$02DA5902,$7C03035A,$02495BEC,$49010101,$5ACA0202,$020C0202,$0159CB02,$5BCA5901,$03EB5C03,$49020259,$02025959,$02020259,$5BCA59CA,$02015ACB,$59590101,$5902597A,$5A49027A,$59025A59,$7A595A02,$49020259,$03BB5A02,$03DB0303,$49020203,$D8020259,$02020202,$995902DA,$9901025A,$6CEC5CCB,$CA02CB02,$03030303,$0202025A,$0303DA5A,$02595903,$CBCB5ACA,$02027B03,$59590202,$59010201,$495CEC02,$01025B5A,$CA5A0201,$03BBCBCA,$DC030202,$0203ECEC,$0202CB59,$02020101,$02020202,$59010102,$5A597A49,$7A5A5A59,$5A597A02,$59027A59
        long $49020101,$5B4903DA,$035B0CEC,$02025902,$59020202,$02024901,$4901495A,$02CBCA99,$5A020201,$5959CACB,$CBEC031B,$015A0202,$5BDB5BCB,$5902CBDB,$0202CA02,$CA020202,$DB5A025A,$0103DC02,$498B0302,$5BCB1BCB,$5A020202,$02CB5A02,$5BDB5C03,$49024C03,$027B4902,$02020202,$028B0249,$01010202,$5A7A5901,$02027A5A,$597A025A,$0189597A,$49490159,$EB020C3C,$03CC5CEC,$CA025902,$02025902,$02020259,$02CB0349,$02CB03CB,$EC020101,$D8020303,$02020299,$59CB0202,$DB5BDA02,$025ACB5B,$59020202,$5A020299,$8B5A8B5A,$02FC5A03,$02490202,$1B5A5ACB,$0202CB5A,$030202CA,$DA5B0303,$E8020C5A,$7BCA0259,$8B8B8BAB,$CA020202,$02027B5A,$01015901,$5A020259,$02020259,$49010159
        long $59015902,$01590259,$5ACB03CB,$020101DA,$02D8025B,$5B9959D8,$02030302,$0202CB02,$CCECCB02,$02CB03BB,$59011B02,$99020202,$CB024901,$03CB02CB,$0202595A,$5A8B5A02,$5BCA5BCA,$5CEB5902,$CB025902,$02CB5A5A,$49035A5A,$03CB5901,$5B5BDA5B,$5ACB5CCB,$02029902,$CA027B02,$5A02025A,$0203DA5A,$02010159,$88580101,$02010101,$4949597B,$02020202,$01495902,$02020248,$5901025A,$02020202,$DA49D859,$01020302,$CA025901,$035CCB5A,$1B598BBB,$99028B5A,$025A0259,$59015901,$CB1B0202,$010103EC,$5BCA0259,$49020202,$0C020102,$1B5A0202,$5A5A5ACB,$CB5A5ACA,$CB5B0201,$5ACB5A5B,$02DA5B02,$02020102,$5A020202,$CB010202,$02035B5B,$02025959,$01010102,$02590159,$0159E801
        long $CA5A0202,$5BCBDB02,$5B5B4959,$590249CA,$027A5A59,$4902027B,$5A020249,$5BBB4902,$034C49CB,$5A02EC03,$020202CA,$BB020202,$01CA5AD8,$5B025ACB,$48CB5C03,$02020201,$59590202,$CB590202,$02CB0259,$0202CB5A,$5B02CA5A,$031B0302,$02CB5BCB,$025B0249,$9A599859,$CA020202,$5901029A,$595ADCCB,$010102D8,$01590202,$02024901,$59E859CB,$03DB5ACB,$CB5B03CB,$1BCB5BDB,$5902025A,$02010203,$01025999,$EC4C5A02,$5A020203,$FC0301CB,$DB0202CB,$DB5A4902,$5ACA5ADB,$010CFC03,$CB5B0259,$02FCEC03,$5A020159,$DB02495A,$1B590203,$5A5A4902,$5A0202CB,$5A02025A,$035B0302,$025A0203,$02030202,$99010202,$02020202,$02CA0202,$02020259,$49595A5A,$5ACA4902,$49020101,$02025B02
        long $5B020249,$5A5A035A,$021B5B5B,$02020202,$01CBCBCA,$CB5A0201,$02020201,$D8595ACB,$01020259,$02020202,$03DB0202,$02031C5B,$02CB5C03,$03020202,$025B032C,$59020303,$1B0202E9,$DB025A03,$02E8025A,$025B5A1B,$025A02CA,$5BCB0259,$5ACB1B5B,$03035B02,$0101ECFC,$02029959,$5A020102,$7BCBCB9A,$5AD859CA,$1B5B0202,$02490101,$021B0202,$021C0C03,$BBCBBB02,$02020202,$1C03CB02,$5A5CCB5B,$5BCBCA49,$59020101,$5A5BDA49,$025A0202,$02595ACB,$0303025A,$015B0C0B,$02025BDA,$02595ACB,$02020202,$021BDA5A,$5B020202,$CB49CB03,$59015ADB,$02025A02,$02010159,$02025902,$CB025A5A,$0C03021B,$025CEC5C,$5A024901,$CA5902CB,$5ACA5A5A,$020202CB,$59020202,$02590159,$CB5A5A02
        long $030CEC4C,$5BCB5A5A,$5B020303,$CB03CB02,$8BDC0303,$CB035B01,$01595ACA,$1B025A02,$02DB49CB,$5ACA0249,$031BCB02,$5949FC03,$02020259,$03CA0202,$021B025A,$02014902,$5B020202,$02010203,$01015902,$01590201,$02CB0259,$5A0259CA,$02CB5ACA,$03030102,$5ACC5C03,$CB5ACA02,$5902CA5A,$8B5ACA02,$02030202,$EC034959,$49D8CBEC,$5B020202,$03EC5CCB,$59CBCB5A,$DC035BDA,$03BB02CB,$0102BC9C,$5ACB0201,$49CB035B,$5A5B1B02,$02CB5A02,$025BCB03,$030202CB,$49025C0C,$0202CA02,$5A020202,$025BDBCB,$4902CB02,$01010149,$01030349,$CB020201,$03020159,$CB0303CA,$02DB5A01,$59024902,$5B020159,$D803CBCB,$CB030249,$CB590102,$59CB5A99,$1C5B5A01,$030C4902,$01595C03,$02020202
        long $035C0349,$49020202,$03030202,$7B025A2C,$0102025A,$7B020101,$5ACB5BCA,$02020201,$CB5ACB02,$02025A5A,$02025959,$4902035B,$59590202,$02494959,$1B020249,$5A1B5A1B,$02025902,$CA03DB02,$5BBBBB5A,$5CDA5ACB,$0303035A,$025BDB02,$02010159,$02010102,$01595902,$EC4CCB58,$030259CB,$038CEC1B,$5BEB0201,$03DC0202,$49CB0303,$5A020202,$DC030202,$5BDB5AEC,$0C0303CB,$8802FC8C,$02035901,$5ACA5959,$02027BCB,$0249E859,$5B1C0303,$D8590201,$BB02025A,$02024959,$010202CB,$0259E859,$021B0259,$CB5ADA5A,$0249D802,$02025949,$BB5BCB8B,$CB0303CB,$5BCB0302,$02DA5B03,$CA8BCB5A,$02010303,$02595902,$03035C01,$CBECCC03,$ECDCCC5A,$03CB0202,$03034959,$035C0303,$CBCB028B
        long $03490203,$0249CB03,$035C5C49,$0149025A,$01020101,$CA5ACB59,$02590202,$03595ADB,$5A03DC1C,$599959D8,$02020202,$DB020102,$01015902,$01490149,$1B5B0201,$DA5A0202,$D8025959,$025A0202,$CBCB5B02,$8B03BB5B,$DB030302,$0202035B,$020202CA,$0203038B,$0298E802,$035C0301,$03030303,$EC6C0303,$CB0249EC,$CB020102,$5ADB035B,$0302BB5B,$04CB5B03,$59CB5A0C,$01595949,$59595902,$59595959,$995902D8,$ECCB0202,$0302DCCC,$025A1BCB,$CB025A02,$02490102,$02020202,$02DA0259,$49020159,$021B0201,$5A1B1B5A,$4CFCCA49,$02020202,$CB5B8B02,$CA5BCB5B,$5B5ACA59,$0202EC03,$027B0202,$02CB5ACA,$02598801,$03EC5B01,$03030303,$03DC0303,$5B59CA5C,$5A0201CA,$010203DA,$020303CA
        long $035BCB02,$022C0303,$59020201,$49590202,$02014959,$025A0159,$02025A02,$02595902,$01020202,$025ACBCA,$02020259,$49020202,$FC4BCB59,$CB02DA03,$1B025949,$DB5A5A02,$045C1B59,$D859025C,$CB5ACB02,$01025BCB,$DB025A01,$01590403,$02020202,$01DB5A02,$01015898,$2C03CB01,$5C030303,$EC5CEC03,$02D85ACC,$02010202,$59031B5B,$025A5A02,$5BCB027B,$02035A1B,$DA5A0249,$D8020359,$59010202,$02025901,$02BBCBCB,$02020202,$49025902,$01E97B02,$02020202,$595B0202,$03CB5AE8,$035B5A5C,$02014903,$2CDA02DA,$0CDC5ACB,$59990203,$02CB0202,$0202CA5A,$034CDA01,$59CB035B,$9A590289,$59020202,$48010101,$03CC5A59,$CC030303,$5A020202,$595902CA,$020303CA,$5A030302,$03BB0202
        long $CB025ADB,$5902025A,$5B5B4902,$4902CB59,$59595949,$BB490159,$028B5A02,$59029902,$02020202,$02025901,$02590202,$59020202,$02025959,$5CDB49CB,$0149CBEB,$5B5B0201,$4C030203,$9859025C,$CB5A5A02,$DA5A0202,$02EC5949,$030302DB,$59010159,$D8490202,$98010201,$EC5B0201,$DC031C5C,$02020299,$02CA5A03,$0202495A,$03031C49,$CB020201,$590202CB,$02020202,$DC030202,$5902025C,$D8025902,$02020249,$CA02CA02,$02490259,$5A020202,$5902EBDC,$02020202,$02010202,$49590202,$DCCB0101,$02CB5C03,$03DB5A02,$DC025902,$0189028C,$028BCA59,$02020259,$5ADC02DB,$1B020202,$5902CB5B,$49015902,$4802CB02,$02015959,$028CFC6C,$038B5901,$5C030303,$02030303,$CB0C4C02,$027B0201
        long $0202025A,$5A5B0259,$5B025B02,$5959025A,$5A5A0202,$02595A02,$5A020202,$02024999,$020202D8,$CA5B0C04,$02D80259,$49490202,$CA490249,$5C025902,$5A1B0303,$0202030C,$03025902,$7A59BB03,$02590259,$030148CB,$5A025A03,$7C1B0203,$DB035BCA,$02015A03,$58595BDB,$020259D8,$02CB5A99,$CBCB4902,$03037C5B,$4904FCEC,$49030C02,$59DA0302,$0159025A,$02020202,$02025A5A,$02010149,$02020202,$59020202,$49990202,$02020102,$02590259,$02495B03,$59025959,$02010201,$DB5A1B49,$EC590202,$02CC03DC,$5B031C03,$025902CB,$59020102,$5B8A028A,$4C03027C,$02DBECDC,$035B0203,$035BCB5B,$0201DABC,$59D80202,$01010101,$03025901,$03CB02BC,$0CEC0C03,$5903CC5C,$02020202,$025B035B
        long $5A028B02,$025ACB5A,$02025A02,$02020259,$02590202,$02025902,$DA020298,$01025902,$49995901,$02024902,$CB020202,$49010203,$5A02CA02,$BB4802CB,$0B040CEC,$ECCB025B,$01CB0C4C,$02590259,$5A027A02,$0303CB5A,$01030303,$DB5B0202,$DC03DC03,$4901BB03,$02025901,$01590202,$038B0259,$035A02CC,$ECEC0303,$1B029C5C,$0249DB4C,$02CB0303,$5B5A02BB,$02CB5ACB,$59020202,$025A0259,$59CA0202,$02020202,$5B0259D8,$02020202,$0202D802,$02490199,$5B025902,$02CB03BB,$5A5A0249,$01010202,$025A0259,$5B1B0259,$CA5C0303,$CA020202,$0201598B,$035A0202,$CB5ACB5B,$030249CB,$EC030303,$D859CB03,$02029902,$59990202,$BBCB5ACA,$03CB5A03,$5CEC6C03,$8C5B0203,$02024CFC,$025BDC03
        long $DB025A7C,$5B03DB5B,$59495A02,$02020259,$5A030202,$02995902,$02590102,$0202027B,$02590102,$59594959,$8B025901,$025A021B,$02CA5A02,$01025901,$59990101,$CB020101,$5ADC035B,$03010249,$0259CBFC,$5ACA0202,$035A4902,$02590203,$035B0303,$59025A03,$02020159,$59020202,$02CB5ACB,$5A01025A,$5ACB03DB,$FC0C5A02,$020304FC,$02CB5ADB,$5A0303DB,$02CB025B,$49590249,$01495902,$02CB8B5A,$8B025902,$029901BB,$02020202,$59010101,$59995901,$02029902,$02025902,$59490202,$025A4902,$DB020201,$5A010203,$02031BCB,$035902D8,$0203EC0C,$8B025902,$03EB0202,$4902EC03,$02020259,$99020202,$0249CA59,$9902027B,$025A8B1B,$025902CA,$59025BCB,$0C0CDA58,$5BFC4C0C,$5A024902
        long $0203035A,$02025902,$0149CB5A,$025A0249,$03035B49,$CA5A0102,$5901025A,$59595902,$02025A02,$02495902,$02020202,$CA020202,$E8029949,$02020102,$CB5B5A02,$5902595A,$02020259,$EC01025A,$03BC0C04,$49590202,$5C5C03CB,$CBEC5CEC,$02DB0249,$0202DA02,$590259E8,$02025ACA,$028B0299,$59020202,$02CA5A02,$5B7C0202,$035BDB03,$CA5B0202,$5ACBBB5A,$02020202,$0149EC03,$021B0C02,$5C03035B,$02AB0102,$0249037B,$02D80202,$BB02BB02,$0201029C,$02020202,$5C030202,$027B02CB,$8B025901,$02CA5ACB,$02010249,$59020201,$030159CB,$035C8C04,$02CBDC03,$03ECEC1C,$03035CDB,$034B03CB,$02020202,$01020102,$02020259,$02024902,$DB1B0259,$030C030B,$02CB5ACA,$025B035B,$020303DB
        long $49020259,$02020202,$495ACB8B,$025C0C02,$EC031C02,$8BCB595A,$03CA5ACA,$5902BB02,$5A5A0202,$99015903,$02020259,$03CB02CB,$0202DA5B,$02020202,$59020202,$49490202,$A8020202,$02590102,$4CFCFC04,$1B5B03CB,$0C5C03CC,$5AFCEC5C,$03BB1BCB,$02020202,$02015999,$03030202,$025CCA02,$03030302,$0C4CEC2C,$5A49CB02,$0B5B1BDB,$1B030303,$EC030202,$02020203,$02020202,$034C0C5A,$5B03035B,$5A7B59CA,$CB5A5A8B,$02CB5A59,$5ACB5A5A,$020202CB,$02020102,$03025A02,$8B5A0203,$02590202,$01027B02,$59024959,$02010202,$02D80202,$CB044C0C,$5BEC1C01,$CCDC031C,$E8034CEC,$03DA5A5A,$0202025A,$E8590202,$CB020259,$02DA025A,$EC2C2C03,$03EC0C1C,$CB025959,$5BCB5A5B,$021B0303
        long $5A020259,$02025A03,$01010202,$5B0C0CCB,$CB5CCB03,$5ACA5949,$5A02CACA,$02020299,$5A5ACBCB,$02020202,$02590202,$034902CB,$029949CB,$99020259,$01020202,$02490101,$02024901,$5A5901CA,$015B03EC,$EC035C01,$1C6CDC03,$020203EC,$035A02DB,$02020202,$59020202,$49020201,$010203DB,$0C4CEC5B,$030303FC,$5B02D802,$020203DC,$028BCB5B,$59020202,$035CCA59,$027C035A,$1B0C0C5B,$02025902,$0259CB5B,$02590202,$02015A02,$025A5A5A,$5A020202,$CB027C02,$02D85B4C,$02E85902,$0202029B,$01019902,$D8590101,$59CA5959,$CA590202,$59E85AEC,$CC034901,$4C03025B,$59025AEC,$CB025ACB,$02020259,$59020202,$D8020202,$011C0249,$4C0C0359,$DB03030C,$1B595959,$02028B03,$CB5A5A5A
        long $DB030302,$5A020302,$020303CA,$5A5B5C03,$5B383802,$02020303,$59020202,$025ACB02,$0202CA02,$CA5A0202,$0202CB5A,$02025A03,$015902DB,$5ABBDB5A,$99594902,$02020249,$02CB0202,$02D85902,$02020249,$5A01E859,$DA5A02CA,$DBDC0202,$02020202,$02025902,$D8020202,$02590202,$1B024902,$EC030201,$5A03035C,$CB4902E8,$020103CB,$02020203,$035BCB02,$02DA0302,$5A9CCB02,$02495901,$4902EC49,$035A0202,$02026CFC,$9C03CB03,$59020202,$5A028B5A,$59025ADB,$5BDA0202,$01CB025B,$EC4C0302,$5959D849,$DB5A0202,$CB02025A,$59020102,$02024902,$02020149,$59594902,$EC024802,$02010203,$020202DA,$02020202,$59E80202,$0202CA02,$03020101,$490303DB,$CB590178,$5959035A,$CBFC0302
        long $49021B02,$021B5A02,$CBCC0359,$03025902,$02034C03,$03DA4902,$0202025B,$02020202,$E8020202,$CB020202,$02DA5A5A,$02495ACA,$02CB49CA,$035B0259,$020259CB,$02020202,$5A020202,$CA0159CB,$02024902,$5B020202,$CBDA02CB,$5A0102CB,$0202ECDB,$5902011B,$CB7B0201,$5959595A,$01490202,$02010159,$0102DB5A,$020202F8,$FC03DB02,$02EC2C02,$CB5A0202,$CB03035B,$03030302,$5B02DA02,$031BCB4C,$025ACB5C,$025ADC49,$5A020199,$0202025A,$02029902,$5A02DB02,$02CA5ACB,$99490203,$02020201,$0202025B,$5A02027A,$CB025902,$0302025A,$02020203,$4902021B,$5B5B0CDB,$015902CB,$02DB5B02,$02595959,$5A020202,$02DA0202,$02485901,$5B1B0202,$02021B02,$02CB0303,$FC4C0201,$5ACB0202
        long $5BCA027B,$49025BDB,$02025959,$025A5B02,$5A5959DB,$02015BCB,$5A02CA02,$030202CB,$5BCB02CB,$020249CB,$CB02CB02,$CB5BCBCB,$0202025B,$025A8A02,$7A025ACB,$CA020202,$CA5A02CB,$CB02025B,$EB020303,$5903035B,$02FC03CB,$5ACA1BCB,$5B020102,$02020202,$02590202,$5B4B03DB,$DB02021B,$03CB595B,$CB025ACB,$03CB5BDB,$EC1C0202,$CA0202CB,$03490102,$025B025A,$5ACA0202,$59030302,$02020259,$5A020202,$CB5A02CB,$0303CB5B,$035A0202,$59CBCB5B,$BB020249,$025ACB5B,$0202025A,$02028959,$025A8A7B,$5B59027A,$5A5ACA02,$020102DA,$5A0102CB,$020303CB,$5ACB035A,$DA035ACA,$5A035A03,$02020101,$DA024902,$0BDC1C5B,$025B025B,$BB5BDA0B,$0202025A,$03CBCB5B,$035B0101,$5A02025B
        long $490202CB,$0C030202,$CBCB5ADA,$02EC0302,$8B03BBCB,$02025902,$CB5A0259,$02BB5B02,$EB03031B,$02DB5A02,$02590202,$CBCBCBCB,$5902CACB,$017A0101,$027B7B7B,$02020202,$5A020202,$590102BB,$02010201,$CB03CB5A,$CA590202,$5ABBCB5A,$DB0202CB,$01010203,$5B010259,$025B0303,$1B030102,$035ACB5A,$025902CA,$CB5B0303,$49010101,$020202CB,$02490202,$CB03DB5B,$CB5A025A,$CB02CB02,$CB5BBB03,$02028B5A,$CB020202,$02BBCC5B,$5BDC7C03,$035BCB02,$010203EC,$025A5A02,$01590202,$88010202,$01020201,$02025959,$02020202,$DC020202,$02020203,$59020202,$02025A02,$5A02025A,$03CB59CA,$0102031C,$025901E8,$020202CB,$5A030102,$CB0302CB,$02D8595A,$02CB03DB,$01490148,$02020259
        long $02020259,$024B5B02,$5ACB024B,$02595A02,$03035B03,$7A79CBBC,$02010202,$02030303,$02029902,$0259CB02,$59E85A02,$02D80159,$D802025A,$59010259,$58888801,$02019898,$02590102,$0202CB02,$0202D859,$DB020202,$0159D802,$02CA0299,$5A020202,$0303CBEC,$02025B5B,$CB024902,$02025902,$02BB0202,$0259D802,$02CBCBCB,$01280148,$02DCCB49,$02020202,$5B1CDB02,$02CA02EC,$025BDBCB,$5A030303,$02010159,$5A020202,$9CBB03DC,$02024902,$59020259,$E8590202,$0202DA02,$02029902,$E80201D8,$01010101,$02010201,$02CBCB03,$DA025902,$02CB1B02,$025A0302,$03CB5A49,$025A02DB,$49020259,$5BCB5AFC,$CB03CBCB,$5A02025B,$BBCC0202,$02590202,$02990203,$02CB0202,$1B015938,$CB1C4BCB
        long $4902DBCB,$DA2C5B49,$4949025B,$49020249,$0202CBCB,$02590299,$02020259,$6C03EC5C,$49D802CA,$CBDA02D8,$CB5B028B,$596C0303,$BB0259D8,$59020202,$02990202,$02020259,$02025CCB,$CB02DA02,$020C5C02,$59DA0302,$0303DCCA,$02020303,$48CA5A02,$CB5A0202,$5A5ABB5A,$CA4C0302,$5A5A0202,$0302DA02,$D8025B1C,$02020159,$2C59E848,$5A1CDC03,$CBCB0203,$5A0302CB,$D8590102,$59CBCB5A,$02020202,$035A0249,$5A020203,$0202CB03,$CB5BCB5A,$5A02BC02,$DBCB0202,$CA5B035B,$02027B02,$CA030302,$5A020202,$7B02CB02,$59025A02,$035B0302,$DA5B5ACB,$02020259,$DB035B03,$02020202,$01590202,$5B025999,$020202CB,$59020202,$02020249,$02025ACB,$59020203,$020259E8,$DA025949,$CB02025A