{*********************************
 *   Rem Floor Demo v010 *
 *********************************


}

CON

  _clkmode = xtal1 + pll8x  ' ?
  _xinfreq = 10_000_000 + 0000 ' Set to 10Mhz and add 5000 to fix crystal imperfection of hydra prototype
  '_stack = ($300 - 200) >> 2           'accomodate display memory and stack
  _memstart = $10                   ' memory starts $10 in!!! (this took 2 headaches to figure out)

  paramcount = 14
  SCANLINE_BUFFER = $7F00
  ' Define list of intercog global variable: they start right next to the video scanlinebuffer
  spin_request_scanline = SCANLINE_BUFFER-4
  spin_vertical_scroll = SCANLINE_BUFFER-8
  spin_horizontal_scroll = SCANLINE_BUFFER-12
  spin_top_y = SCANLINE_BUFFER-16
  spin_bottom_y = SCANLINE_BUFFER-20
  spin_stop_y = SCANLINE_BUFFER-24
  spin_tilemap_adr = SCANLINE_BUFFER-28
  spin_tiles_adr = SCANLINE_BUFFER-32
  spin_gamepad = SCANLINE_BUFFER-36
  spin_framecount_adr = SCANLINE_BUFFER-40
  spin_mousex_adr = SCANLINE_BUFFER-44
  spin_mousey_adr = SCANLINE_BUFFER-48

  NES_RIGHT  = %00000001
  NES_LEFT   = %00000010
  NES_DOWN   = %00000100
  NES_UP     = %00001000
  NES_START  = %00010000
  NES_SELECT = %00100000
  NES_B      = %01000000
  NES_A      = %10000000

VAR
  long tv_status      '0/1/2 = off/visible/invisible           read-only
  long tv_enable      '0/? = off/on                            write-only
  long tv_pins        '%ppmmm = pins                           write-only
  long tv_mode        '%ccinp = chroma,interlace,ntsc/pal,swap write-only
  long tv_screen      'pointer to screen (words)               write-only
  long tv_colors      'pointer to colors (longs)               write-only               
  long tv_hc          'horizontal cells                        write-only
  long tv_vc          'vertical cells                          write-only
  long tv_hx          'horizontal cell expansion               write-only
  long tv_vx          'vertical cell expansion                 write-only
  long tv_ho          'horizontal offset                       write-only
  long tv_vo          'vertical offset                         write-only
  long tv_broadcast   'broadcast frequency (Hz)                write-only
  long tv_auralcog    'aural fm cog                            write-only

  long temp1

  ' param for rem_engine:
  long cog_number
  long cog_total
  
  long colors[1]

OBJ

  tv    : "rem_tv_014.spin"
  gfx   : "rem_gfx_engine_014.spin"
  mouse : "mouse_iso_010.spin"
  loader : "REM_LOADER_KERNEL_001.spin" ' loader kernel (boots paged cogs)


PUB start      | i, j, k, kk, dx, dy, pp, pq, rr, numx, numchr
  DIRA[0] := 1
  outa[0] := 0

  longfill(@colors, $02020202, 1)

  long[spin_tiles_adr] := @floor000

  cog_number := 0
  cog_total := 4
  gfx.start(@cog_number)
  repeat 10000 ' Allow some time for previous cog to boot up before setting 'cog_number' again
  cog_number := 1
  gfx.start(@cog_number)
  repeat 10000 ' Allow some time for previous cog to boot up before setting 'cog_number' again
  cog_number := 2
  gfx.start(@cog_number)
  repeat 10000 ' Allow some time for previous cog to boot up before setting 'cog_number' again
  cog_number := 3
  gfx.start(@cog_number)
  repeat 10000 ' Allow some time for previous cog to boot up before setting 'cog_number' again

  'start tv
  longmove(@tv_status, @tvparams, paramcount)
  tv_colors := @colors
  tv.start(@tv_status)

  mouse.start(2)

  loader.start(@GAMEINIT_START)

  long[spin_top_y] := 0
  long[spin_bottom_y] := 192
  long[spin_stop_y] := 192


  ' Start of main loop here
  repeat
    repeat while tv_status == 1
    repeat while tv_status == 2

    long[spin_mousex_adr] := long[spin_mousex_adr] + mouse.delta_x #> 0 <# 255
    long[spin_mousey_adr] := long[spin_mousey_adr] - mouse.delta_y #> 0 <# 191


'end of main
'---------------------------------------------


DAT

tvparams                long    0               'status
                        long    1               'enable
                        long    %011_0000       'pins
                        long    %0000           'mode
                        long    0               'screen
                        long    0               'colors
                        long    16              'hc
                        long    12              'vc
                        long    10              'hx
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    60_000_000'_xinfreq<<4  'broadcast
                        long    0               'auralcog

                        org
GAMEINIT_START
                        mov dira, #1            ' Prepare led debug
loop
                        'xor outa, #1

                        rdlong framecount, framecount_adr

                        call #waitvbl

                        add framecount, #1
                        wrlong framecount, framecount_adr

                        rdlong r0, horizontal_scroll
                        add r0, hscroll_speed
                        wrlong r0, horizontal_scroll

                        jmp #loop

waitvbl                 
:wait_status_1          rdlong r0, request_scanline
                        cmp r0, #191            wz
        if_ne           jmp #:wait_status_1
:wait_status_2          rdlong r0, request_scanline
                        cmp r0, #192            wz
        if_ne           jmp #:wait_status_2

waitvbl_ret             ret

request_scanline        long SCANLINE_BUFFER-4
vertical_scroll         long SCANLINE_BUFFER-8
horizontal_scroll       long SCANLINE_BUFFER-12
top_y_adr               long SCANLINE_BUFFER-16
bottom_y_adr            long SCANLINE_BUFFER-20
stop_y_adr              long SCANLINE_BUFFER-24
tilemap_adr             long SCANLINE_BUFFER-28
tiles_adr               long SCANLINE_BUFFER-32
gamepad                 long SCANLINE_BUFFER-36
framecount_adr          long SCANLINE_BUFFER-40
framecount              long 0

hscroll_speed           long 165536

GAMEINIT_END

fit 440 ' real maximum is 448

' /////////////////////////////////////////////////////////////////////////////
' GLOBAL REGISTERS ////////////////////////////////////////////////////////////
' /////////////////////////////////////////////////////////////////////////////

                        org                     $1e0

r0                      long                    $0
r1                      long                    $0
r2                      long                    $0
r3                      long                    $0
r4                      long                    $0
r5                      long                    $0
r6                      long                    $0
r7                      long                    $0

' /////////////////////////////////////////////////////////////////////////////
' LOADER REGISTERS ////////////////////////////////////////////////////////////
' /////////////////////////////////////////////////////////////////////////////

                        org                     $1c0                        
__loader_return         res                     7
__loader_call           res                     6
__loader_execute

                        org                     $1e0                            ' general registers 1e0-1ef
__loader_registers
__g0                    res                     1 ' g0..g7 : Global COG Registers
__g1                    res                     1
__g2                    res                     1
__g3                    res                     1
__g4                    res                     1
__g5                    res                     1
__g6                    res                     1
__g7                    res                     1

__t0                    res                     1
__t1                    res                     1
__t2                    res                     1
__loader_ret            res                     1
__loader_stack          res                     1
__loader_page           res                     1
__loader_size           res                     1
__loader_jmp            res                     1

' //////////////////////////////////////////////////////////////////////////
' HUB VARIABLES ////////////////////////////////////////////////////////////
' //////////////////////////////////////////////////////////////////////////

org
floor000 long $9C9C9CBC,$ACACAC9C,$8BCB03AC,$BB03BB03,$ACBB038B,$04048CBC,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505,$04050505,$027BCA8A,$02025902,$8B8ACA9B,$7BCA8B9A,$04AC028B,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505,$8C8C0405,$CA5ABBAC,$02590202,$59595959,$59595959,$9C9C9C9C,$0303ACAC,$CBAC8BBB,$BBBBBB8B,$BC8BBB8B,$058C048C,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505,$9B020505,$CA7BABCA,$9BCA9A02,$ABABAB9B,$CBBBBB7B,$CB8BCB8B,$BBBBBBAB,$3C3C4C3C,$04043C04,$05040504,$04050505,$05050405,$05050505,$05050505,$5C040505,$04040404,$05040404,$04040404,$04040404
        long $AC9CBCBC,$ACCBACAC,$BB0303CB,$BB5BBB03,$8C9C03BB,$05059C8C,$05050505,$05050505,$05050505,$05050505,$05050505,$9B050505,$0505058A,$029A0505,$8ACA0159,$029B02AB,$025901CB,$8B0159CA,$ABABABAB,$ACBBBBBB,$3C5A025A,$5A495A02,$024A4A49,$053B5A4A,$5A5A0405,$025A025A,$5A025A5A,$048C0403,$04040404,$02CBFC05,$05050403,$05050505,$039C9CBC,$ACACACAC,$03BBACAC,$8BBBBB8B,$8C8CAC03,$0505058C,$05050505,$05050505,$05050505,$05050505,$05050505,$AAAB0505,$058A8AAA,$01CA0505,$02020000,$AB7BCA7B,$980000AB,$49000059,$CBBBBB8B,$BBACBBAC,$5A010000,$00000000,$00000000,$59000000,$00480404,$00000000,$00000000,$04045900,$04040404,$0000785C,$05045800,$05040504
        long $9CBC9C8C,$AC03ACAC,$038B038B,$03BB03BB,$048C9CCB,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505,$9B9B0405,$05AC9B9A,$588A0505,$9A010000,$02CA7BCA,$480000BB,$D80000D8,$BBBBCB9A,$BBACACBB,$49010000,$00000000,$00000000,$00000000,$00680402,$00000000,$00000000,$04020000,$04040404,$00000048,$04010000,$05050405,$9C9C8CBC,$ACACAC9C,$BBACBB03,$AC038B03,$9C048C9C,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505,$8A8AAC05,$05059C9B,$019A0505,$02020000,$ABCA7BCA,$010000BB,$59000059,$BBACBB7B,$ACACACAC,$49010000,$49010078,$49594959,$00004959,$00480300,$02024958,$59590202,$03000088,$02050404,$49480000,$5A000088,$05040505
        long $9CBCBC8C,$ACACAC9C,$8B03ACCB,$9CCB8B03,$05AC049C,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505,$9A9B0505,$050505AA,$018B0505,$02990000,$7B8BCA7B,$010000BB,$01000001,$ACBBBBCA,$BBACACAC,$02010000,$5B010000,$FC044C4C,$00480404,$00781B00,$8CFC5A48,$EC03CCFC,$5A000001,$00EC04FC,$CB020000,$58000003,$050505CC,$9CBC8C8C,$ACACAC9C,$CBAC8BAC,$AC9CACCB,$0505AC04,$05050505,$05050505,$05050505,$05050505,$05050504,$05050505,$05050505,$0505AC8A,$019A0505,$48480000,$48585848,$58000048,$00000002,$01015858,$78015801,$49590000,$4B010000,$05050505,$00480505,$00785A00,$01014800,$01015801,$5A580000,$00590404,$01487800,$00000001,$05040559
        long $9C8CBC8C,$03AC9C9C,$8B03ACAC,$8C8C9CAC,$05050504,$05050505,$05050505,$05050505,$9A040505,$0505AC9A,$05050505,$05050505,$05050505,$018B0505,$00000000,$00000000,$48000000,$0000019B,$00000000,$00000000,$02497800,$5B010068,$05050505,$00480505,$0000CB00,$00000000,$00000000,$CA590000,$00007C04,$00000000,$00000000,$0505CC00,$BCBC8C8C,$ACAC9C9C,$ACAC8BAC,$048C8C9C,$050505AC,$05050505,$05050505,$05050505,$999A0505,$AC8A9999,$05050505,$05050505,$05050505,$019A0505,$78780000,$78787878,$48000078,$4899AC02,$00007878,$78787800,$2C5A4948,$4B010000,$05050505,$00480505,$00585A00,$78785800,$78007878,$03780000,$00004804,$78780078,$00787800,$05040100
        long $9C8C8C8C,$ACAC9CBC,$9C03AC03,$AC049C8C,$05050505,$05050505,$05050505,$05050505,$029A9C05,$9A990102,$0505059B,$05050505,$05050505,$01CB0505,$59D80000,$01D801D8,$01000002,$02ACBB9A,$00010202,$0202D800,$4C045B5A,$03010000,$05050505,$00480505,$0078DA00,$02020248,$02020202,$02000001,$48000002,$5A020202,$580202DA,$05CB0000,$BC8C8CCC,$AC9C9C9C,$8C9CACAC,$05AC049C,$05050505,$05050504,$9C040505,$0505059C,$CA029B05,$059B8A9A,$05050505,$8A050505,$05059B05,$019B0505,$02590000,$8B8B8BAB,$5800008B,$ACACBB5A,$0001BBBB,$8CAC5978,$4C05044C,$03010000,$04040404,$00780404,$00685B00,$FCFC0248,$0404FCFC,$02000002,$02000058,$040404CB,$02050404,$8C490000
        long $BC8C8C8C,$9C9C9C8C,$8CBC9CAC,$05058C04,$05050505,$04050504,$02029BAC,$05049B7A,$599BAC05,$9CAB9B02,$05050505,$8A8A8A05,$05050505,$019B9B05,$8B990000,$8BCBCA8B,$480000CB,$BBACAC02,$00999CAC,$04AC0200,$3C050504,$00000000,$00000000,$00000000,$00000201,$04040248,$04040404,$02000002,$5A000058,$040504EC,$03050405,$5C020000,$8C8C8C8C,$9C9C9CBC,$8C8C9C9C,$05AC0504,$05050505,$9A8B9C05,$98019959,$05020078,$ACAC0505,$9A9A9B9A,$050505AB,$05058A8A,$8A8A0505,$488B9AAA,$CA490000,$CA8B8B8B,$58000003,$ACACBB9B,$00598CAC,$049C5900,$3C050504,$00000000,$00000000,$58000000,$0048CB02,$8C040248,$0404FC04,$02000002,$5A000058,$04040404,$CB040504,$03020000
        long $8C8C8C8C,$9C9CBCBC,$059C8CBC,$050505AC,$ABAC0505,$0199028A,$78588801,$9A010188,$05050505,$02ABACAC,$059B8AAA,$05050505,$999A8A8A,$02CA9899,$CA014848,$8BCBCA5A,$015848BB,$BBCBAC02,$4802ACAC,$7CAC9901,$4C044B04,$58584801,$58480148,$02010148,$0159EC5A,$04040201,$0404048C,$02480103,$02E80159,$0504048C,$5C050404,$6C025801,$8C8C8C8C,$8C9C9CBC,$058C049C,$9BAC05AC,$997A998A,$58588801,$48885888,$02788848,$05050505,$9BAB0505,$9B9A9A9A,$9A8A9B05,$9898A9A9,$5A5B0101,$5B020202,$CB5ACB5B,$0202CB5B,$038B0302,$5A030303,$6C030202,$4C5C5C5B,$CA5A0203,$5A5A025A,$CB5A5ACA,$CAFC8CEC,$FC04CB5A,$FC040404,$CBCB0304,$CB5B0304,$04050404,$05040504,$ECCB0304
        long $8C8C8C8C,$8C8CBC8C,$AC8C9C04,$AA9A9BAC,$58019901,$78888858,$88580188,$02787888,$05050504,$9B9B0505,$9A019ACA,$98999A9B,$98580198,$CBCB9801,$5ACB5ACB,$5BCB5ACA,$BBCB5BCB,$035B035B,$03030303,$03030303,$030303CC,$5CECCC5C,$ECECECEC,$8CFC8C4C,$048CFC0C,$04FC8CFC,$0404FC04,$04040404,$04040404,$04040404,$04040404,$05040404,$8C8C8C8C,$9C8C8C8C,$9A9BACAC,$01010199,$78007888,$01585878,$58010101,$9858C800,$0505059C,$9A9B0505,$0198029A,$01980199,$98589898,$BA995858,$9BBA9B9A,$9B9AAA9B,$00019B9B,$88588878,$9A015858,$0199029A,$58780101,$01487888,$8C027A01,$02AB9C8C,$9C9C8B9B,$8BAB8B9C,$0505058C,$05050505,$05050505,$04050505,$9C8C8C8C,$5ACB8B03
        long $8C8C048C,$9BABBB8C,$0101999A,$78788801,$C8787800,$01010158,$59995999,$01990101,$0505058B,$AB8C0505,$98999902,$9898BA01,$48985858,$9A019898,$9B9B9BBA,$BA99BA9B,$88019A9A,$01880000,$59BA029A,$99488801,$58885801,$88585878,$9BBB0248,$BB8BCA9B,$ABBB03BB,$CB8BCB8B,$058CABAB,$05050505,$05050505,$048C0505,$9CBC8C04,$8B8BBB8B,$CC8C8C04,$010199AB,$78580101,$78007878,$01484858,$59019901,$59D85999,$AB9A0299,$050505AB,$9B040505,$01010199,$01019901,$01989898,$99984898,$9BBA9B9A,$785899BA,$98010158,$9A588858,$78780102,$49019901,$58C8019A,$780058E8,$029B9901,$BBAC7B8B,$5ACA7B8B,$5A7B027B,$BB8B8BBB,$05050504,$05050505,$05050505,$9C8C8C04,$02CB039C
        long $999BAC8C,$88010101,$88000078,$58588800,$01990198,$01990101,$01599901,$02599959,$0505057B,$99AC0505,$88885801,$98880199,$A8010101,$01489858,$999B9ABA,$58A84888,$8A9B9A98,$48009A9B,$00780088,$99CA0201,$99590202,$78010159,$ACCB4900,$AB02CBAC,$0202CA5A,$CACBBB02,$8BCB8B5A,$05048B9B,$05050505,$AC050505,$AC04AC05,$0203037C,$5801019A,$00007888,$88787878,$01A84848,$99010101,$99015901,$59990159,$01990101,$05059C02,$019A9B04,$00788898,$01019801,$58489898,$985888C8,$C8599A01,$98019878,$8A8A8ABA,$00AA8A9B,$48008888,$CB595888,$0202BA02,$01580199,$ABACBB02,$CA8B027B,$AC8CAB02,$8B9CACBB,$CB5ACA02,$ACAB9A5A,$05050504,$05050505,$8CAC05AC,$03035C8C
        long $78788878,$58780000,$48C87800,$99010101,$01019901,$01010101,$01015901,$58010199,$029B7800,$C8589899,$88880088,$98980188,$88C88858,$88C87878,$58880101,$02994898,$058A8ABA,$C98A9B8A,$C8587800,$01888800,$D859ACAB,$02589801,$5ACA029B,$7B0202CA,$9C9C8CCB,$AB7BCA8C,$029A5ACA,$025ACBCB,$0505AC9B,$05050505,$04040505,$035CCC8C,$00007878,$88885878,$01585888,$01019901,$99010101,$01990101,$01990199,$00785801,$88780078,$88580198,$00588800,$589901C8,$888888C8,$78789801,$48888888,$9A029B9A,$8A8A8AAA,$AAAA8A8A,$7800C858,$01014858,$02990201,$0199CB8B,$9A5A0201,$BB9CBB02,$8C8C8C04,$CB5A7B8B,$8C8CCB8B,$CB8B02AB,$AC9B9B7B,$05050505,$04040405,$BC5C8C04
        long $88588848,$00000000,$58580058,$01010198,$01015999,$01019901,$78580101,$78000000,$9B020000,$88989901,$880000C8,$99D89868,$99015858,$D9019801,$C8885899,$88589902,$8AAAAA58,$99AAAAAA,$01486801,$01010148,$ACCB0299,$020202AB,$CB02029B,$8C049CAC,$02ABAC9C,$9C9CCA02,$04050404,$02CA028B,$AB5ABBBB,$05059C8B,$04040505,$CC8CFC8C,$78004801,$00788800,$88588800,$01990148,$01990101,$01010101,$00000088,$00780088,$9B997800,$98010101,$00008899,$01019858,$58999999,$9C997888,$8878C8AB,$C8888888,$BA989888,$99029AAA,$01018848,$02029901,$028ABBBB,$CB8B9A02,$ACBBAB8C,$ACACACBB,$8B02028B,$04049C8B,$9BAC9C04,$8B5ACA5A,$BBBBCB5A,$04AC0202,$04050505,$EC8C0404
        long $00009899,$88880078,$58007800,$01015888,$01010101,$78008801,$00780000,$00780078,$78000078,$01985888,$88009859,$99019948,$88884801,$599ACA01,$C8585801,$58C88858,$989848C8,$01010199,$98485858,$8ABBAC02,$9A020202,$9C8CACCB,$AB027BBB,$02AB9CAC,$CB020202,$9C04ACBB,$0202ABBB,$5ACA5ACA,$BB5AABCA,$02595902,$04058CAC,$5CFC0404,$88010259,$000088C8,$88008800,$01885800,$78880198,$00780078,$78008800,$88007800,$00780000,$78580000,$000198C8,$58985888,$CA599888,$99599AAB,$88C88801,$8858C878,$99CA5901,$C8019848,$0158C858,$02599A02,$8CCB8ACA,$AB8BAC8C,$8B020202,$0405059C,$8B0202AB,$ABAB7BCB,$7B02029B,$CA7BCA02,$8BCB5ACB,$59D80202,$04AC8B59,$8C040404
        long $4899CA59,$88980198,$78880078,$88588858,$00000078,$00000000,$00580058,$00780078,$88880078,$00000000,$A8587800,$01880000,$029ACA02,$02020198,$58789801,$020158C8,$0159BA9B,$010159D8,$99010148,$02CA0202,$8C8CBC8B,$BBBB8BBB,$02AC9C5A,$0504AC02,$048C8B9C,$0202028B,$CACB9C03,$5A020202,$8BCA8BAB,$59029902,$8B4901E8,$048C049C,$88BA0299,$0099BB01,$88008800,$00588800,$00787800,$00787878,$00007800,$78000078,$88780000,$00008801,$88008888,$01C88858,$9858019A,$99029958,$01D80102,$999A9B02,$59018801,$01029959,$02024999,$AC040202,$BB8BCBAC,$0202CBAC,$0405059C,$8BAB027B,$CBBBACCB,$AB02028B,$9C040504,$CA8B8B8B,$CBBB5A02,$01010102,$38E80159,$8C5CCB49
        long $88020202,$00589948,$58580078,$78880088,$78000000,$00000000,$78000078,$00008800,$00007800,$00788848,$00880158,$98585800,$48989858,$BB015898,$9AABABAB,$48019901,$99019848,$020159D8,$AB8B0202,$ABAC0202,$ABCBAC8B,$AC020202,$048CAC9C,$BBBB8BAC,$0202ACAC,$0304AB5A,$04058BAB,$9CAC0304,$8B5ACA03,$01010102,$01010101,$03020101,$989A9902,$88885898,$88008800,$00585800,$00580000,$88780078,$00880000,$00780078,$00000078,$88000000,$C8007800,$98C88848,$98019848,$02985898,$01029B9B,$01014898,$59D80199,$02020259,$0404AB8B,$02AB59AB,$5902028B,$CB8BBB02,$AB02029A,$AC03CB8C,$AC7BCBAC,$BBACBC04,$AC9B038C,$8C040405,$CA5ABBAC,$01F85902,$59010101,$59380101
        long $98CA029A,$C8888858,$00000088,$00C88858,$00000078,$00007800,$00780078,$88000000,$88780000,$00880078,$78888878,$5858BA02,$01984898,$CA9AD801,$58889859,$01019901,$02025901,$3C8B0202,$6C3C4B5C,$028BAB8B,$99029959,$02028B02,$CB8C8CBB,$7BBB9A02,$BBCA8B02,$8C04BBBB,$CB7CAB9C,$0405AC8B,$CBBBAC8C,$59010159,$010159F8,$F8015901,$BA9B02AB,$5888E898,$00589848,$00487800,$78880000,$00780000,$88007800,$00008800,$00880078,$78C84888,$0102E800,$019A0298,$99584899,$010102CA,$99010298,$59D85901,$02025999,$3B5B5A5B,$3C3B3B4B,$59015B4C,$CA0249E9,$8B04AC02,$02ABCB59,$02024902,$03BB9CCB,$CBBB9C8C,$AC8C8C04,$04ACCB9C,$038C0405,$59490102,$02490101,$59594902
        long $590199AC,$01018898,$78010198,$00000000,$00000078,$00007800,$00780078,$00000000,$5802A858,$02010158,$CA9901AB,$02990299,$01989ACA,$99019801,$CB029B01,$D859019A,$5B5B0259,$4A284A3B,$2A3A3A3B,$02033C4B,$8B020259,$DCACBB9C,$9A5A028B,$02020202,$AC8B6C5A,$9CAC8B03,$BC8CBB04,$AB9C8C8C,$BB048C9C,$F8594902,$8B020101,$49D859D9,$0058589B,$99588878,$8898589B,$78007800,$00780000,$78000078,$00007800,$99018800,$980199AB,$019AAB01,$01998B9A,$02020202,$01029C9A,$59010198,$01019959,$5A020159,$284B4B5B,$7B6B4B39,$3A6B695A,$5A3C3B2A,$02990299,$8CAB8C03,$BC02BBBC,$0202029C,$020202CA,$8CCB9CCB,$03049C8C,$7C049C9C,$CBACBB8B,$01F80102,$0102F859,$5959D859
        long $00009801,$48780078,$007878D8,$00000000,$00007800,$00780000,$01880000,$029B0299,$AB025801,$ABBB0202,$CA029901,$BBAC999A,$01029901,$01010101,$02025901,$3C5B5A02,$4B4A594A,$9A5A7B8B,$2A3A2859,$496B3B4B,$59024902,$BBBBAB02,$9A02BBCB,$8BBBACCB,$BB04BBAC,$9CBB5A02,$BB8BBBBB,$CB8B9C04,$BB8B0303,$01010102,$E85902F8,$D8595959,$58010188,$78000088,$78000078,$00780000,$88000000,$00000000,$ABD80000,$98980199,$9B019902,$02029ABB,$02990202,$8ACA9ABB,$02990202,$99015999,$6CCB59D8,$5A393C4B,$5A7B6B2A,$02019A8A,$4A4B3B5A,$5928596B,$CA025902,$BBCB0202,$8CEC7B02,$BBBB02CA,$03AC5A8B,$8CBB028B,$8BDBACCB,$BBCBCB5A,$CBBCBC03,$2802DA02,$59010101,$494901E8
        long $D8880088,$00008801,$00888800,$00000000,$00000078,$CA880088,$01887899,$01AB5900,$99BBCB99,$9A9B0202,$019B9B99,$02028B02,$5902029A,$49599902,$4A3B5B5A,$7A3B3B69,$998A5A5A,$5C3B6B59,$38694A4B,$02283838,$9C9CCB99,$AB5ACA5A,$BB02CBBB,$BB020202,$028BBBBC,$CB8B0202,$CBCB5A8B,$5A8BCB9C,$8C049CCB,$02024949,$59E82849,$29D84902,$780078C8,$88880199,$00007800,$00007800,$58888800,$8B990298,$02880099,$AC0201BA,$7B029902,$BB02BA02,$02590102,$02020202,$029A0202,$4B5B0202,$3B3A283B,$9B5A5A5A,$5B02019A,$395B5C5C,$28283859,$5A283828,$AC8CCB5A,$0202038C,$02BBACCA,$5A020259,$0202CABB,$0202CBCA,$5ACBCB02,$CB02CB9C,$8CBBBBCB,$0259CACB,$01490202,$59010101
        long $00880000,$58980100,$78000088,$58C80000,$02990158,$000102CA,$01580000,$0299CA8B,$D88ACA02,$99018B9B,$029B0202,$9A029A02,$5ACB9A02,$394A4B5B,$6B6B6B3B,$0189BA5A,$5B6C5B5A,$3838284A,$38383838,$4A593838,$9C8CCB4A,$BB8C8BBB,$BB7B0202,$CABB02BB,$5A020202,$CB5A0202,$CB0202CB,$03CB5ACB,$0202039C,$02CBCB49,$02020202,$0101F849,$88780078,$99C80078,$00000001,$00785888,$789B0288,$00000088,$88000078,$9B020258,$02BB0299,$59010199,$9A020202,$02020202,$3B4B5B5A,$6B4A4A39,$9A9B4A6B,$5B5A0279,$593A3B5B,$28593838,$38385938,$38283838,$8CCB8B28,$CBACCB03,$02020204,$490202CA,$02020202,$025ACBCA,$BBCB5A02,$BC5ACA03,$49590203,$DB023859,$02E859DA,$F8494902
        long $00008888,$78007888,$C8019901,$88000088,$00000088,$00000000,$78008800,$9C018800,$9802988B,$88010201,$02029901,$6C8B0202,$3B3A5A4B,$8B4A6B49,$0289599A,$3B3B5B4A,$38385939,$38383838,$28382838,$38385938,$ABBC5B28,$8B8CAC02,$02020202,$02020202,$CB020202,$CB02025A,$1B03BB8C,$CBACCB02,$02D80101,$492849DA,$49DACC02,$493902F8,$88000001,$888800C8,$00589948,$88000000,$00000088,$00880078,$00000088,$58887888,$01015858,$00990201,$02590158,$4A4A6C02,$4A6A3A3B,$017A9B5B,$3B02499A,$59284A3B,$38283838,$38383859,$38383838,$28383838,$02020238,$BC03ACBB,$02590202,$02020202,$025ACA02,$9C030202,$CBCB03BC,$CA025B03,$DA5A021B,$38010202,$CA5A49F8,$02490149
        long $48888888,$E8588801,$58010202,$00000000,$00880000,$00000000,$00888800,$00880088,$998858C8,$78580159,$6C595800,$693B3B4B,$8A8B3B4A,$59029A59,$6B3B3B5A,$38382869,$38382838,$38593838,$38283828,$38283828,$02024959,$CBAC0302,$49020202,$5A020202,$02020202,$CB9CDA02,$9C03BBCB,$5C1B02DB,$5BDA0203,$4928F849,$39012802,$E84903DA,$88880000,$8878C898,$CA9A0201,$00889802,$00000088,$88880088,$00880000,$01008888,$02010188,$0299D899,$044A5801,$5B3B3B3B,$9A02598A,$4B3B5959,$28595A3B,$59383828,$28383838,$38382838,$38383838,$38382838,$02595928,$02AB0202,$02020249,$02020202,$02020202,$03AC1B02,$5ACB7C03,$DBBCCCDB,$0203CC49,$49CB4928,$2828F802,$5BCB0228
        long $00888888,$78588868,$5ABB0288,$C8995999,$00880000,$00008800,$88008888,$01015888,$01019A02,$02595901,$2A5A5999,$594A3C4B,$5A01599A,$394A4B3B,$38383859,$38283838,$38382838,$38383838,$38283838,$28283828,$59D84901,$02020202,$02CA0202,$02020202,$DA020202,$5A5A0202,$CC03DA5A,$03CB0303,$1BF903CB,$E8390202,$F8282828,$02022828,$88E87800,$48988800,$78014888,$000148C8,$00008800,$8801D878,$E8880000,$02BA0101,$59990199,$02880199,$3A5968D8,$4A3C3B3A,$3B4B4B5B,$3859593A,$28382838,$38383838,$28383828,$38383838,$38382838,$38383838,$49024938,$02024902,$02020202,$02020202,$02020202,$DA020202,$03CB1BCA,$CB03BC03,$035BCB5B,$02F949F9,$28282828,$F8284928
        long $9AAC8B99,$48008888,$99888801,$78990259,$88880078,$C8588800,$01010158,$01010198,$01015901,$58484888,$3A288801,$3B3B3A3A,$596B3B3B,$38383838,$38383838,$59382859,$38383838,$38283838,$38383828,$38004838,$0249D849,$49024902,$02020202,$02020202,$02020202,$5ADA1B02,$DA5B5A1B,$0303EB5B,$0203CCDB,$4A1B0339,$28F828F8,$2802EB02,$9C8C8CCB,$00580199,$9AD85888,$019B02BA,$00885898,$485878C8,$01010198,$01990101,$00004801,$01584858,$3A490148,$5A3A3A3A,$38382869,$28382838,$28382838,$38283838,$38382838,$28383838,$48383828,$38590138,$59024959,$02490202,$DA020202,$02021BCB,$1B020202,$1B1B0202,$5B1BCB5A,$ECDB5BCB,$DBCB1B03,$39281B03,$39282828,$28283902
        long $049C0201,$A8029B8C,$58587800,$ABAB9901,$010299CB,$01989848,$99019901,$58480102,$00007878,$01000000,$3A3A5C02,$393A5A3A,$28385928,$38383838,$38383838,$28383838,$38383838,$38382828,$01000038,$48E83859,$49D84901,$020249E9,$CB5BDA02,$1BCBCB5A,$020B1B02,$5A021B02,$DA5BDA1B,$DB1B1B1B,$DB031B5A,$1B394939,$1B0239F8,$4928F829,$9B029899,$9AAC8CAC,$88008801,$CA8B0158,$9B8BCA59,$01010102,$01010199,$58880102,$58580048,$9A597800,$3A3A3B5A,$393A3A3A,$38382859,$59382838,$28385938,$38382838,$28283838,$00004838,$38003800,$38484848,$490249E8,$DA020202,$5ADA5BCB,$CB5BCACB,$0203CBCB,$1B1B021B,$1B1B5BDA,$1BCB5A1B,$1B02CB1B,$39F93902,$1AEBDC02,$02393902
        long $88010159,$029A9BAB,$5898D89A,$58990198,$CA025988,$02BBAC8B,$01990101,$01588801,$01000001,$01010199,$3A4A4A49,$393A3A3A,$28383859,$28383838,$38283838,$02593838,$48382802,$38000000,$38003800,$38383800,$02024938,$5BCBBBCA,$CB5BDA5A,$CA5BCB1B,$1B025B1B,$DA5A1B02,$CB021B5A,$1B1BDBCB,$025B1BCB,$031B1B1B,$0229020B,$39F9F90C,$00008801,$01990158,$989B8C02,$01010198,$03990078,$AB59AB9C,$99010199,$58005801,$58010201,$01000001,$3A4A4A59,$5A3A3A3A,$38382859,$38382838,$38383828,$058C8B4A,$00488C05,$00380048,$48383838,$E8383838,$CB5ACA49,$CBCA5A5B,$5ACBCBCB,$5BCA1BCB,$CBDBDBDA,$021BDA1B,$1B5B1B1B,$5BCB1B02,$1BDB1B1B,$1BDB1BDB,$1B1B1B49,$0B2C4902
        long $00000000,$99025988,$0102BB9B,$99019801,$015848E8,$02580001,$01010159,$CBD85801,$58C85902,$48585800,$4A4A4A59,$3A3A3A3A,$28385939,$38383838,$8C5A2838,$059C059C,$0001CB8C,$38003800,$38480000,$5A49E838,$5ADA5ACA,$5ACB1BCA,$CB020202,$DB5BCB5A,$DB5B5B5B,$1B1B5B5B,$1BDA1B1B,$1B1B5B1B,$DB1B5BCB,$1B5B1B5B,$39020B0B,$4A0C1B1B,$00880000,$9901C878,$BA9A0101,$889801AB,$00889958,$9A025888,$0101D801,$01029B01,$59580198,$E84888E8,$4A4A4A59,$283A4A4A,$38383838,$59383838,$8C05AC5A,$9BAC0505,$0001019A,$38003838,$E8020138,$CA5A0202,$5ACB5ACA,$02CB7BDA,$1B02DB1B,$CB1BCBDA,$03EBDB1B,$02021B03,$1B4A1B02,$CB1B1BCB,$031B0B1B,$EB0B031B,$FB1B1B5B,$02F903EC
        long $C8888800,$58787858,$59ACCB99,$0198028B,$E8485800,$02999801,$01598ACB,$58880101,$E8014858,$8BDC5901,$4A4A4A59,$694A4A4A,$38383838,$AC283838,$05AC0504,$99989A9B,$48EC9959,$49E80048,$5A02CBD8,$5ACA5ACA,$DA02CA5A,$DB5ADA5B,$5BDB5ACB,$DB5A1BCB,$1B5BDB5B,$291929F9,$1BDB1B0B,$1BDB1B1B,$0B031B03,$030B1C03,$1B030B1B,$1C5CFB4A,$88585888,$00588888,$ACACBB02,$9B9BACAC,$58008801,$BB02E898,$0102AC8C,$58010101,$99010101,$BB049C03,$4A4A4901,$284A3A4A,$38383838,$CB383838,$AAABAC9C,$01010299,$48BB5AD8,$02025900,$5ACA0202,$CA5A02CA,$5A5ACB02,$02CB5ADA,$DA5A1BDB,$5BDBCB5B,$294A1B1B,$29191929,$1B4A1B1B,$1B5B1BDB,$2C030B0B,$0B030B0B,$0B4B0B03,$1B1B030B
        long $01980101,$8858C848,$9C9A7800,$ACBBACAC,$008801CA,$8B887878,$010102BC,$01010299,$04CB9959,$0159028C,$4A493801,$593A4A4A,$28283838,$59383838,$01999902,$59010148,$024801D8,$02CA4949,$CA5ACA02,$CA02CA5A,$CADA025A,$DB1BCA5B,$1BCBDA5A,$DA1B5B1B,$19192829,$291B2A19,$5B1B1B1B,$031B0B1B,$0B0B2C0B,$0B4B0B4B,$0B0B1B2C,$1C1B0B4B,$01990158,$48880199,$02018888,$8C9CACBB,$0199ACAC,$D80158C8,$01D80101,$99CA8B59,$9B020202,$01010101,$38385801,$285A3A3A,$38383838,$59E80000,$01014898,$D80299D8,$02020259,$02020202,$020202CA,$5ACA0202,$1B5A0202,$5ACB1B5A,$5B1BCB1B,$292902EB,$2A191919,$2B0B2A29,$1B0B1B1B,$0B0B5B1B,$0B0B4B0B,$4B0B030B,$03EC1C0B,$0B1B1B0B
        long $01018888,$48980101,$88885858,$BB8B8B02,$CBEC9A8B,$01010101,$01019959,$0202CBCA,$02029A02,$01015902,$48015902,$283A5948,$00003838,$CB010000,$9901D802,$02024959,$02020202,$0202CA02,$CA5A0202,$021B0202,$5ACA1BDA,$1BCA5ADA,$021B5BCB,$19191929,$2C292A29,$2A2A192A,$1B1B1B0B,$1B2B1B0B,$4B1B0B1B,$1C0B0B0B,$1B0B1C1C,$1CEC1C1B,$01887888,$C8014899,$00000078,$02990188,$8BAC0201,$01990199,$02990101,$9A020202,$02020202,$01E89902,$48480101,$38384800,$38000038,$01484800,$0259029A,$02D859E8,$9A020202,$CA020202,$0202CA02,$5A02CA02,$5A1BCA5A,$DA5B1BCB,$19391A1B,$1A291A19,$2A192C2A,$1A1A2929,$1B1B1B2B,$1B1B0B0B,$1B1B1B1B,$FB4B1B1B,$2C0B0B1C,$0C4C0CEC
        long $9848C800,$00788848,$00000000,$99588800,$98019A02,$01010101,$9A025901,$02029A02,$010202BA,$01480001,$485902D8,$48484848,$00480000,$01000048,$59E99949,$02020259,$CA020202,$5A020202,$CA020202,$DA5A025A,$DA5A5ADA,$2902DB1B,$19191939,$2A2C1A1A,$291A2A19,$1919191A,$0B4B0B1B,$1B1B1B1B,$0B0B2C1B,$2C0B0B4B,$1C2C0CFC,$0C0C1C0C,$58780000,$000000C8,$00000000,$78880158,$01019888,$01990101,$9901E848,$02020202,$78580102,$7B590100,$48480202,$00480048,$48004848,$48480000,$02025948,$029A0202,$02029A02,$02CA0202,$02CA5ACA,$DA1BCA02,$1BDA1B5A,$19192902,$2B1A1919,$292A194B,$19192A29,$19291919,$1B1B1B1B,$0B1B1B1B,$0B4B0B0B,$0B4B1C1C,$1C1C1C2C,$0C0C0C0C
        long $00007800,$00000000,$00000000,$88BB8C99,$99010158,$01019901,$59485848,$0199BA02,$E8580000,$0102D801,$00485801,$38483848,$00000048,$01020100,$02020202,$02020202,$CA020202,$0202CA02,$1B020202,$025A025A,$2949CA1B,$19291919,$291A2C2A,$1A2A292A,$1A191919,$29191919,$1B1B1B2A,$0B031B1B,$030B0B03,$0B0B1B0B,$0C1C1C2C,$0C0C0C0C,$00880088,$00000000,$99880000,$01BB04AC,$010101A8,$01480101,$48484898,$00484801,$9B014848,$E8985801,$48480159,$01484800,$48480048,$020249E8,$0202BA02,$02020202,$02020202,$CA5A0202,$CA5ACA02,$02DACB02,$19192949,$2A2B1929,$29293B29,$191A192A,$19192919,$29191929,$1B1B1B1B,$0B4B0B0B,$2B1B0B4B,$1C1C4B0B,$0C1C1C1C,$0C0C0C0C
        long $78C899D8,$00000000,$CAABBA58,$019999BA,$01990101,$58580199,$48485801,$48007878,$0100D99B,$78480188,$48010101,$48480048,$59E84848,$02BA0202,$029A0202,$029A029A,$CA02CA02,$5A02025A,$02020202,$29390202,$291A1919,$3B4B192A,$1A293A19,$1919191A,$19191919,$29192919,$0B1B1B1B,$0B0B031B,$0B0B1B0B,$1C1C0B0B,$1C0C0C1C,$0C0C0C0C,$78029B9A,$9A018800,$78999BAB,$99014868,$01019901,$88E80101,$48000058,$8802D800,$48485801,$00000058,$38010158,$48484800,$9A020201,$02020202,$0202029A,$02CA0202,$02020202,$0202CA02,$02DA02DA,$1A192929,$2A192A1A,$2A2A1A4B,$19192A1A,$19191919,$19191929,$29191919,$1B1B1B1B,$04EC1B03,$4B0B031B,$1C0B2C0B,$0C1C0C1C,$0C0C0C0C
        long $5899019B,$9B9BCA01,$00008899,$01984888,$99010199,$488BCA02,$00580000,$78010100,$0000C858,$00000000,$58010148,$02590148,$02020202,$02020202,$02020202,$02020202,$02CA0202,$DA020202,$3A294902,$1A3A3A3A,$292A3C1A,$2929293A,$19191919,$19291929,$19291919,$19291928,$1B031B1B,$031B1B1B,$0B4B0B1B,$1C1C4B0B,$0C0C1C1C,$FC0C0C0C,$99019999,$8858999A,$88880000,$9801E888,$BB020101,$4859AC8C,$48000058,$00480158,$00000000,$00000000,$01014848,$BA020202,$02020202,$0259BA02,$02020202,$02020202,$02020202,$294A0202,$05053A29,$2A3B3A05,$292A3A19,$1919193A,$19291919,$18191819,$19181929,$29191819,$1B1BDB1B,$0B1BDB1B,$030B0B03,$1C0B1C0B,$0C0C1C1C,$0C0C0C0C
        long $58A8D859,$00007888,$00880088,$01995988,$7B8B9801,$E8980101,$00000058,$00004858,$00000000,$00000000,$0202D801,$02020202,$99990299,$02025901,$02BA0299,$020202BA,$02020202,$3A3A2AF9,$3A3A3A3A,$3A2A193A,$191A3A1A,$19191919,$19191919,$19281919,$28191818,$29182918,$1B021B1B,$0B031B5B,$0B0B031B,$1C0B0B4B,$2C1C1C0C,$0C0C4C0C,$00789801,$C8000000,$0248C800,$0159CACB,$0198E898,$00010101,$48580101,$00000058,$00000000,$01484800,$BA020202,$99029902,$01490202,$02D85959,$02590202,$02020202,$29020202,$05053A3A,$2A2A2A05,$3A2A293B,$19191929,$29192919,$19192819,$19191829,$19182919,$4A291829,$1B1B1B02,$1B1B0B1B,$4B0B4B03,$1C1C2C0B,$1C1C1C1C,$FC0C0C1C
        long $00880088,$007878C8,$8BAB0201,$99019801,$01010101,$78010101,$5858D801,$48004800,$00004800,$02594800,$59020202,$02020202,$49990202,$020259D8,$02020299,$02020202,$3A290859,$3A3A0505,$293A3B29,$1919293A,$18181819,$18191928,$18182919,$28181919,$29181819,$0A292928,$DB1B1B1B,$030B5B1B,$031B0B0B,$2C2C0B0B,$1C0CFB1C,$04FC0C0C,$58008800,$02D80000,$9801029A,$01019901,$01019901,$88D89998,$01010201,$000000E8,$00000000,$01484848,$02029902,$02990299,$02020299,$02990202,$02990202,$F8019902,$3A3A2A19,$3A043A3A,$29293A19,$2818181A,$19281819,$19291919,$18191818,$19181928,$29282928,$1B02F929,$1B1B5B1B,$1B1B1B1B,$0B0B0B4B,$0B0B0B4B,$0C1C1C2C,$0404040C
        long $58008800,$029B7BD8,$98029A01,$99010198,$02980101,$020102CA,$010188C8,$00484801,$48000000,$585858E8,$02994901,$02020202,$02599902,$02020299,$59020259,$1A182801,$4B191A19,$3A3A183B,$18192A29,$18181818,$19181818,$19182929,$19281918,$29182819,$1A292919,$1B1B4A29,$1B1B1B1B,$0B0B4B0B,$0B4B0B0B,$2C2C0B0B,$04FC1C0B,$05050505,$02D85800,$01019902,$02990299,$01980102,$98019901,$9902AB02,$00000058,$00007848,$48020148,$58000078,$01484848,$02599902,$99020259,$02590202,$38E85999,$18191818,$2A182B2A,$292A192A,$18281818,$18281818,$4A281828,$18291B1B,$19191828,$29291928,$021A2929,$1B1B1B1B,$0B1B1B1B,$4B0B2B1B,$0B0B4B0B,$0B2C0B4B,$04FC041C,$05050505
        long $99020259,$02990101,$CB99028B,$019802BB,$98010101,$48990201,$01590158,$59010088,$00010202,$48480000,$01010048,$D80202D8,$02D85902,$E8029959,$1818F801,$38023918,$29284B4A,$1828182A,$18181818,$18381828,$1B291818,$2A021B1B,$28281829,$08292929,$1B020A29,$1B1B021B,$1B1B1B1B,$0B0B0B0B,$0B4B0B0B,$2C0B2C0B,$FC2C040C,$05050505,$01010199,$CBCB0299,$0202ACBB,$01999A9B,$01980198,$88588858,$00C80101,$D8D87800,$00880088,$00000058,$01484858,$59025959,$02590201,$3838E802,$28283818,$082C0238,$28192A08,$18183818,$18181828,$28181828,$28181818,$EB1B0A4A,$291A291B,$1B292919,$1B4A1B02,$1B1B1B1B,$0B1B1B1B,$4B3B0B2B,$4B0B4B0B,$2C2C0B2C,$4B2B1C2C,$0C1C0404
        long $02999959,$BBBBBBBB,$9BBBACCB,$02BB04AB,$01980199,$48E80198,$58007888,$00680000,$48580058,$00000000,$00485800,$CA990158,$01990201,$18383838,$FC011838,$292A1839,$38382928,$28183818,$18281818,$18183818,$18182818,$1B1B2918,$291A2A4A,$4A0A4A29,$F91B4A0A,$1B1B4A1B,$2B0B0B1B,$0B0B4B0B,$0B2C0B3B,$1C2C2C4B,$3A3A0C1C,$1A1A2A3A,$CBCB5901,$AC8BBB8B,$ACACACAC,$AC059B8B,$98019902,$01015801,$007800C8,$00580058,$58880088,$00004848,$48000048,$49014848,$18480199,$01183838,$0A3839DB,$1829E829,$18383838,$18381818,$18183818,$18181838,$28292928,$1A281918,$1A291A19,$1B020A02,$1B4A0A02,$1B1B1B4A,$4B2B2B1B,$4B2B2B2B,$4B4B4B4B,$1C2C2C2C,$3A2A1C1C,$1A293A3A
        long $8B590158,$ACBB03AB,$ACACAC8B,$AC9BABAC,$01999BAC,$01980198,$00885858,$00580088,$E8485848,$00010248,$00480000,$48484800,$38383838,$E8010238,$29E81A1B,$00384818,$38381838,$38183818,$38381838,$18381818,$19291B49,$1A182929,$2B3C3A3A,$0A4A4A1A,$020A4A4A,$1B1B1B1B,$2B0B1B2B,$4B2B4B0B,$4B2C4B0B,$2C2C4B2C,$3A2A1C4C,$192A3A3A,$02018888,$BB8BAB8B,$ACCBAC8B,$9BABCBCB,$029BBBBB,$58019898,$C8010198,$48885848,$984848C8,$48025901,$48004800,$38480000,$01F83838,$380A0BE8,$38481829,$38180038,$38183838,$38183838,$18181838,$28083949,$294B4A08,$2A192918,$1B3C052A,$4A020A02,$1A29290A,$0C1B1B1B,$2C2B0B0C,$3B3B4B2C,$2C4B3C3C,$4C3C3C4B,$3A2B2C4C,$29293A3A
        long $01880088,$CBCB8B59,$ACACBBAC,$AC8BABAC,$99BB9CAC,$01980102,$48014801,$48E858C8,$01010101,$58E85858,$00000000,$38004800,$1BDB4800,$38F9F948,$384838E8,$38001800,$38001838,$38380018,$38383818,$294B1BF9,$1B1A2918,$2A191829,$0B1C292A,$F91A4A1B,$29192929,$0504FB1A,$0B1C0405,$3C3C2C3B,$04040404,$3C04054B,$3A3A4B3C,$29191A2A,$58888888,$AC8B01A8,$8BBBACAC,$AC05ACAC,$99029BAC,$0101BA01,$01980198,$01585801,$48010101,$017800C8,$00480048,$48000048,$EAEA0000,$483828E8,$38003848,$18003838,$18003838,$18383800,$39084938,$1A4B2928,$4A083918,$19294A1B,$031B1919,$391B1B1B,$19292918,$0404042A,$04050504,$043B4B3C,$05050504,$052A0505,$2A2A3B3C,$4B2B2A29
        long $880058CA,$5A990158,$8CAC8BBB,$9A9BAC05,$BBAB9B9A,$029901CB,$01010158,$01980101,$58584898,$00000078,$48480148,$00480000,$F9E94800,$E8E8C868,$38384858,$00281838,$38003838,$F8381838,$2C1BF828,$1B4AF91A,$1A294A1B,$18391A1A,$0A4A4A29,$194A031B,$19291818,$053A3A2A,$04040504,$05053B3C,$0505052A,$05050505,$1A3A043B,$2A0C4C3A,$00489959,$99E858C8,$ACBBAB01,$9B029A9B,$8BBBCB8B,$99018BAB,$01019802,$01010198,$01019801,$00000048,$01480000,$000048E8,$48484800,$48885848,$38383848,$38283800,$38383800,$38180038,$1B393818,$29021C02,$021BFA02,$4A291A29,$4AF90A4A,$28020A4A,$19281929,$3B3A3A29,$3B3C0C05,$05050505,$05050505,$05050505,$3A3B4B05,$1A1A3B2A
        long $59D94878,$01587878,$019ACA01,$CBAB8B99,$8BCB8BBB,$99DBBBBB,$01010201,$98010101,$48580101,$00480048,$48000048,$38000148,$00480000,$00484848,$F9000038,$38000038,$00E802E8,$18383818,$28081838,$020BDC29,$1B1B021A,$F94A0A02,$1A5A4A1A,$29FC1B02,$29192918,$0C044B19,$3A3B2C2C,$0505053A,$053A0505,$05050505,$3B3C0505,$2B1A2A2B,$9C0278C8,$888800D8,$02AB8B48,$ACACCB02,$AB8BCBBB,$ACBB8BCB,$019A0102,$01010101,$58E84801,$000058C8,$00000000,$00480100,$00480000,$38004848,$48002808,$E8494800,$38380202,$38183800,$392828F8,$FB1B39F9,$F94A2902,$1B4A291A,$1B1AF94A,$4A0404EC,$19292929,$2B0B0C2A,$3A3A2A3B,$053B0505,$05050505,$05053B05,$2C4C0505,$FC1C2C2C
        long $01000101,$4888028B,$9C9A4898,$BB9B029A,$BBBBBBBB,$8BBBBB8B,$BBCA9902,$01019802,$88019848,$00785858,$00480048,$00010158,$48003800,$00384848,$380038E8,$01CBD848,$383838E8,$F83818F8,$F9392828,$1B02F949,$4A0A1A4A,$0A4A0A4A,$4A021B02,$F98C04DC,$1B291928,$2A2B0B0B,$3A3A3A2A,$05050505,$05050505,$05050505,$2C2C4B3B,$05040C2C,$880199CA,$5899CBE8,$9B0148C8,$9B599BBC,$CBBBACCB,$AC8BABBB,$040202AB,$01019A9C,$48580148,$0000C858,$00000000,$01010000,$38385848,$00083800,$D8480000,$48E8E802,$38E83848,$01283838,$49390239,$1A294AF9,$1A4A4AF9,$4A1A02F9,$180B0C1B,$1B8CDB29,$1B1B1B29,$2A1A1A1B,$3A3A3A2A,$05050505,$05050505,$052A0505,$0C4C3C3B,$05050404
        long $0102CB9C,$AB030188,$8858C858,$029BAC02,$AB8BCB8A,$04AC0202,$9B9ABB04,$0199CBAC,$E8585898,$00587848,$00480058,$48000058,$F902E801,$48000000,$48480201,$E8C99AC8,$F8383848,$4949F801,$49F939F9,$0229F949,$4AF92902,$FB1B4A4A,$181B0CEC,$DB4A1818,$F91B5ACB,$1A1A1A1A,$053A3A29,$3B053A3A,$2A050505,$3B052A05,$FC05044C,$04050504,$BABBBCBC,$CB588801,$48C858BB,$AB9CBA88,$ACAC0202,$AC05ACAC,$59CBAB8B,$01029902,$58980148,$58004858,$48000000,$00000000,$48E83858,$02E84800,$5848D9CA,$AC05ACC9,$01F8E8E8,$F85949F8,$39390249,$4AF94A1A,$4A1A1B1B,$DB0B0BFA,$292CFC1B,$4A181818,$291A021B,$2A192929,$2A043B3B,$0505053A,$052A0505,$05052A05,$04040405,$050504FC
        long $DC8C8CBC,$5888D802,$5801BB02,$9C994898,$05AB9ABB,$ABABAC05,$998BABBB,$484859D8,$48010198,$00584898,$00005858,$D859E800,$48000048,$01020202,$58480048,$9BABACD9,$490159D9,$4949F849,$02F93949,$29493939,$EB1B4AF9,$1C040403,$F92A1C1B,$0A4A2839,$0BEC0BDB,$2B1A1A1A,$044B4B0C,$05053A05,$2A3A053A,$04050505,$05050505,$0504FC05,$048C8C8C,$58D89A9C,$02BB5988,$99480188,$AC9A0202,$BBBBAC9B,$03D8029B,$01A859AB,$01485801,$E899E801,$00580000,$00010178,$02024848,$005801CA,$02D80148,$CACACAD8,$59F859CA,$49F84901,$F93939E9,$02F9F902,$1B4AF94A,$0C04EC1B,$020A291B,$1B021A1B,$048C045C,$291A192B,$3C2A292A,$053A3B4B,$05050505,$05050404,$040C0C04,$0CFC0405
        long $8C8C04BC,$99CA8C04,$CA59C848,$48019801,$99990298,$019AABAB,$02010101,$0102CAAB,$48980158,$01594858,$48005858,$01000000,$01020202,$48580058,$02021B02,$CACAA902,$F859E859,$49490149,$39023939,$4A494A39,$021A4A0A,$1A0A1B1B,$1B4A020A,$8CEC0B02,$ECBCBCCC,$191A1A2A,$043B2B1A,$3A2A3B3C,$0404053A,$05043C04,$0504FC04,$1B0BFC05,$048C8C8C,$CB8C0404,$01880199,$A801CABB,$59029801,$01010102,$01019858,$ACAC9B01,$48489802,$58980198,$58005858,$02004800,$58E89902,$E8004800,$CA020202,$010102CA,$590159E8,$49E949F8,$39F90249,$1C1BF939,$29021BDB,$4A1B021B,$1B1B4A02,$EC8C8CFC,$CCCCCCCC,$2A19191A,$2A2A3B2A,$4B3B3B2B,$043C3C4B,$FC0C0C05,$04050505,$1A1A1B1C
        long $04040404,$8C048C8C,$880199CB,$01ABBB01,$D8980101,$88588801,$02590158,$BBAC0299,$9801019B,$E8484801,$88E84858,$58000058,$78484800,$78484800,$49028BE8,$F8010101,$49F80159,$49494959,$394928E9,$030303DA,$1B021B1B,$0A4A1BF9,$ECDCFA4A,$BCCCEC8C,$CCCCBCCC,$2A2B2A0A,$1A1A1A2B,$3C2C3B2A,$05040505,$1C2C0C05,$1B1C04FC,$DB1B1A1A,$048C048C,$8C048C04,$0199DB8C,$ABBB0188,$01010198,$88889999,$01889801,$02010159,$48CA8CAC,$58489858,$48014898,$00008858,$58480088,$48485858,$0101E801,$01590101,$01594901,$F849F849,$CB020249,$1B0B031B,$021A4A02,$1B02294A,$EC8CECEB,$ECCCCCCC,$BCDCDCBC,$1A1A2A1B,$1A1A1919,$0C1C1C2A,$04040404,$1C0C0505,$1A1A2B0B,$0B1B1B1B
        long $04059C04,$048C0404,$BADB048C,$8B585801,$9A9901CA,$000098BA,$01588858,$98990101,$9ACABB9B,$01980101,$58E85801,$485848E8,$58005848,$01014848,$01010101,$59E80101,$02F85949,$02025901,$0303EB49,$39020203,$4A29F94A,$CC0B1B0A,$CCCCDBEB,$CCCCECCC,$DCCBEADB,$19191A0B,$1A19291A,$FC05041B,$1C0B0B0B,$2B0C0404,$1B1A1A0A,$0B1B1B1B,$9C05058C,$8C048C05,$BB8C8C04,$48989902,$99BA9B59,$99985888,$485800C8,$01494888,$ACAC0258,$014801AB,$01589801,$58C84858,$01480000,$010101E8,$01010101,$02590101,$5959D849,$03CB49F8,$02DB5BDB,$0229F91B,$1B024AF9,$DA03DCDB,$DA1B024A,$DBBCCCDC,$DB1B390A,$29291829,$2A2A1A19,$0505FC1B,$0B2C0C05,$1A1A0B0B,$1B1B4A1A,$1B0B1B1B
        long $059C0504,$048C059C,$8C8C048C,$9A01D9AC,$019AAABA,$C899BA99,$88C87800,$01010148,$9A015859,$9802ABCB,$58010148,$48010198,$01010101,$E8010101,$E8590101,$01E82801,$D8594949,$5BDA4949,$39021BDA,$29020239,$DC0B0249,$49F902DB,$CCDCFA0A,$F9DBEBDC,$EBDA1A49,$2A1A29F9,$FC050B2A,$FC040504,$1B0B0505,$4A1A291A,$020A1B0A,$1B1B1B1B,$05050504,$8C05AC05,$8C048C04,$BA029C8C,$9B025899,$780098BA,$0078A9A9,$88589858,$590159D8,$01AB9CAB,$E8984898,$01010101,$01010101,$01010101,$5901E801,$E8383838,$59490201,$025A4959,$02024949,$021A49F9,$DABBDC0B,$DB1B0202,$0404CCAC,$1BEC0405,$031B4AF9,$0B1BF91B,$0504FCFC,$0B0BFC05,$1A1B0B0B,$0A4A1A29,$1B1B4A49,$1B1B1B1B
        long $05AC059C,$0404059C,$048C048C,$029C8C8C,$A8BAAAD8,$BA990102,$C8007899,$00005898,$01AB0201,$ACBB0201,$0158018B,$01010101,$01010101,$01010101,$E8010101,$28383848,$49D80138,$020249E9,$39390249,$9CDA0249,$4A02DADB,$04DCDB02,$BCDC9C04,$0C050504,$DCEB1B0B,$04CC5B1B,$FC040505,$1B0B0504,$291A294A,$4AF91B29,$021A0A1B,$1B1B1B0A,$AC050505,$8C049C05,$8C8C0404,$BC8C8C04,$88989ACA,$88BABAAA,$99A9C800,$58480088,$019A0248,$9ACB0158,$01019BCA,$01010101,$01010101,$01010101,$01010101,$38480038,$59012838,$49494949,$024949E9,$0203BBDB,$DA020202,$0504DCEB,$DCDCEB04,$0505058C,$DCEC4C05,$0504FCEB,$05050505,$1A020BFC,$021AF929,$0A4A1A0A,$2B024A1A,$1B1B1B02
        long $0505AC05,$059C0505,$048C049C,$8C8C8C9C,$BA59CA8C,$999998AA,$88989A99,$00007800,$48010188,$59019801,$999C8CCB,$01010101,$01010101,$01010101,$01010101,$38484838,$E82838E8,$4949D859,$DBDA0249,$020202CB,$8CEB0202,$04CCBCCC,$048C0405,$0BBC8C04,$ECFC2B2A,$040505EC,$EC040505,$291A291B,$29294AF9,$021A02F9,$0A1B0A1A,$1B1B1B2B,$05AC0505,$059C05AC,$8C8C048C,$8C8C8C04,$99CBCC8C,$BABA4801,$000058A9,$00000000,$01985888,$01580101,$5902CB02,$98010101,$01010101,$01010101,$01E85901,$48380048,$28383838,$02E84901,$02ABCBCA,$02E94902,$050403DA,$DC03DBDC,$0405058C,$1829EBBC,$EB2B1918,$0505050C,$29EB8C05,$4AF91A1A,$0A020A29,$1A021A4A,$4A0A4A02,$1B0A1B0A
        long $AC0505AC,$9C05AC05,$04048C04,$8C048C8C,$CBBCBC8C,$889ABA02,$00010201,$00780078,$980101C8,$98019801,$01980148,$01010101,$01010101,$01010101,$59010101,$48484802,$59E83848,$CB0259E8,$0202028B,$BCAC02D8,$0504ACAC,$BCECCC04,$CBACBC04,$1828F929,$291A1919,$8C04CC1B,$1A291AEB,$4A1A491A,$4A1A29F9,$4A1A1AF9,$0A4A0A1A,$1B1B1B1B,$05AC0505,$8C0505AC,$8C048C04,$8C8C048C,$BCBC8C8C,$C80102AB,$98CA9958,$58008800,$01010158,$01010101,$01010101,$01010101,$01010101,$01010101,$DC020201,$00004802,$590101E8,$02ABBB02,$02D902D8,$8C05BCCA,$8CDCDBCB,$8C040404,$18F9CBDC,$18292908,$29292819,$0A1B1B1B,$F9292929,$F94A1A29,$F9024A1A,$0A021B4A,$1B0A1B1B,$1B1B1B1B
        long $0505AC04,$05ACAC05,$049C04AC,$048C8C8C,$8C8C8CCC,$0102BBCC,$CA015858,$C8580002,$01980148,$01010101,$01019801,$01010101,$01010101,$02010101,$CAABCB8B,$38380001,$BB025938,$E80102BB,$02029B02,$040505BB,$BCACBCBB,$CB9C8C04,$183939F9,$18182818,$1A292918,$291A291A,$4AF91A1A,$1A290A29,$2A1A1A02,$4A1A1A1A,$1B1B1B1A,$FA1B1B1B,$05AC0505,$05AC05AC,$048C049C,$8C8C048C,$8CCC8C8C,$02ACBCBC,$01489801,$48585801,$01010101,$01010198,$01010101,$01010101,$01010101,$02BBCA59,$01598BCB,$38380101,$ABBBCAE8,$3801D8BA,$02BA02CA,$0504BB02,$8C8C8C04,$2802DAAC,$28290818,$18181818,$F9292918,$1A291A29,$1A4A1A29,$4A1A0229,$020A4A1A,$1B0A4A1B,$1B1B1A1B,$0B1B0A1B
        long $AC0505AC,$AC05AC05,$8C049C05,$8C8C8C8C,$8C8C8C04,$DCACBC8C,$5801D89A,$98010199,$01019801,$01010101,$01019801,$01010101,$01010101,$9BBB8C02,$01010101,$28E80101,$9BABAB8B,$D8029BCA,$0239D859,$ACBB9BCA,$CBBC0404,$39F83902,$18181828,$28181828,$2929F918,$291A1AF9,$1A1A290A,$1A291A0A,$1A4AF91A,$1A4A0A1A,$0A1B1B1B,$1B1B1B1B,$05AC0505,$05AC05AC,$9C8C8C8C,$8C8C8C04,$BCCC9C9C,$ACAC9C9C,$01995ADC,$01BA0201,$01010101,$01980198,$01010101,$01010101,$01CA0201,$01020201,$38580101,$02383801,$CAABAB9C,$ABCA9B9B,$2C4938D8,$BBABCA2C,$F802CABB,$28081838,$29281818,$18181839,$1A392919,$F9494A29,$4A1A4A1A,$020A4A29,$1A1B4A0A,$1B0A021B,$1B1B1B1B,$0B1B1B1B
        long $AC05AC8C,$AC05AC05,$048C058C,$8C8C8C9C,$9C9C9CBC,$ACAC9CBC,$59CABBAC,$CA7B01A8,$01019801,$01010101,$01010198,$99019801,$59AC8C02,$01010101,$E8780101,$02014849,$ABBBABBB,$ABAB9BCA,$4AE80102,$BB8C044C,$59180102,$183818F8,$28182828,$18181808,$1A1A2929,$4A1AF91A,$1AF91A29,$1A02290A,$1B1A0A4A,$1B1B1B1A,$1B0A1B0A,$0B0B0B1B,$05AC0505,$05AC05AC,$AC048CAC,$8C8C8C04,$8C8C8C8C,$BC9CBCBC,$CA9C9C9C,$9A010102,$0198029C,$01019801,$01980101,$BCCB9901,$01029AAC,$01010101,$0101E801,$CA38E802,$9AABABBB,$CBAB0202,$F801D802,$BA05041B,$E83838E8,$38181838,$181838F9,$39182818,$1A49F9F9,$1A291A49,$021A4AF9,$0A1A1B1A,$0A4A1A4A,$1B1B1A1B,$0B1B2B1B,$0B0B1B1B
        long $AC05ACAC,$9C05AC05,$8C8C048C,$8C048C8C,$8CCC8C8C,$9CBCBC8C,$ACACDC9C,$010102CA,$99BB9C02,$01010101,$01010101,$CAAC5ACB,$01010159,$01015858,$028C0201,$02380139,$01029BBB,$BBABCA48,$59D8029A,$3802DC02,$38183801,$18380128,$38183828,$29391818,$29F94A49,$290A491A,$1A4A1A4A,$4A1A4A1A,$4A0A1B0A,$1B1B1B1B,$1B1B1B1B,$0B0B0B0B,$05AC0505,$ACAC05AC,$8C9C9C04,$BC9C8C8C,$9C9CBC8C,$DCAC9C9C,$ACBBACAC,$01D9AB9C,$9C9C9901,$01980102,$9ACAAB01,$0199CB8C,$01010101,$01000001,$CB5AE801,$02383802,$4801BABB,$BBBB9AE8,$029B9B02,$38E8CBCA,$383838F8,$381801F8,$18381818,$39F93928,$02291A1A,$021A4AF9,$1A290AF9,$4A0A0A02,$1B1B4A0A,$1B1B1B0A,$0B1B1B1B,$0B0B0B0B
        long $AC059C8C,$05ACAC05,$9C049CAC,$8C8C8C8C,$BCBC8C8C,$AC9C9C9C,$ACBBACAC,$02BBACAC,$BB590199,$0199BB8C,$028C9C9C,$01019859,$D8010101,$48005802,$01010158,$0238E849,$4801018B,$ACBB0299,$990202AA,$38018B49,$3801E838,$38381838,$49183838,$1A49F939,$2949F939,$4AF91A4A,$021A021A,$0A024A1A,$020A0A4A,$1B1B1B1B,$1B0B1B1B,$030B0B0B,$AC059C04,$9CAC05AC,$049CAC05,$8C8C8C8C,$BC8C8CCC,$9C9C9C9C,$BBAC9CAC,$BBACACAC,$9901D802,$9A8C04AC,$0102BBBB,$01010101,$01010101,$00580159,$01384800,$02483859,$01E898D9,$ACBB9BD9,$E802D8CA,$0049CA48,$38E83838,$18383838,$F949F818,$021A4949,$F902F939,$1A4AF939,$4A0A4AF9,$0A4A0A0A,$1B1B021B,$1B1B1B1B,$0B0B1BEB,$1C0B030B
        long $9C9C059C,$8C05AC05,$9C8C8C9C,$8C8C8C8C,$9C9C8C8C,$9C9CAC9C,$ACDCACAC,$ACACBBAC,$01D802BB,$8C04AB01,$0158019A,$01010101,$01010101,$380158C8,$E8480048,$0200E859,$029801AB,$BBACAB9A,$484801AB,$38020248,$38383838,$01383838,$39024949,$F949F939,$F9494902,$49F9024A,$0A021A02,$021B024A,$1B022B0A,$1BDB1BEA,$0BDB0B1B,$DCDC0B0B,$05AC059C,$8CAC9C9C,$8C8C049C,$8C8C8C8C,$9CBC8C8C,$9C9CACAC,$ACACAC9C,$CBACACAC,$019BCBBB,$8CCA0101,$9801AB04,$01010101,$01010198,$01580058,$48004848,$59485801,$9B029B9B,$ABBBACBB,$00480102,$38CAD848,$38003800,$F949F838,$4949F949,$393902F9,$0229F949,$024AF949,$4A0A0229,$1B0A0A02,$1B1BDA4A,$1B1B1B1B,$031B03EB,$DCEB03EB
        long $AC05AC04,$8C9C059C,$8C9CAC8C,$BC8CCC8C,$AC9C9C9C,$BBACACAC,$BBACACAC,$BBCBACBB,$02BBACBB,$02980199,$99AC8C9C,$01010101,$01010101,$58005801,$007848E8,$D8004800,$ABABABBB,$D89BABBB,$48485801,$48CA4948,$F8380038,$59F84901,$49E94949,$F9023949,$F9024902,$02F90249,$02F9020A,$1B02020A,$DA1B4ADA,$DBDBDA1B,$EB030BDB,$EB03DC03,$05ACAC04,$9C04ACAC,$8C8C8C8C,$9C8C8C8C,$9C9C9C9C,$ACACACBB,$ACACACAC,$BBACBBAC,$CBBBBBAC,$985999CA,$AC04BC02,$01990102,$01010101,$00480101,$48E80158,$01484848,$ABBBABBB,$7801D89B,$48004800,$D802E848,$4901E848,$F849F849,$F9494949,$0239E949,$023949F9,$4A020229,$02024A02,$021B1B02,$1B02DA1B,$1B5B1BCB,$EB03DBDB,$0303EB03
        long $AC9C05AC,$8C9C8C04,$8C8C8C8C,$8C9C8CBC,$9C9C9CBC,$ACACBBAC,$BBBBACAC,$BBBBACAC,$BBCBBBBB,$01E9CB03,$8CAC9901,$CB8C8C9C,$01019899,$48014801,$01018858,$01480048,$D89BABBB,$00486858,$48484858,$495901E8,$49494901,$494949D8,$4949E949,$39023902,$02F90249,$02F902F9,$020A02F9,$021B021B,$CA1B1BDA,$DBDBCB1B,$03DBDB5B,$BBDCBBDB,$04AC9C05,$8C8C8C9C,$8C8C8C8C,$9C9C9C8C,$AC9C9C9C,$BBACACAC,$ACACBBAC,$ACBBBBAC,$ABCBBBBB,$BA8B8BCB,$ACD80101,$8C048C8C,$010159AC,$99010198,$010058E8,$48000101,$4848BACA,$48000000,$01E85858,$D8590159,$D8014949,$49D84949,$024949E9,$E90202F8,$02020202,$02020202,$02021B02,$DA02EA02,$1BCA1B1B,$DBDB1BCB,$CB03CBDB,$CBCBDB03
        long $AC048C8C,$8C9C048C,$8CBC8C8C,$9C9C9C9C,$ACACAC9C,$ACACACAC,$BBACACAC,$BBBBACBB,$CBBBBBAC,$5ABBBBBB,$01010102,$8C8C8CBB,$02BAAC8C,$0202029A,$58010102,$58005848,$78004801,$48484800,$010101E8,$59F859F8,$4949D801,$4949D849,$49E94949,$49F94949,$F9023902,$0202F902,$020A0202,$1B1B021B,$DA5BCA5A,$5BCBCBCB,$CBCBCBCB,$BBBBBBCB,$048C8C04,$8C8C9CAC,$9C8CBC8C,$9C9C9CBC,$ACACACAC,$ACBBACAC,$ACACBBBB,$BBACBBBB,$BBBBBBBB,$BBBBBBBB,$9901BACB,$8C8CBB01,$9CBBAC8C,$9A99BA02,$01CB9ACA,$00480058,$48487800,$48E84858,$59495901,$4959D859,$49D85949,$D84949D8,$E9495902,$02024902,$02020202,$02020202,$DA02020A,$CA02CB02,$5BCA1BCB,$DACA5BCA,$CA8BCBCB,$BBBBCB8B
        long $AC8C049C,$8C8C8C04,$9C9C9C8C,$AC9C9C9C,$ACACACAC,$ACACACBB,$ACBBACAC,$BBBBACBB,$BBBBABCB,$CBCBABCB,$D802BB8B,$9C9B0101,$BBBCAB8C,$029A0202,$02BB599A,$00005848,$88480058,$D80198E8,$D859D849,$D8495949,$4959E959,$4902D849,$4902E949,$E94902E9,$F9020249,$020A0202,$0202DA02,$1BCA02CB,$02CB5ACA,$CB5ADACB,$CBCBCA5A,$CB8BCBCA,$048C0404,$8C8C8C8C,$BC8C8C8C,$9C9C9C9C,$ACACAC9C,$BBACACAC,$BBACBBAC,$BBACBBAC,$CBCBCBAC,$ABCBCBBB,$9A03CBCB,$0201D859,$9CCCBBAC,$AABB8CBC,$ABAB0202,$4848E801,$E8010101,$49024901,$49024902,$02E94902,$E9490249,$E9494902,$02490202,$02020202,$02020202,$02020202,$DA5B02CB,$CB5BDA1B,$DACBDA5A,$8BCBCB5A,$8BCBCBCB,$ABCB8BCB