{********************************
 *   Rem Space Battle game v010 *
 ********************************


}

CON

  _clkmode = xtal1 + pll8x  ' ?
  _xinfreq = 10_000_000 + 0000 ' Set to 10Mhz and add 5000 to fix crystal imperfection of hydra prototype
 _stack = ($300 - 200) >> 2             'accomodate display memory and stack

  x_tiles = 16 ' Number of horizontal tiles (each tile is 16x16), so this means 256 pixel
  y_tiles = 12 ' Number of vertical tiles, this means 192 pixel. Resolution is 256x192.

  paramcount = 14
  SCANLINE_BUFFER = $7F00
  vertical_scroll = SCANLINE_BUFFER-8
  horizontal_scroll = SCANLINE_BUFFER-12
  top_y = SCANLINE_BUFFER-16
  bottom_y = SCANLINE_BUFFER-20
  
  sprite_x = SCANLINE_BUFFER-24
  sprite_y = SCANLINE_BUFFER-28
  sprite_w = SCANLINE_BUFFER-32
  sprite_h = SCANLINE_BUFFER-36
  sprite_pixel = SCANLINE_BUFFER-40

  sprite2_x = SCANLINE_BUFFER-44
  sprite2_y = SCANLINE_BUFFER-48
  sprite2_w = SCANLINE_BUFFER-52
  sprite2_h = SCANLINE_BUFFER-56
  sprite2_pixel = SCANLINE_BUFFER-60

  MAPSIZEX = 32
  MAPSIZEY = 88

  NES_RIGHT  = %00000001
  NES_LEFT   = %00000010
  NES_DOWN   = %00000100
  NES_UP     = %00001000
  NES_START  = %00010000
  NES_SELECT = %00100000
  NES_B      = %01000000
  NES_A      = %10000000

VAR
  long tv_status      '0/1/2 = off/visible/invisible           read-only
  long tv_enable      '0/? = off/on                            write-only
  long tv_pins        '%ppmmm = pins                           write-only
  long tv_mode        '%ccinp = chroma,interlace,ntsc/pal,swap write-only
  long tv_screen      'pointer to screen (words)               write-only
  long tv_colors      'pointer to colors (longs)               write-only               
  long tv_hc          'horizontal cells                        write-only
  long tv_vc          'vertical cells                          write-only
  long tv_hx          'horizontal cell expansion               write-only
  long tv_vx          'vertical cell expansion                 write-only
  long tv_ho          'horizontal offset                       write-only
  long tv_vo          'vertical offset                         write-only
  long tv_broadcast   'broadcast frequency (Hz)                write-only
  long tv_auralcog    'aural fm cog                            write-only

  ' param for rem_engine:
  long tilemap_adr
  long tiles_adr
  long tv_status_adr
  long colors_adr
  long gamepad
  long cog_number
  long cog_total
  
  long mousex, mousey
  long colors[64]
  word screen[x_tiles * y_tiles]

  long temp1
  long temp2
  byte previous
  byte tile
  long framecount

OBJ

  tv    : "rem_tv_012.spin"
  mouse : "mouse_iso_010.spin"
  rem   : "rem_spacebattle_asm_012.spin"


PUB start      | i, j, k, kk, dx, dy, pp, pq, rr, numx, numchr
  DIRA[0] := 1
  outa[0] := 0

  longfill(@colors, $02020202, 1)

  'start tv
  longmove(@tv_status, @tvparams, paramcount)
  tv_colors := @colors
  tv.start(@tv_status)

  'init tile screen
  ' screen is defined as a 2D array of tile(x,y), each value being a 10-bit memory address divided by 64 (>>6)
  ' (each tile using 16x16x2bpp = 64 bytes per tile)
  ' and a color-table entry from 0..63 shifted by <<10

  repeat dx from 0 to x_tiles * y_tiles
    screen[dx] := SCANLINE_BUFFER >> 6 + dx

  repeat dx from 0 to 255
    byte[SCANLINE_BUFFER][dx] := $0A + ((dx & $F) << 4)

  ' perform a delay before setting the colors, this prevent a flickering screen
  ' when TV sync with signal
  repeat 160000
  mouse.start(2)

  tilemap_adr := @tilemap
  tiles_adr := @tile000
  tv_status_adr := @tv_status
  colors_adr := @colors
  cog_number := 0
  cog_total := 4
  rem.start(@tilemap_adr)
  repeat 10000 ' Allow each time for first cog to boot up before setting 'cog_number' again
  cog_number := 1
  rem.start(@tilemap_adr)
  repeat 10000 ' Allow each time for first cog to boot up before setting 'cog_number' again
  cog_number := 2
  rem.start(@tilemap_adr)
  repeat 10000 ' Allow each time for first cog to boot up before setting 'cog_number' again
  cog_number := 3
  rem.start(@tilemap_adr)

  long[top_y] := 17
  long[bottom_y] := 175

  long[sprite_x] := 120
  long[sprite_y] := 100
  long[sprite_w] := 64
  long[sprite_h] := 56
  long[sprite_pixel] := @spri000
  {
  long[sprite2_x] := 120
  long[sprite2_y] := 100
  long[sprite2_w] := 64
  long[sprite2_h] := 56
  long[sprite2_pixel] := @spri000}

  ' Start of main loop here
  repeat
    gamepad := NES_Read_Gamepad
    temp2 := mouse.delta_x
    mousex := mousex + temp2 #> 0 <# 255
    temp1 := -mouse.delta_y
    mousey := mousey + temp1 #> 0 <# 191

    if(mouse.button(0)&1)
      long[top_y] := long[top_y] + temp1 #> 0 <# 192
      long[bottom_y] := 192 - long[top_y]
    elseif(mouse.button(1)&1)
      long[vertical_scroll] += temp1
      long[horizontal_scroll] := long[horizontal_scroll] + temp2 #> 0 <# CONSTANT(MAPSIZEX*16 - 256)
    else
      long[sprite_x] += temp2
      long[sprite_y] += temp1

    repeat while tv_status == 1

    repeat
      {temp1 := long[SCANLINE_BUFFER-4]
      if(temp1 == 100)
        byte[SCANLINE_BUFFER][40] := $07
      else
        byte[SCANLINE_BUFFER][40] := $02}
    while tv_status == 2

'end of main
'---------------------------------------------

PUB NES_Read_Gamepad : nes_bits   |       i

DIRA [3] := 1 ' output
DIRA [4] := 1 ' output
DIRA [5] := 0 ' input
DIRA [6] := 0 ' input

OUTA [3] := 0 ' JOY_CLK = 0
OUTA [4] := 0 ' JOY_SH/LDn = 0
OUTA [4] := 1 ' JOY_SH/LDn = 1
OUTA [4] := 0 ' JOY_SH/LDn = 0
nes_bits := 0
nes_bits := INA[5] | (INA[6] << 8)

repeat i from 0 to 6
  OUTA [3] := 1 ' JOY_CLK = 1
  OUTA [3] := 0 ' JOY_CLK = 0
  nes_bits := (nes_bits << 1)
  nes_bits := nes_bits | INA[5] | (INA[6] << 8)

nes_bits := (!nes_bits & $FFFF)
' End NES Game Paddle Read
' //////////////////////////////////////////////////////////////////       


DAT

tvparams                long    0               'status
                        long    1               'enable
                        long    %011_0000       'pins
                        long    %0000           'mode
                        long    0               'screen
                        long    0               'colors
                        long    x_tiles         'hc
                        long    y_tiles         'vc
                        long    10              'hx
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    60_000_000'_xinfreq<<4  'broadcast
                        long    0               'auralcog

tilemap                 
toptilemap    byte 61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76
bottomtilemap byte 61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76

tilemap000  byte 50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50
tilemap001  byte 50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50
tilemap002  byte 50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50
tilemap003  byte 50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50
tilemap004  byte 50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50
tilemap005  byte 50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50
tilemap006  byte 50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50
tilemap007  byte 50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50
tilemap008  byte 50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50
tilemap009  byte 50,50,50,50,50,50,50,50,50,50,00,01,02,03,04,05,06,07,08,09,50,50,50,50,50,50,50,50,50,50,50,50
tilemap010  byte 50,50,50,50,50,50,50,50,50,50,10,11,12,13,14,15,16,17,18,19,50,50,50,50,50,50,50,50,50,50,50,50
tilemap011  byte 50,50,50,50,50,50,50,50,50,50,20,21,22,23,24,25,26,27,28,29,50,50,50,50,50,50,50,50,50,50,50,50
tilemap012  byte 50,50,50,50,50,50,50,50,50,50,30,31,32,33,34,35,36,37,38,39,50,50,50,50,50,50,50,50,50,50,50,50
tilemap013  byte 50,50,50,50,50,50,50,50,50,50,40,41,42,43,44,45,46,47,48,49,50,50,50,50,50,50,50,50,50,50,50,50
tilemap014  byte 50,50,50,50,50,50,50,50,50,50,50,51,52,53,54,55,56,57,58,59,50,50,50,50,50,50,50,50,50,50,50,50
tilemap015  byte 50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50
tilemap016  byte 50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50
tilemap017  byte 50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50
tilemap018  byte 50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50
tilemap019  byte 50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50
tilemap020  byte 50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50
tilemap021  byte 50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50
tilemap022  byte 50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50
tilemap023  byte 50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50

            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,50,50,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,50,50,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,50,50,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,50,50,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,50,50,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,50,50,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,50,50,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,60,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,60,60,60,50,50,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60
            byte 60,50,50,50,50,50,50,50,50,50,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60

tile000 long $00005800,$00000000,$00583848,$00003838,$00000000,$00000000,$68004868,$68006800
        long $00000000,$00000000,$48586800,$00000000,$58000000,$00480000,$68006800,$00000000
        long $00000000,$49010000,$00004838,$00000000,$00000000,$59000000,$00000059,$00000068
        long $00000000,$5A8B0088,$00000000,$00000000,$00000000,$68000058,$69010000,$00000000
        long $00000000,$58880000,$00006800,$00000000,$00486858,$01880000,$00000000,$00000000
        long $00000000,$68004848,$00000000,$00000000,$00000068,$78005848,$00000000,$00000068
        long $00000048,$00000000,$68000000,$68000000,$00000000,$00000000,$00000000,$00680000
        long $00000000,$00017800,$00004848,$00000000,$00000000,$48486800,$00006848,$00000000
tile001 long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00680000,$00000000,$00000000,$00000000,$00000000,$00006800,$00000000,$00000000
        long $00680000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00680068,$00000000,$00000000,$00000000,$68680000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000068,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$68000000,$00006838
tile002 long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00006800,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000068,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00004868,$00000000,$00000000,$00000000
        long $00683800,$00000000,$00000000,$00000000,$00683848,$00000000,$00000000,$00000000
        long $68380068,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $38593800,$00000000,$00000000,$00000000,$59484800,$00006838,$00000000,$00000000
        long $58006800,$00000068,$00000000,$00000000,$00680000,$00000000,$00000000,$00000000
tile003 long $48480000,$00000000,$00003868,$00006800,$68000000,$00684800,$00484848,$00000000
        long $00680000,$00004848,$00000068,$48000000,$48000000,$48484800,$00484800,$48680000
        long $00000000,$00004868,$38680048,$58000000,$00006800,$48000000,$00480000,$00006800
        long $00000000,$00680000,$00004800,$00480048,$00000000,$00000000,$00000000,$48004868
        long $00000000,$48000000,$00480000,$58480000,$00000000,$00000000,$48000000,$48000000
        long $00004800,$00000000,$00480000,$00484800,$00004848,$48480000,$48004800,$48480000
        long $48000048,$00000048,$38383838,$48484848,$48000000,$48000000,$38383800,$48000048
        long $00000068,$00000000,$38480000,$48384868,$00000000,$00000000,$48680000,$48383848
tile004 long $00000000,$00000048,$00000000,$48486800,$68484800,$48000000,$48000000,$48484800
        long $00683838,$00004848,$68004800,$48483800,$00004838,$00484868,$00480000,$00484848
        long $00486848,$00480000,$48480048,$38383848,$00004848,$68000048,$00484848,$68483858
        long $38480048,$00486848,$48000000,$48486848,$48004838,$48480068,$00486848,$48484800
        long $38484848,$00000000,$68004800,$38484848,$48484868,$00000048,$00480048,$68000048
        long $00684848,$00480000,$38484848,$48480048,$48380048,$48480048,$48483800,$48004848
        long $48484848,$38384848,$48004838,$00484800,$48004800,$38383848,$00483848,$00480000
        long $38484848,$48010101,$48480068,$48004800,$59483848,$38015959,$48486848,$5B014848
tile005 long $00000048,$00000000,$68480048,$00004800,$00680000,$00000048,$00004800,$00680048
        long $00000000,$48006800,$00480000,$00484868,$48000000,$00480000,$00486800,$00006800
        long $00000000,$00000000,$48000000,$48680000,$00004858,$00000000,$00480048,$00484800
        long $00004838,$00000000,$48480000,$48004838,$00003838,$00480000,$48004800,$48000048
        long $00000048,$48000000,$68000000,$00000048,$00000058,$00000000,$48004800,$00004800
        long $00000048,$48004800,$00480000,$00004848,$48000000,$00000000,$00000048,$00004800
        long $00000048,$00484800,$00484800,$38484848,$38380000,$38383838,$49590101,$02494949
        long $5A020201,$048CDC03,$04040404,$05040505,$BCEC5CDC,$5B030303,$5902021B,$01480101
tile006 long $48480000,$38004800,$48000001,$00680000,$00000048,$48006800,$68003828,$00004800
        long $68380000,$00000000,$00000000,$48000038,$00480000,$00000048,$00480000,$00004838
        long $00000038,$00000000,$48004800,$48004800,$48000000,$48000000,$68480000,$00480048
        long $00484800,$00004800,$00004800,$00004848,$48000000,$00000000,$00480000,$00484800
        long $00480000,$00000000,$00000048,$48000048,$00480068,$00480000,$48000000,$48484800
        long $48004800,$48000000,$00484800,$48000048,$00480000,$00004800,$48480000,$00480000
        long $38483838,$38383848,$28012828,$39492849,$5B020202,$CB5BDB1B,$03DB5BCB,$DBDB0303
        long $EC0C0404,$025A5B03,$495A5902,$01012801,$48483838,$68584838,$00487800,$00000048
tile007 long $00480048,$00004848,$58480000,$48485848,$00000000,$00006800,$68004848,$38684848
        long $00486800,$48000048,$48380000,$00004800,$00000000,$00004800,$48480048,$48484848
        long $48000000,$00480000,$00004800,$48004848,$48004800,$00004800,$48000000,$00380048
        long $38000038,$00000048,$00483848,$48480000,$00000038,$00480000,$48004800,$48004800
        long $00003800,$00000000,$00000000,$48480048,$00004800,$00004800,$48000000,$00480000
        long $00000048,$38000048,$00004800,$00004800,$00004848,$00484848,$00480000,$00004800
        long $49494901,$49494949,$00003849,$00380048,$DB03EB7C,$1B03DB03,$38284902,$00000000
        long $01010101,$CB015901,$4A28DB05,$00480048,$00000048,$00480048,$49CA0449,$0000382B
tile008 long $01384848,$48003838,$03010128,$035C4C04,$38486800,$38484838,$5B380158,$8B3C6C8C
        long $38484838,$48380038,$59590138,$8A045B02,$48484800,$48483801,$02023838,$01590202
        long $38384848,$00003838,$49394800,$58480101,$48584868,$38004848,$58013838,$48485858
        long $48004848,$00380000,$58010128,$48483848,$00383800,$38000038,$01483848,$48484838
        long $48384848,$00380000,$48480000,$00480149,$00004800,$38003848,$48003838,$48483848
        long $48004838,$00384848,$00004838,$48003838,$00484848,$00480048,$00380048,$00483838
        long $48000000,$48000048,$38480048,$48004800,$48484800,$48480000,$00384800,$00384848
        long $00000048,$00004800,$38484838,$48004838,$00480000,$48380000,$38004800,$48484848
tile009 long $5C4B5A6C,$3C044B4B,$05050439,$9C5C6C5C,$035B0202,$5A5C4A5A,$0405043A,$8B7B8B6C
        long $495B5959,$3C5B5A7B,$6C5A0505,$7B8BBB6C,$5A010159,$5A590159,$025A5B3C,$9BAC7B5A
        long $38380048,$59014938,$598B7B02,$7B7B7B89,$48483848,$5A595858,$025B0259,$7B8A7B8A
        long $38006848,$01013801,$59015A01,$AC7B8B6B,$48380048,$01594848,$01385938,$7B7A9B6B
        long $58480048,$58015958,$01383848,$8B9A8A02,$48484800,$48484848,$38485848,$7B027B79
        long $48484848,$01484848,$59594858,$5A9A7A59,$58480048,$68486858,$01586848,$02595959
        long $48684848,$00004848,$48484800,$7A015838,$00004848,$38480048,$48484801,$59017948
        long $48480048,$48484800,$58584801,$38010148,$48004848,$00000000,$48686848,$38584838
tile010 long $00000000,$68000000,$00680000,$00000000,$00000000,$00680000,$00000000,$00000000
        long $00000000,$00000000,$00000068,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00680068,$00680000,$00000000,$00000000,$00480000,$68480000,$00000000,$00000000
        long $68004801,$00000000,$00000000,$00000000,$00000048,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$48000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000068,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$58000000,$00000000
tile011 long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$68006800
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$68680000
        long $00000000,$58680000,$00000000,$00000000,$00000000,$38484800,$00000048,$68000000
        long $00000000,$00000000,$00000000,$68006800,$00000000,$00486800,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00584800,$00000000,$00000000,$00000000,$00680068
        long $00000000,$00000000,$00000000,$00000000,$68000000,$00000000,$00006800,$00000000
        long $00000000,$00000078,$00004800,$00000000,$00000068,$68000000,$00000000,$00000000
tile012 long $00000068,$00000000,$00000000,$00000000,$48006800,$00000038,$00000000,$00000000
        long $68680000,$00004838,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00004800
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000068
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
tile013 long $00000068,$48480000,$01004800,$01595959,$00000000,$00000000,$01383848,$02020259
        long $00000000,$00000000,$01484848,$04ACAB02,$00000000,$00004800,$045B4848,$05050505
        long $00000000,$00486800,$05050501,$05050505,$00000000,$38480000,$03020505,$05050404
        long $48000000,$5B004800,$5B5A2805,$5CFC5B1B,$00006848,$05480000,$1B1B285A,$1B5B035A
        long $00480000,$05020048,$3C045A38,$4A1B031B,$00000000,$04044800,$5B2C5A28,$4A3B5B5A
        long $00000000,$3C053848,$024A1B39,$4A49494A,$00000000,$2B054900,$4A4A4A49,$494A4A4A
        long $48000000,$28055A00,$4A021B4A,$494A494A,$48004800,$282C0400,$4A4A4A5A,$4A494A49
        long $00484800,$49390501,$4A494A4A,$494A4A4A,$00000000,$4A38052C,$024A4A02,$4A4A494A
tile014 long $02590159,$48015949,$38484848,$1B050200,$02AB0202,$01285902,$01010101,$88490402
        long $04050404,$FC4C4C0C,$05050504,$05050505,$05050505,$05050505,$05050505,$05050505
        long $05050505,$05050505,$05040505,$5B035C8C,$0C050505,$4A1B5B03,$0C5A4A5A,$4A5A025A
        long $5BEC7C03,$4A5A4A2B,$0C2C494A,$4A4A4A4A,$5B5B1B5A,$4A024A1B,$2C2C494A,$4A494A49
        long $1B4A024A,$024A4A4A,$2C3C494A,$024A4A49,$4A4A4A49,$4A4A024A,$1B0C024A,$49494A4A
        long $024A494A,$022A024A,$3B4C0229,$2B4A4A49,$4A4A494A,$1B4A4A4A,$4A044A4A,$5B4BF94A
        long $494A494A,$4A024A49,$49044A02,$1B4C5A4A,$4A4A494A,$4A4A494A,$4A0C1B4A,$03044A49
        long $4A494A4A,$494A4A02,$494C5B02,$5C04DB1B,$4A4A4A49,$1B4A1B1B,$4A2C031B,$03041B5A
tile015 long $48584848,$00004800,$48004800,$00480048,$01280101,$59595928,$02020202,$1B020202
        long $05050505,$05050505,$05050505,$05050505,$05050505,$05050505,$04050405,$0C040405
        long $4A3B3B4B,$02495A02,$494A4949,$494A4A39,$02024A02,$4A4A494A,$4A494A4A,$4A494A4A
        long $4A4A024A,$49494A49,$494A4A49,$494A4A02,$4A494A4A,$4A4A4A4A,$4A4A394A,$4AF94A49
        long $494A4AF9,$1A494A29,$4A39024A,$4A4A024A,$4A024A4A,$4A4A021B,$022A4A49,$4A491B4A
        long $4A4A024A,$024A4A02,$4A024A4A,$4A1B4A1B,$1B4A4A1B,$1B1B1B4A,$022A021B,$024A024A
        long $031B0303,$5B035A1B,$4A491B5B,$4A494A4A,$1C032C4C,$4BFC035B,$F94A4A2C,$4A4A494A
        long $04FC4C05,$5C044C1B,$4A49024B,$494A4A49,$4C5CEC04,$035C03CB,$4A4A4A4B,$4A4A394A
tile016 long $00004848,$48480058,$48480048,$00000000,$CB5B025A,$8C8CBCBB,$004802EC,$00000000
        long $05050505,$05050505,$01050505,$00000000,$FC8CFC04,$FC4C4C8C,$DC050504,$00000000
        long $024A4A49,$4A5A494A,$04051B5A,$00000000,$4A49494A,$4A494A49,$05055A02,$00000000
        long $49494A49,$4A4A494A,$04054A49,$00480000,$294A4A49,$491A4A49,$0405024A,$38383838
        long $49492949,$4A49494A,$04053B4A,$28594901,$4A024A49,$024A4AF9,$04051B4A,$49014949
        long $4A494A4A,$1B0B5A1B,$04054B5A,$1B49DA5B,$031B4A1B,$034C5B5B,$05050B02,$03020303
        long $FC4C1B5A,$020C031B,$05050C49,$05CB0405,$045C1B49,$49495B03,$04054C5A,$1B590203
        long $5B0C5A4A,$49590202,$3C051B4A,$78483848,$59021B39,$02023959,$4C05034A,$1B010202
tile017 long $00000000,$00000000,$02050178,$00004B39,$00000000,$00000000,$041B0000,$00281B38
        long $00000000,$00000000,$FC004800,$004B4959,$00000000,$00000000,$5B000000,$013C28CA
        long $00000000,$00000000,$02000000,$494B48CB,$00000000,$00000000,$02000048,$022B48AC
        long $00000000,$00480000,$02000048,$5A4A018C,$01283838,$38003838,$02003800,$5A495804
        long $28012801,$48003838,$02383838,$024A588C,$01024902,$49380048,$1B020202,$5A49E804
        long $49DB02CB,$03000000,$8B5CEC04,$4A49888C,$01EC5A6C,$FC380000,$8C040404,$4A494804
        long $5904CB04,$05480000,$04050404,$E8E8018C,$48490102,$05380000,$FC050404,$D9B99804
        long $00004848,$05380000,$8C050404,$BACAB804,$00025902,$05E84800,$03050404,$D8D8C848
tile018 long $00000000,$00000048,$00380048,$48484800,$00000000,$00480000,$48000000,$00484800
        long $00000000,$00003838,$00000000,$48000000,$00000000,$00004800,$00480000,$00480000
        long $48000000,$48000048,$00000000,$00000048,$48004800,$00000000,$00384800,$00480000
        long $00480000,$00480038,$48000048,$00000000,$38000038,$00004800,$00003800,$00000000
        long $00384838,$48480000,$00480000,$00004800,$38382849,$00000149,$00004800,$48000048
        long $04492802,$00004905,$00000000,$00000000,$04043C2B,$48594B3C,$00000000,$00004800
        long $044B3C2B,$05040405,$494A291B,$00000000,$4B044B1B,$05053B3B,$05040505,$00480059
        long $3B2A4A49,$4B3B0505,$053C4B4B,$00004804,$4A290101,$3B3B1B3A,$3C053C4B,$00004802
tile019 long $00384800,$00480048,$68003800,$48484858,$00484800,$48480048,$48486800,$48680048
        long $00000000,$00004800,$00480048,$48384848,$00480048,$00004848,$00480048,$48486848
        long $00004800,$48000000,$48000000,$48004800,$00000000,$00480048,$00484800,$00480000
        long $48000048,$48004800,$48000048,$00480048,$00000000,$00000000,$00004800,$00000000
        long $48000048,$00480000,$00000048,$00000000,$00480000,$00000000,$00004800,$00480000
        long $00000000,$00480048,$00000048,$00000048,$00004800,$00004800,$00480048,$00480000
        long $48000000,$48480000,$00000000,$00000048,$00000000,$00480000,$48004800,$48000000
        long $00000000,$48004800,$48004800,$00003800,$00480000,$00480000,$00000000,$00000048
tile020 long $00000000,$00000000,$00000000,$00000000,$00000000,$00788800,$02880068,$00000000
        long $00007800,$00000000,$68680000,$00000068,$00000000,$00680000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00480000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00680000,$00000000,$00006800,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$68000000,$00000000,$00006800,$00000000
        long $00000068,$00000068,$00000000,$00000000,$00684800,$00680000,$00000068,$00000000
        long $68000078,$00000000,$00000000,$00006800,$00480000,$00000000,$00000000,$68000068
        long $00680000,$00000000,$00000000,$00006800,$00000068,$00680068,$00680000,$00684800
tile021 long $00000000,$00000000,$00000048,$00000000,$00000068,$00000000,$00006868,$00000000
        long $00000000,$68000000,$00000000,$00000000,$00000000,$68000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00680068,$00000000,$00000000,$00000000,$00680000,$68000000
        long $00000000,$68000000,$78000000,$48000000,$00000000,$00680000,$58780000,$48484848
        long $00680000,$00000000,$00006800,$48382802,$00000000,$00000068,$03594800,$1B2C0505
        long $68004800,$00000000,$05050100,$05050404,$00480068,$58684868,$0C05BB00,$05050504
        long $48005800,$68006848,$05040488,$05050505,$68686868,$C8588868,$05050501,$05050505
tile022 long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000048,$00000000,$00000000,$48004800,$00000078,$00000000,$48000000,$00006800
        long $00005859,$00000000,$00000068,$00480000,$00005859,$00006800,$00000000,$00480048
        long $68000000,$00000048,$68006800,$00000000,$00000000,$68006848,$48000000,$00000000
        long $48586800,$00000000,$48680000,$00680000,$68585948,$00000068,$00480068,$00000000
        long $48480202,$68006800,$00006800,$01000000,$4838015A,$00004800,$00004800,$D8A86868
        long $6878282C,$48680000,$49280138,$D899D849,$88583B3C,$01590101,$59012801,$D801C9D8
        long $02493C04,$38E83902,$D8E85848,$9899A899,$39025A3B,$01380149,$A8594858,$885858C8
tile023 long $48000048,$4A280C05,$4A4A494A,$4A021B4A,$01000000,$5A494B05,$4A4A4A4A,$4A4A024A
        long $02004800,$4A4A4905,$021B021B,$1B1B1B1B,$2C004800,$2B1B3904,$4B3B3B3B,$CCBC5C03
        long $05680048,$0505050C,$05050505,$05050505,$04020048,$040404CB,$05050404,$05050505
        long $DAEC0000,$EA02DA02,$BAD9BAD9,$CABA9BBA,$D8024800,$02D81B0B,$021B0202,$CA0202DA
        long $02D89800,$02490303,$1B021B1B,$1B1B1B1B,$1B02D801,$E91B4B0B,$DA020202,$DA1B0202
        long $0B1B02C9,$024B1B4B,$1B02DA02,$025ADA1B,$1B1B0202,$0B0B1B1B,$02020249,$1BDA1B02
        long $4B0B0B02,$2C4B1B0B,$0202D8DB,$02020202,$1B4BEB02,$020B4B0B,$02D8021B,$0249491B
        long $0B0B0202,$0B2B2B4B,$021B1C1B,$021B1B02,$1B0249C8,$4B0B0B1B,$1B0B1B2B,$02CB0302
tile024 long $DC0B024A,$1B035B1B,$024B1B02,$4B4C5A4B,$023B4A02,$1B5A0249,$4A024A5A,$021B5A1B
        long $4A5A5A1B,$2C0B1B1B,$02490202,$0102DC5C,$4A1B2C8C,$1B5A1B5B,$2C030B4A,$02492802
        long $05050505,$0505025B,$05050505,$05050505,$02040505,$0C4C5A01,$03ECEC04,$ECEC7CEC
        long $E8480404,$D902D9D8,$CACAD902,$D902D902,$02A8BAAB,$02CA025A,$CA025ACA,$99D9BA02
        long $99E9CBDA,$1B1B5BDA,$CBDB1BDA,$02D8D802,$0202DB5A,$DA0202D8,$031B5B1B,$CA0202DB
        long $02CB0202,$0259D802,$CB1BDA1B,$CB048C0C,$CB1B021B,$02CA1B02,$02021B02,$0405054C
        long $1B021B5B,$1B021B02,$EC021BDA,$04050505,$490249F8,$02DA0249,$0502021B,$04050505
        long $01E80149,$02020202,$05EC0202,$05050505,$0C4CEB02,$030BEBEC,$050403DB,$05050505
tile025 long $5B1C2C03,$5B5B4901,$024A021B,$2839024A,$5902CB5A,$5BDB5A49,$1B4A4A1B,$CB49024A
        long $1B494949,$1B3B1B02,$0229025A,$38492B49,$3B2B0202,$1B5B1B1B,$1B02491B,$1B1B0303
        long $05050505,$5A040505,$05055A38,$05040405,$BBCB03BC,$58CB8CBB,$CACBCA01,$5A5A0202
        long $CAAAD9BA,$C85804CB,$0202E902,$D9D9CAD9,$D9020202,$CAA8C9CA,$DADA02CA,$02DA1B02
        long $5B1BDA03,$01D9CB5A,$1B4ADB02,$CA1B5A1B,$D9020202,$0202CA02,$0202D8D8,$490202DA
        long $02020249,$024901D8,$EA0202DA,$E9E90202,$5B1B2CFC,$02DA02DA,$0202DA1B,$0149E902
        long $1B3C0505,$DB021B1B,$F9020202,$F80159E8,$4C04055C,$F91B0202,$01E9F902,$59E8E849
        long $3C050505,$D802021B,$F801E849,$E8010101,$5B050505,$59D8F803,$59E859E8,$020249E8
tile026 long $EC030303,$4A4A0202,$4C055B5A,$02585902,$04CC0102,$02294A02,$03050B4A,$0188E801
        long $FC8C5B28,$4A495A1B,$5B055B39,$00006800,$0404EC1B,$2C2C0B03,$02050C4B,$48484848
        long $05050505,$05050505,$02050505,$49480202,$CADACBCA,$E9020202,$02054BE8,$02010202
        long $99D899E9,$D8D9D9D8,$02054A49,$CB01021B,$D8E90202,$E899D999,$59051B28,$5B01025A
        long $E999D802,$4801E849,$01053B28,$5B0102CB,$490249D8,$018801F8,$01044B28,$035902CB
        long $0101F859,$01480101,$595C2C39,$DC020203,$010149F8,$01585801,$011B4C28,$CC02027C
        long $E801E859,$49010101,$02020429,$6C5A029C,$01010101,$0202D902,$024B2C02,$EC030203
        long $D902D901,$D8D8D859,$3B0C0259,$5A053C1B,$CADB5BDB,$020202CA,$4B3B2B02,$595B3C3C
tile027 long $58590159,$04013800,$BB050404,$01BA0101,$78E84801,$04010100,$CC040404,$D8BAC98C
        long $00480048,$CC010100,$AC050405,$98D9BAAC,$01014848,$03015948,$BC040405,$E801C9CB
        long $015B02DA,$03015900,$AC040404,$01A8D8CA,$0102025B,$CB010100,$CB048C05,$58E80101
        long $0102025B,$01494900,$02020202,$014949E8,$010202CB,$48490100,$E8023901,$5949E849
        long $010249CB,$38020100,$4928021B,$02023801,$0102028B,$28020100,$1B294902,$2B4B2B2A
        long $4802015B,$491B2800,$4B1B4A49,$493C3C3C,$380259CB,$49280228,$2C4B4A29,$493B043C
        long $020249CA,$4A49284A,$3C3C2B2A,$492B3B3C,$4A4A2802,$2A4A3928,$2C3C3C2B,$2B2B1B4A
        long $381A2B49,$1B1A4A49,$4A3C3C3C,$3B2B3B2B,$39015A28,$4B4A4A1B,$4A493C04,$4B3B4B3C
tile028 long $38E80148,$2AF838E8,$383B054B,$00480000,$D801D8E8,$3901E8D8,$00004A4C,$00004800
        long $D8D8D801,$4858D8A9,$48380038,$48000048,$D899D801,$4800C8C8,$00003800,$00484838
        long $C8D801E8,$003878C8,$38000000,$48000000,$C898D848,$00004888,$48480048,$00483800
        long $58C801C8,$0000C8E8,$00000000,$00000048,$C8480058,$48485858,$48383838,$48383848
        long $58E84858,$480000C8,$38284838,$4A393901,$58384800,$00000000,$00000000,$28F83800
        long $78E85858,$00000000,$48000000,$48383800,$480068C8,$00000000,$00000000,$00380000
        long $00005848,$00000000,$00000000,$38003838,$00008801,$00000000,$00000000,$48000038
        long $00005802,$00000000,$00000000,$00380048,$0088481B,$00000000,$48000000,$38000000
tile029 long $00000048,$38000000,$00000000,$00000000,$48000000,$00000000,$00000000,$00000000
        long $00003800,$00004800,$00000048,$00480048,$00000000,$00000000,$00000000,$00000000
        long $00004800,$00000000,$00000000,$00480000,$48000000,$00380000,$48000048,$00000000
        long $00000000,$00000000,$00480000,$01000000,$00000000,$00480038,$48000000,$38480000
        long $0038394A,$38004800,$00000000,$48480048,$48382838,$00480038,$48000048,$48484800
        long $01492838,$00484848,$00484848,$00680048,$494A4938,$48484868,$68586868,$68685868
        long $59494938,$68686838,$68686848,$68686868,$01594928,$48483801,$48486848,$68486848
        long $48485928,$69486938,$69686948,$48686968,$00480101,$48693848,$68486869,$68696848
tile030 long $68680078,$00006800,$00000000,$48680000,$00680078,$00000000,$00680000,$68006800
        long $00000000,$00680000,$00000000,$48380000,$00000078,$00000068,$00000000,$48000000
        long $00680000,$00000000,$00000000,$00000000,$68000000,$00000000,$00000000,$00680000
        long $00888800,$00000000,$00680000,$00000000,$00885800,$68680000,$00000078,$00680000
        long $00680000,$68686868,$68680068,$59680000,$68687878,$68686868,$00686800,$59796868
        long $78785878,$68686868,$68686868,$01596868,$68686868,$68006800,$68686868,$01597968
        long $68686800,$68686868,$68796868,$E8590178,$68686868,$68686868,$68686868,$01010179
        long $00686868,$68686868,$78686868,$28490101,$78786878,$68686868,$79786868,$5A590159
tile031 long $78000000,$59E802C8,$05040402,$05050505,$C8784800,$0202D9AA,$05050402,$04050505
        long $B9C86848,$CABABAB9,$0405DBBA,$CC040505,$BAB86800,$BB9AAABA,$0404BBBB,$9BAC0505
        long $B9780068,$9B8A8AAA,$9CABCBDC,$BABAABAC,$A8786800,$9B8A9AB9,$9B9B9B9B,$CA9BAACA
        long $01386800,$8A8ABA01,$8A05058A,$ACACBAAA,$01010158,$8ABAA901,$AA05058A,$BB9B9BAA
        long $01013858,$AAB888E8,$9B058A8A,$C9BA8CAC,$38010101,$B9C85858,$AC058A8A,$C8CA0505
        long $48010138,$00000148,$0505AAB8,$9AAC059B,$58010159,$00000101,$058AB900,$CA059B05
        long $48483859,$00007848,$9BB9C800,$AC050505,$01010101,$00000058,$9BA90000,$ACAB059B
        long $01490101,$00000000,$B9998800,$0505059B,$01494949,$00000068,$00007900,$059B8AB8
tile032 long $F8494901,$E8380128,$00E8E801,$E8988878,$F859E859,$38010149,$88685801,$99C8C858
        long $59F89802,$01E82801,$C888C858,$D801A8A8,$284901A9,$48010149,$0299E888,$02020202
        long $59F85902,$98E80128,$EA0202D9,$02E90A02,$5901F802,$02E901D8,$02EA02DB,$0202D902
        long $F80138C8,$CACABA01,$02D902DA,$D9D902D9,$E80148C8,$D9BAD9A9,$CACACACA,$D902D9CA
        long $C9588899,$BABAB9BA,$CACACABA,$CABACACA,$C9C8C8A8,$CABABABA,$CACACACA,$BACABABA
        long $BAB901E8,$CACADC9B,$CACACACA,$CABACACA,$B9B9C9C8,$CACACACA,$CACA9BCA,$CACACACA
        long $BAB9BAC9,$9BCACABA,$9BCACACA,$CABACA9B,$AAAABABA,$CAAB9BBA,$AB9B9B9B,$CA9B9BCA
        long $AAAAB99B,$05059B8A,$0505059C,$048C0505,$8AAABABA,$059B8A8A,$05050505,$05050505
tile033 long $E9D8D899,$1B1B1B02,$DB1B1BCB,$1B1B021B,$0202A9D8,$DA021B02,$02020202,$02DA1BDA
        long $02020202,$49DA0202,$0A020A02,$0A020202,$02EA020A,$EA02F9EA,$02020202,$020202E9
        long $E902F902,$E9490202,$E9E9E902,$D9E9E902,$02E902E9,$E9D9E902,$0202E902,$E902D902
        long $D902D902,$D802D8E9,$D8E9D8D8,$99E9D8D8,$02D9D9D9,$02D9BAD9,$D99902D9,$E9D902D9
        long $D9BACABA,$D9D9D9BA,$99D9D9BA,$BAA9D9BA,$BACABACA,$BABABACA,$CABABAD9,$D8D99AD9
        long $BABACABA,$BABABABA,$BABABACA,$BABABABA,$CABACABA,$BACABACA,$BACABACA,$BABABABA
        long $BACABACA,$CABACABA,$BABACACA,$BABABACA,$BACACABA,$CACABACA,$BABABABA,$BABABABA
        long $ACAC9CAC,$9BACBBAB,$CABA9B9B,$BACABABA,$05050505,$05050505,$ACAC05AC,$ACACAB05
tile034 long $1B1B1B1B,$1B1B1B1B,$05041BDB,$05040505,$02DA02DA,$DA020202,$05040202,$05050404
        long $0A02DA02,$0202EA02,$0503E90A,$0505054C,$D90202E9,$E9CAE902,$04D8D902,$05050505
        long $02D9E902,$02E902D9,$D89902D9,$05050505,$E902D802,$D8BAE9E9,$D8D8D8D8,$7C7CCA98
        long $D8D8D8D9,$99D8D899,$D8D8A9D8,$99E801D8,$D999D999,$D8D899D9,$C898D8D8,$C901D898
        long $D8D9D9D9,$C9D8D8D8,$C8C8C8A9,$BAC8E898,$BAD99AD9,$BA99C9BA,$A8C8C8D8,$B9B8C8C8
        long $C9BAC9BA,$C8C9C9D9,$C8C8C89B,$CAD898B8,$BABABABA,$C8D8AABA,$C8C899CA,$ACBAB8C8
        long $BABABABA,$C9A8C9BA,$B8B8D999,$ACACBAB8,$BABABABA,$D8C9AABA,$C9C9A9D8,$059BACBA
        long $BACACACA,$C9D9C9BA,$BAC9D9A9,$9B05ACAC,$BA9B9B9B,$D9C9BABA,$ABA9A9C9,$059B05AC
tile035 long $CB050505,$E8E85959,$4901E801,$4939DB5B,$8B050505,$59E8E8E8,$E959E801,$DC1B4948
        long $59050504,$E8E859E8,$E8385949,$BABACA02,$01CA0504,$495901D8,$CAD9D8E9,$BABABACA
        long $9999AC05,$CA0249F8,$BA9BABCA,$BABABABA,$E802D8AB,$BABABAD8,$9B9B9B9B,$CACA9B9B
        long $B9C99904,$ABABBAAA,$AB9B9BAB,$C8BAABAB,$8A9ABA9B,$ACBA8A05,$ABACACAB,$0000C8BA
        long $8A9B9BAC,$ABB98A05,$C99BACAC,$00000000,$059BABBA,$BBB98A8A,$00C8BAAB,$00000000
        long $0505ACAC,$AB9BB9AA,$000000B8,$00000000,$8A9B9BAC,$C8BABA9B,$00000000,$48000000
        long $ACACACAB,$7800C9AB,$00000000,$58480000,$9BAC059B,$000000C8,$00000000,$48017800
        long $C8BA9B05,$00000000,$00000078,$58E85800,$0000BA8A,$00000088,$00000000,$3801E800
tile036 long $02032C4A,$1A49E902,$4B3B2B4A,$99993C3C,$D8D9CADB,$0101E8D8,$3C3C2B49,$01015A3C
        long $C9C9C9BA,$0148A801,$284A0B49,$00000000,$C9BABABA,$000001D8,$00000000,$00000000
        long $C8D8D9BA,$00000000,$00000000,$00000000,$0000C8C9,$00000000,$00000000,$00000000
        long $00000000,$00000000,$48000000,$00383848,$00000000,$00000000,$01014868,$28283838
        long $00000000,$E8684858,$E8590148,$49283848,$78000000,$4848E801,$00010101,$01013838
        long $48784848,$01585848,$48480101,$00384800,$58004858,$48005800,$4800E801,$00480048
        long $48588858,$01585848,$00484801,$01480048,$58484800,$48480048,$48000048,$01594800
        long $48484801,$00484858,$00004800,$00005848,$48E84801,$48480048,$48000000,$00000000
tile037 long $1B280238,$044B2A2A,$3C1B593C,$3C3C4B3C,$2B394948,$3C043C2B,$053C0102,$4A1B3C3C
        long $4B49E800,$595A3C04,$3C3C5998,$00014B3C,$1B390000,$997A025B,$59590201,$00000159
        long $88580000,$58019902,$99997A99,$00000058,$00000000,$88888901,$01899959,$00000000
        long $00000000,$48005858,$00680199,$00000000,$00000000,$98000000,$00007899,$00000000
        long $00004849,$00000000,$00000000,$00000000,$58000128,$00000000,$00000000,$00000000
        long $00787848,$00000000,$00000000,$00000000,$00480000,$00000000,$00000000,$00000000
        long $78000068,$00000000,$00000000,$78000000,$00000048,$00000000,$00000000,$02000000
        long $00006800,$00000000,$00000000,$88680000,$00000000,$00000000,$00000000,$00686800
tile038 long $0000014C,$00000000,$00000000,$48483838,$00000001,$00000000,$38380000,$48000000
        long $00000000,$00000000,$00003800,$48480048,$00000000,$00000000,$00380000,$38000048
        long $00000000,$38000000,$38003800,$68000000,$00000000,$00000000,$00380048,$48003800
        long $00000000,$00000000,$38000000,$48000000,$00000000,$00000000,$00380000,$48000000
        long $00000000,$00000000,$00000038,$48004848,$00000000,$00000000,$48000000,$00000000
        long $00000000,$00000000,$00000000,$48380000,$00000000,$00000000,$00000000,$00000000
        long $00000058,$00000000,$00000000,$00000000,$00000059,$00000000,$00000000,$38000000
        long $00000078,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
tile039 long $00680128,$69384868,$68694848,$68686869,$00680101,$69486800,$48686948,$69486968
        long $00000001,$48693800,$69486869,$68694848,$00004801,$48694800,$69486938,$48694869
        long $48380001,$69386800,$69486968,$69386948,$00380048,$48690000,$68694869,$48693869
        long $48480068,$69384800,$69686968,$69486948,$68480000,$69586800,$68686968,$69686869
        long $01480158,$58696800,$69684869,$78696958,$01385878,$69480000,$79696978,$6A797979
        long $01016848,$59796848,$7A7A6A7A,$8A7B7B7A,$4A013849,$7B6B6800,$7B7A8A7B,$6B7B7A6B
        long $1B382802,$7A7A0038,$79797989,$796A7979,$4B284902,$68686800,$78686968,$78887878
        long $1B380239,$68684800,$68680068,$68686868,$5A015A59,$00004800,$68006868,$68686868
tile040 long $79787878,$79697879,$7A7A7989,$02015901,$79797979,$7A896A89,$597A7A7A,$03025948
        long $79797989,$897A8989,$897A7A7A,$5BDA5901,$7A898989,$7A7A7A7A,$597A7A7A,$CC030201
        long $7A8A7A7A,$7A7A7A7A,$798A7A7A,$9BAB5958,$7A7A7A7A,$7A7A7A7A,$886B8A7A,$02020101
        long $7A7A7A7A,$7A7A7A7A,$797A7A7A,$01890158,$7A7A7A7A,$7A7A7A7A,$797A7A7A,$98010101
        long $7A7A7A89,$7A7A7A7A,$797A7A89,$01017901,$89897A7A,$7A7A7A7A,$9989796A,$78885858
        long $89897A7A,$79797A89,$58697979,$78880158,$896A7A7A,$6979896A,$79797969,$58585878
        long $7A897A89,$89897A7A,$897A896A,$78787878,$896A896A,$897A896A,$7A7A897A,$58686859
        long $7A89897A,$8989796A,$7A6A796A,$78005879,$8A7A897A,$7B8A8A7A,$7A89897A,$5878887A
tile041 long $485A0202,$00007800,$00000000,$0505B900,$48495902,$00004868,$00000000,$05BAC800
        long $58591B02,$00000058,$00000000,$9AC80000,$00485C05,$00000002,$00000000,$BA000000
        long $6838CB8C,$00000001,$00000000,$B8000000,$00480202,$00000058,$00000000,$02000000
        long $00680202,$00000000,$00000000,$AB000000,$68000201,$00000000,$00000000,$00000000
        long $68480178,$00000000,$00000000,$00000000,$00010178,$00000000,$00000000,$00000000
        long $68585878,$00000000,$00000000,$00000000,$58588878,$00000000,$00000000,$00000000
        long $58986800,$00000000,$01000000,$00000000,$78018858,$00000000,$59780000,$01015959
        long $88587878,$00000000,$01887800,$02590302,$58587800,$00000068,$01780000,$99980101
tile042 long $8AAAB9BA,$9B058A8A,$05059B05,$05050505,$8AAAAABA,$058A8A8A,$05050505,$05050505
        long $8AAABABA,$05058A8A,$05050505,$05050505,$8AAAB99B,$058A8A8A,$05050505,$05050505
        long $AAAABABA,$8A8A8A8A,$05058A8A,$05050505,$B9B9B99A,$AAAABAB9,$8A8A8A8A,$AB8A8A8A
        long $B9AA9902,$B9B9B9B9,$B9B9B9B9,$AC9BAAB9,$B8028898,$B9B9B8B8,$B8B8B8B8,$BA9BAAB9
        long $88010000,$A8A8B889,$888888B8,$BA999A9A,$58010000,$A8A8A802,$A88800A8,$99020299
        long $01990000,$A8987899,$9898B8A8,$99999998,$98010000,$0202E899,$C8010199,$01589858
        long $01594888,$49284802,$98990202,$58989898,$99D859CB,$88000059,$79588888,$99489801
        long $015A5B8C,$59014801,$01010138,$02590101,$5804CB8C,$9C040201,$3C5C036C,$BB5C035C
tile043 long $05050505,$05050505,$05050505,$AC05059B,$05050505,$05050505,$058A0505,$9B9B058A
        long $05050505,$05050505,$05050505,$8A8A8A05,$05050505,$05050505,$058A0505,$8A8A058A
        long $05050505,$8A050505,$05050505,$8A8A8A8A,$059C0505,$8A8A8A05,$8A8A8A8A,$8A8A8A8A
        long $9B9A9A8A,$AA8AAB05,$AAAAAAAA,$B9B9B9B9,$AABABABA,$BA9BAC9A,$B9B9B9BA,$B9B9B9B9
        long $A999BA99,$9BAC9BA9,$A898999A,$B8B8A9B8,$02997A99,$ABAB02D8,$0199029B,$B8B8C801
        long $7A999959,$CA029899,$01BA028B,$A8C88889,$98980198,$02990101,$9959CA02,$C88848A8
        long $01010101,$99989898,$59020259,$000058E8,$9901D802,$99019801,$02020201,$98C80101
        long $5898985A,$02020198,$BB9A9A02,$01010202,$02015902,$0299025B,$99990202,$02020202
tile044 long $BA9B9B9B,$AAB9BAB9,$05BAD9D9,$BA05059B,$BA9B9B9B,$B9C9BABA,$ACABAAD9,$B8BA9B05
        long $AABA9B9B,$B9C9B9B9,$059CCAC9,$78B8B99B,$BA9B9B8A,$B9C9BABA,$8A05ABC9,$880088B9
        long $AA9AAA8A,$C9C9B9B9,$C8AAACBA,$00580000,$BAAAAAAA,$B9B9B9B9,$0000CA9B,$00780000
        long $B9B9B9B9,$C8B8B9B9,$00000098,$88000000,$B8B8B9B9,$00C8B8B8,$00000000,$00000000
        long $C8C8C8B8,$00C8C8C8,$00000000,$00000000,$00B8C8C8,$0000C8C8,$00000000,$00000000
        long $C8C8C8C8,$000000C8,$00000000,$78480000,$0088B8B8,$0000C8C8,$00000000,$00590000
        long $C8C88898,$000000B8,$00000000,$58020000,$88888800,$00008800,$00000000,$78D80000
        long $00008802,$00000000,$00000000,$58590000,$0000787B,$00000000,$00000000,$48010000
tile045 long $C8C8C8B8,$78000000,$00000048,$E8010258,$00780098,$00000078,$000000C8,$59490248
        long $00888800,$00000058,$00000000,$4901CA02,$00580000,$00000088,$88008800,$49020202
        long $88005888,$00885800,$78000000,$020302CB,$C8000058,$00007858,$48008800,$5ACCCB02
        long $58588800,$00000000,$01000000,$04056CCA,$78000058,$00000000,$01008800,$05050302
        long $02004800,$00005904,$01000000,$0505EC02,$02015800,$000099EC,$01000000,$8C040202
        long $00980000,$00000088,$98C80000,$02AC9A02,$00000078,$00000000,$A9000000,$01590202
        long $00000000,$00000000,$01C80000,$A8020102,$00000000,$00000000,$A8C80000,$48019902
        long $00000000,$00000000,$88C80000,$88015999,$00000000,$00000000,$01000000,$58010102
tile046 long $48484838,$48484848,$00003848,$00000068,$E8380101,$48480148,$48000000,$48000048
        long $013849E8,$4801E838,$38000048,$48000000,$59E84959,$58E85901,$48480048,$00480001
        long $01590202,$58580259,$48000001,$68000059,$49021BCB,$48480149,$00480001,$68000048
        long $CACCBC05,$98580102,$48490048,$00000000,$02038C05,$0148015A,$49480058,$01283801
        long $028B0405,$48580102,$00000068,$484B4C39,$0202CB4C,$01585801,$00680000,$00494B00
        long $014902AB,$48780102,$00000000,$01685848,$5999015A,$48584801,$01480000,$39484838
        long $01014801,$58004898,$00480000,$39480000,$58888801,$78585801,$00000000,$01280000
        long $48587801,$00588801,$00000000,$4A013800,$48587801,$48885848,$48000000,$4A283800
tile047 long $00587800,$00000000,$00000000,$68680000,$00587800,$00000000,$68686800,$68007868
        long $68485948,$00000000,$00000000,$00680000,$00585858,$00000000,$00680000,$00000000
        long $68580068,$00000000,$68000000,$00006800,$00780000,$00000000,$00000000,$00000000
        long $00006800,$00000000,$00000000,$00000000,$68000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$48006848,$00000000,$00000000,$00000000
        long $0149284A,$00000000,$00000000,$00000000,$4902494B,$00000000,$00000000,$00000000
        long $49494A02,$00000000,$00000000,$68000000,$4949394A,$00000000,$00000000,$00000000
        long $49022839,$58000000,$00680068,$00000000,$484A2801,$00000000,$00000068,$00680068
tile048 long $00000078,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000068,$00000000,$00000000,$00000000,$00000068,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$68000068
        long $00000068,$00000000,$00680068,$01006800,$00000000,$58680000,$58585888,$79785879
        long $00000000,$01590168,$68687858,$68587868,$78006800,$00005858,$00000000,$68580000
        long $78580000,$00000000,$68006800,$68586868,$68586868,$68006868,$68006800,$68006800
tile049 long $4A4A1B01,$68685800,$68686800,$68686868,$282C4A28,$68004848,$68686868,$68006868
        long $384C3948,$00684838,$68006868,$58686800,$38023900,$78584801,$68680068,$79686868
        long $39283800,$68787901,$68686868,$58686868,$49494800,$68687801,$68006800,$68796800
        long $49010000,$68006878,$68686868,$68587968,$78584800,$68686868,$00686800,$68780168
        long $00005800,$68000068,$68686868,$68687901,$68007858,$68686800,$58686800,$68685859
        long $00686868,$68006868,$59686868,$00687879,$68680000,$68686800,$01016868,$68686878
        long $68680068,$68006800,$78597868,$68686868,$00680068,$68680068,$78015868,$79686868
        long $68686800,$00686868,$00680168,$79680179,$68686868,$68686868,$68687901,$79796A79
tile050 long $7A7A7989,$8A7B7B8A,$7B7B8A7A,$0100898B,$7A7A7979,$7A8A8A9B,$8A8A8A8A,$98788A7B
        long $7A7A7A89,$8A7A8A7A,$7A8A7A7A,$6A896A6A,$7A8A7A7A,$7A7A7A7A,$896A7A7A,$7B89796A
        long $8A8A8989,$897A7A8A,$896A7A7A,$7A7A896A,$8A7A8A7A,$7A8A8A7A,$7A7A8A7A,$8A8A7A8A
        long $7A8A8A7A,$8A8A8A8A,$7A7A898A,$7A7A7A8A,$7A8A8A7A,$7A7A8A8A,$89897A89,$7A7A7A8A
        long $897A8A8A,$897A8A7A,$6A897A6A,$897A7A7A,$6A897A89,$6A6A7A7A,$89897A7A,$7A897A7A
        long $79697969,$7969897A,$6A6A6A7A,$8A7A7A89,$79898988,$79697A89,$69798979,$7A7A8A7A
        long $7A7A7A89,$896A7A7A,$69797A79,$7A7A896A,$7A8A7A7A,$7A897A89,$896A6A6A,$7A896A69
        long $7A7A7A7A,$897A7A7A,$897A7A8A,$7A89797A,$897A7A7A,$7A7A7A7A,$6A7A7A7A,$7A6A7A7A
tile051 long $88680078,$00000000,$88000000,$99880078,$78008858,$00006801,$88786800,$7A680068
        long $68787801,$78688902,$89786A88,$8A7A6A7A,$78788879,$7A798A7A,$7B7A7B7A,$8B8A8A7B
        long $7A897A7A,$8A8A8A7B,$8A8A8A8A,$7B8A8A8A,$8A7A8A7A,$7A7B8A8A,$8A7A8A7A,$8A7A8A7A
        long $89897A8A,$7A8A7A7A,$7A7A7A7A,$7A898A7A,$89897A8A,$8A897A8A,$7A7A7A7A,$7A897A7A
        long $6A897A7A,$897A7A8A,$897A8A8A,$8A7A7A7A,$7A897A8A,$897A6A8A,$897A7A7A,$9B7A7A8A
        long $6A6A6A89,$6A7A7A7A,$7A8A7A89,$9B8A7A7A,$89896A6A,$6A7A7A89,$8A7A896A,$8A8A7A7A
        long $7A896A7A,$89897A6A,$7A7A7A7A,$7A8A8A8A,$7A8A7A7A,$6A7A8A7A,$7A8A8A7A,$7A7A7A8A
        long $897A8A8A,$7A6A8A7A,$7A8A7A7A,$7A7A7A8A,$7A7A897A,$89697A7A,$7A7A7A7A,$8A7A7A7A
tile052 long $59999898,$9AAA9998,$9BAA9A9A,$ACACABAC,$89797959,$99890078,$A8897979,$99998999
        long $7A7B8A8A,$8A7B7A6A,$7A7A8A89,$7B7B8A7A,$8A7B8A8A,$7B8A7B8A,$8A7B8A7A,$7B8B8A7A
        long $8A7B8A7A,$9B8A8A8A,$7A8A8A7A,$9B8A8A7A,$7A8A8A8A,$8A7A7A7A,$7A8A8A7A,$8A8A8A7A
        long $8A8A7A8A,$7B8A8A7A,$7A7A7A8A,$8A8A7A7A,$8A8A8A7B,$8A8A8A7A,$8A7A8A7A,$8A7A7A7A
        long $8A8A7A8A,$8A8A8A8A,$7A7A7A8A,$7A7A8A8A,$8A8A8A7A,$7A7A7A8A,$7B9B8A8A,$7A7A7A8A
        long $8A7A8A7A,$8A8A7A8A,$8A8A8A7A,$7A897A9B,$8A8A7A8A,$8A7A7A7A,$7A7A8A8A,$7A7A7A8A
        long $7A7A7A8A,$7A897A8A,$7A7A7A8A,$7A7A7A8A,$7A7A7A7A,$7A7A7A8A,$7A6A7A7A,$7A7A897A
        long $8A7A897A,$6A7A7A8A,$6A897A7A,$6A897A7A,$8A7A7A7A,$7A7A7A8A,$896A8989,$896A7A7A
tile053 long $059C9902,$8C050505,$6C0299CA,$0159028B,$9998598A,$9C8A8A8A,$9C994802,$0303ACAC
        long $89898902,$7B898A8B,$9A7801AC,$01019998,$8A8A8BAB,$7A7B7BAC,$8A7A7A89,$02995879
        long $7A8A7B7A,$7A8A8A8A,$6B9B7A89,$7A88897A,$7A8A8A8A,$8A7A7A8A,$7A9B7A7A,$89797A7A
        long $7A7A7A7A,$7A897A8A,$7A8A7A89,$7A7A8A7A,$8A8A8A7A,$8A6A898A,$7A89897A,$7A7A7A7A
        long $7A8A7A8A,$8A7A897A,$7A797A7A,$8A8A8A8A,$7A7A7A7A,$7A7A7A7A,$7A7A8A7A,$7A7A7A7A
        long $7A6A8A8A,$7A7A7A7A,$7A7A7A89,$7A7A7A7A,$7A7A896A,$7A7A8A7A,$7A6A8979,$7A7A898A
        long $7A7A7A7A,$8A8A8A8A,$7A7A7A6A,$8A9B8A89,$7A8A7A7A,$6A8A7A8A,$7A897A89,$7A7A7A7A
        long $7A8A7A8A,$6A7A7A7A,$7A7A897A,$7A7A7A89,$7A7A7A7A,$7A7A7A7A,$7A7A7A89,$7A7A796A
tile054 long $00005959,$78007878,$58007800,$48590000,$0248D802,$02020202,$02024902,$58E90202
        long $C888599A,$A9999899,$ABCABAA9,$789A8C8C,$58889859,$88788849,$A8888858,$5898A899
        long $7A9A0289,$6801799A,$98887988,$98017878,$7A7A7A8A,$8A7B7A8A,$7A8A6B7A,$897A8989
        long $8A7B8A7B,$8A8A8A8A,$7A8A8A8A,$8A8A7A7A,$8A8A7A8A,$7A897A8A,$7A8A7B8A,$8A8A7A7A
        long $8A7A8A8A,$8A897A8A,$7A7A8A8A,$7A8A7A7A,$7A8A7A7A,$8A8A8A8A,$897A6A8A,$7A7A7A7A
        long $7A8A8A7A,$7A897A7A,$6A8A897A,$7A7A8989,$7A8A8A7A,$7A898A8A,$6A8A7A7A,$89896A89
        long $8A8A7A7A,$7A7A7A8A,$897A7A7A,$896A897A,$8A7A897A,$7A7A7A7A,$7A898989,$89897A89
        long $7A7A898A,$7A6A897A,$79796A6A,$897A8979,$7A7A6A89,$8989897A,$79797979,$7A7A8989
tile055 long $00000000,$00000068,$98E88848,$00489902,$48485800,$00004859,$00000058,$C8480199
        long $E8025A00,$0000028C,$78000000,$78580259,$98019800,$00000102,$78000000,$00885898
        long $00000000,$00007800,$00006800,$48005800,$89897900,$78788879,$00008878,$88C88800
        long $8A9B896A,$8989897A,$7968896A,$00688878,$7A7A7A7A,$89896A89,$7A7A7A7A,$88587A89
        long $897A7A7A,$8B7A7A79,$7A8A8A8A,$01987A7A,$7A7A8A7A,$AB7B7A7A,$7A7A8A8A,$8888797A
        long $8A7A8A8A,$8A9B8A8A,$7A7A7A7A,$8969896A,$7A8A8A7A,$8A8A8A7A,$7A7A7A7A,$89897989
        long $8A7A7A7A,$8A7A7A7A,$89897A8A,$797A6A7A,$7A7A7A7A,$7A8A7A7A,$6A897A7A,$897A897A
        long $7A7A8A6A,$89897A89,$897A9B8A,$7A7A6A89,$8A8A7A7A,$7A897A7A,$8A8A8A7A,$7A8A7A89
tile056 long $78008858,$58585888,$28000000,$1B284800,$78580001,$000101E8,$39480078,$49022802
        long $58005878,$88010158,$5A000000,$394A4949,$00005800,$00880188,$39000000,$394A2B4A
        long $00008800,$78584800,$38000000,$4A294B04,$00000000,$00880000,$00000000,$2C3B4A28
        long $00000000,$00000000,$00000000,$4A2C0100,$00000078,$00780000,$00000000,$00004868
        long $78007800,$00000000,$78000000,$48380000,$78780078,$78000000,$88680000,$79795879
        long $78007988,$79787979,$6A797A89,$7A6A8979,$89898989,$896A897A,$7A897A7A,$8989896A
        long $7979696A,$6A7A8969,$896A7A7A,$79896A89,$7A7A7A7A,$897A7A89,$6A897A7A,$6989796A
        long $7A8A8A7A,$897A7A8A,$796A6A6A,$79687979,$7A8A8A8A,$6A7A897A,$78798989,$68686878
tile057 long $005A4938,$00000000,$00680000,$68000000,$00010238,$68000000,$00006800,$00680068
        long $00384A39,$00680000,$68000000,$68006800,$0000494A,$68000000,$00006800,$00000000
        long $0000013B,$00000000,$68000000,$00680000,$00003849,$00680068,$68000068,$68000000
        long $68000038,$00680000,$68697868,$68686800,$68004800,$68686800,$79896A68,$79697979
        long $68680068,$79897968,$69896A89,$79896A89,$79786888,$79898969,$69897969,$6A897979
        long $79797979,$69796978,$79697989,$896A8979,$79897989,$79697979,$78687989,$79798968
        long $79896969,$79897969,$79687979,$79796869,$69796878,$69797968,$78786869,$68686878
        long $68686879,$78787878,$88786868,$68686888,$68686868,$68686868,$68686868,$68686878
tile058 long $00687800,$68686800,$68006868,$00686800,$68005868,$68006868,$68686800,$68787868
        long $68686800,$68686800,$01790068,$68680179,$68000068,$68680068,$68587968,$68006878
        long $68686800,$68006868,$00687979,$78000078,$68796868,$79687978,$79788979,$79697979
        long $798A7978,$6A897A7A,$6A7A8A7A,$797A7A7A,$8A7A7A79,$89898A7B,$7A7A7A89,$6A897A7A
        long $7A7A7A7A,$6A7A7A8A,$7A7A8989,$7A89897A,$7A7A7A89,$6A897A7A,$7A896A89,$897A896A
        long $6A896A79,$796A6A89,$896A896A,$896A8989,$89797979,$79897969,$69796979,$7979696A
        long $69787968,$69696878,$78686868,$69787878,$68686878,$68686868,$68786878,$78696868
        long $68686878,$68686868,$68687868,$68006868,$68687878,$68686868,$68686868,$68686868
tile059 long $68680068,$68680068,$79683859,$7A79897A,$58786968,$01386958,$59797969,$7A797A6A
        long $79587801,$59684879,$7A7A7979,$89796A89,$79796868,$79686959,$7A8A6A59,$7A8A7B7A
        long $6B7A7900,$7A69797B,$7A8A7A8A,$7A7B8A8A,$7B7A7978,$7A7A7A7A,$7A8A6A6A,$7B7A6A7A
        long $8A7B6A68,$7A7A897A,$7A7A7A79,$8A7A7B7A,$7A7A7A79,$7989896A,$7A7A7A89,$7A7A8A7A
        long $897A8989,$6A896A89,$8989897A,$89897A6A,$896A6A89,$89898969,$896A7A89,$69798979
        long $6A89896A,$79697979,$69796969,$78686978,$79796A79,$69796979,$69787879,$79887888
        long $79687979,$78787978,$68697869,$78797879,$68696878,$78686868,$58686868,$78687868
        long $78787878,$68686878,$69686878,$78686868,$69696868,$68686868,$78686869,$68686868
tile060 long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000

tile061 long $2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$002A2A2A,$00000000,$2A2A002A,$2A2A2A2A
        long $2A2A2A2A,$2A2A002A,$2A2A002A,$2A2A2A2A,$2B2B2B2B,$2B2B002B,$2B2B002B,$2B2B2B2B
        long $2B2B2B2B,$2B2B002B,$002B002B,$2B2B2B00,$3B3B3B3B,$3B3B003B,$3B00003B,$003B003B
        long $4B4B4B4B,$4B0B004B,$0B4B004B,$004B004B,$2C2C2C2C,$4B2C002C,$2C4B002C,$002C002C
        long $2C2C2C2C,$2C3C002C,$2C3C002C,$3C2C003C,$3C3C3C3C,$3C3C4C3C,$3C3C4C3C,$3C3C4C3C
        long $4C4C4C04,$044C4C04,$4C4C044C,$044C4C04,$04044C04,$04044C04,$044C044C,$04044C04
        long $04040404,$0404044C,$04040404,$4C040404,$04040404,$04040405,$04040404,$05040404
        long $05050505,$05050504,$05050505,$04050505,$05050505,$05050505,$05050505,$05050505
tile062 long $2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$0000002A,$2A2A2A00
        long $2A2A2A2A,$2A2A2A2A,$2A2A002A,$2A2A002A,$2B2B2B2B,$2B2B2B2B,$2B2B002B,$2B2B002B
        long $2B000000,$2B2B2B2B,$2B2B002B,$2B2B002B,$002B4B3B,$3B3B3B3B,$0000003B,$3B3B3B00
        long $00000000,$4B4B4B4B,$4B4B004B,$4B4B0B00,$2C2C2C2C,$2C2C2C2C,$2C2C002C,$2C2C002C
        long $00000000,$2C2C2C2C,$2C2C002C,$2C2C002C,$3C4C4C4C,$3C3C3C3C,$3C3C4C3C,$3C3C3C3C
        long $044C4C4C,$4C4C4C4C,$4C044C4C,$4C4C044C,$0404044C,$0404044C,$4C040404,$044C0404
        long $4C040404,$04040404,$04044C04,$04040404,$05040404,$04040404,$04040504,$04040404
        long $04050505,$05050505,$05050405,$05050505,$05050505,$05050505,$05050505,$05050505
tile063 long $2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$00000000,$002A2A00,$2A2A2A2A,$2A2A002A
        long $2A2A2A00,$002A2A2A,$2A2A2A2A,$2A2A002A,$2B2B2B00,$002B2B2B,$2B2B2B00,$2B2B0000
        long $00000000,$002B2B2B,$002B002B,$2B2B002B,$2B4B3B00,$003B3B3B,$003B003B,$3B3B003B
        long $4B4B4B00,$004B4B2C,$4B004B4B,$4B4B004B,$4B2C2C00,$002C4B2C,$2C002C2C,$2C2C002C
        long $00000000,$002C2C00,$2C2C2C2C,$2C2C002C,$4C4C4C4C,$4C3C3C3C,$3C3C3C3C,$3C3C4C3C
        long $4C4C4C04,$4C044C04,$4C4C044C,$4C4C4C04,$04044C04,$4C044C04,$044C0404,$04044C04
        long $04040404,$0404044C,$04040404,$04040404,$04040404,$04040405,$04040404,$04040404
        long $05050505,$05050504,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505
tile064 long $2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$00002A2A,$2A000000,$2A2A2A2A,$2A2A2A2A
        long $2A002A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2B002B2B,$2B2B2B2B,$2B2B2B2B,$2B2B2B2B
        long $00002B2B,$2B2B0000,$00002B00,$002B2B2B,$3B003B3B,$3B3B2B4B,$3B3B0000,$3B003B00
        long $4B004B4B,$4B4B4B4B,$4B0B4B00,$4B004B00,$2C002C2C,$2C2C2C2C,$2C2C4B00,$2C002C00
        long $00002C2C,$2C000000,$2C2C3C00,$003C2C00,$4C4C3C3C,$3C3C4C4C,$3C3C3C4C,$4C3C3C4C
        long $4C4C4C04,$044C044C,$4C044C4C,$0000044C,$04044C04,$044C4C04,$4C04044C,$044C4C04
        long $0404044C,$04040404,$04040404,$04040404,$04040405,$04040404,$04040404,$04040404
        long $05050504,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505
tile065 long $2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A00,$2A2A2A2A,$2A2A2A2A
        long $2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2B2B2B2B,$2B2B2B2B,$2B2B2B2B,$2B2B2B2B
        long $2B000000,$2B002B00,$2B2B0000,$0000002B,$3B002B4B,$00003B00,$3B003B3B,$2B4B3B00
        long $4B004B4B,$4B004B00,$4B004B0B,$00000000,$2C002C2C,$4B002C00,$2C002C2C,$2C2C4B00
        long $2C000000,$3C002C00,$2C002C2C,$0000003C,$3C004C4C,$3C4C3C4C,$3C3C3C3C,$4C4C4C4C
        long $4C040000,$4C4C044C,$044C4C04,$044C4C4C,$4C040404,$044C0404,$04044C04,$044C044C
        long $0404044C,$04040404,$04040404,$04040404,$04040405,$04040404,$04040404,$04040404
        long $05050504,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505
tile066 long $2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$002A2A2A,$2A2A0000
        long $2A2A2A2A,$2A2A2A2A,$2A002A2A,$2A002A2A,$2B2B2B2B,$2B2B2B2B,$2B002B2B,$2B002B2B
        long $2B2B2B2B,$2B2B002B,$2B00002B,$2B002B2B,$3B3B3B00,$3B3B003B,$3B00003B,$3B003B3B
        long $4B4B4B00,$4B004B4B,$4B004B00,$4B004B4B,$2C2C2C2C,$2C002C2C,$2C002C00,$2C002C2C
        long $2C2C2C00,$002C2C2C,$002C3C2C,$2C2C0000,$3C3C3C3C,$4C3C3C3C,$4C3C3C3C,$3C3C4C4C
        long $4C044C4C,$4C4C044C,$4C044C04,$4C044C4C,$4C04044C,$04044C04,$4C044C4C,$4C040404
        long $04040404,$04040404,$04040404,$044C0404,$04040404,$04040404,$04040404,$04050404
        long $05050505,$05050505,$05050505,$05040505,$05050505,$05050505,$05050505,$05050505
tile067 long $2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$002A2A2A,$002A2A2A,$2A2A0000,$2A2A2A2A
        long $0000002A,$2A002A2A,$2A002A2A,$2A2A2A2A,$002B2B2B,$2B2B2B2B,$2B002B2B,$2B2B2B2B
        long $002B2B2B,$2B2B2B2B,$2B002B2B,$2B2B2B2B,$003B3B3B,$3B3B3B3B,$3B3B003B,$3B3B3B3B
        long $004B4B4B,$4B4B4B4B,$0B4B4B00,$4B4B4B4B,$002C2C2C,$002C2C2C,$2C2C2C2C,$2C2C2C4B
        long $002C2C2C,$00002C2C,$2C000000,$2C2C003C,$3C3C3C3C,$4C4C3C3C,$3C3C4C4C,$3C3C4C3C
        long $4C4C044C,$4C044C04,$4C044C4C,$4C043C04,$044C0404,$4C044C04,$4C4C0404,$4C044C04
        long $04040404,$04040404,$04040404,$04040404,$04040404,$04040404,$04040404,$04040404
        long $05050505,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505
tile068 long $2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$002A2A2A,$2A2A2A2A,$2A2A002A,$2A2A2A2A
        long $002A2A2A,$2A2A2A2A,$2A2A002A,$2A2A2A2A,$002B2B2B,$2B2B2B00,$2B2B0000,$2B2B2B2B
        long $002B2B2B,$002B002B,$002B002B,$2B2B0000,$003B3B3B,$003B003B,$3B00003B,$3B002B4B
        long $004B4B4B,$4B004B4B,$4B00004B,$4B004B4B,$002C2C2C,$2C002C2C,$2C00002C,$2C002C2C
        long $002C2C2C,$2C2C2C2C,$003C002C,$2C2C0000,$3C3C3C3C,$3C3C3C3C,$4C3C4C3C,$3C3C3C4C
        long $044C4C4C,$4C4C044C,$044C4C04,$4C044C4C,$04040404,$044C044C,$04044C04,$4C04044C
        long $4C040404,$04040404,$04040404,$04040404,$05040404,$04040404,$04040404,$04040404
        long $04050505,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505
tile069 long $2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A
        long $2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2B2B2B2B,$2B2B2B2B,$2B2B2B2B,$2B2B2B2B
        long $2B2B2B00,$00002B00,$2B2B2B00,$002B2B2B,$3B3B3B00,$4B3B0000,$3B3B002B,$3B003B3B
        long $004B004B,$0000004B,$4B4B0000,$004B4B4B,$002C002C,$2C4B002C,$2C2C2C2C,$2C2C2C2C
        long $2C002C2C,$00002C3C,$2C2C0000,$00002C2C,$3C4C3C3C,$4C4C3C3C,$3C3C3C4C,$4C4C3C3C
        long $044C4C04,$4C044C4C,$4C4C044C,$4C4C044C,$04044C04,$4C04044C,$044C0404,$044C0404
        long $04040404,$04040404,$04044C04,$04044C04,$04040404,$04040404,$04040504,$04040504
        long $05050505,$05050505,$05050405,$05050405,$05050505,$05050505,$05050505,$05050505
tile070 long $2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A00
        long $2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2B2B2B2B,$2B2B2B2B,$2B2B2B2B,$2B002B2B
        long $002B0000,$2B000000,$2B00002B,$00002B00,$003B2B4B,$002B4B3B,$3B3B003B,$3B003B00
        long $004B4B00,$004B4B4B,$4B2C004B,$4B004B00,$002C002C,$002C2C2C,$2C4B002C,$2C002C00
        long $002C2C00,$2C000000,$2C2C002C,$00002C00,$003C3C3C,$3C3C4C4C,$3C3C4C3C,$3C4C3C4C
        long $000C044C,$044C4C04,$4C044C4C,$4C4C044C,$044C0404,$04044C04,$4C04044C,$044C0404
        long $04044C04,$04040404,$04040404,$04040404,$04040504,$04040404,$04040404,$04040404
        long $05050405,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505
tile071 long $2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A
        long $2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2B2B2B2B,$2B2B2B2B,$2B2B2B2B,$2B2B2B2B
        long $00002B2B,$2B2B2B00,$2B002B2B,$2B2B002B,$4B3B003B,$3B3B002B,$3B003B3B,$3B3B003B
        long $0000004B,$4B4B0000,$4B004B4B,$4B004B00,$2C2C002C,$2C2C2C2C,$002C2C2C,$002C2C2C
        long $00002C2C,$2C2C0000,$002C2C2C,$002C2C2C,$4C4C4C3C,$3C3C3C4C,$3C3C3C3C,$3C3C3C3C
        long $4C4C4C04,$4C4C044C,$044C4C04,$4C044C4C,$04044C04,$044C0404,$04044C04,$4C04044C
        long $04040404,$0404044C,$04040404,$04040404,$04040404,$04040405,$04040404,$04040404
        long $05050505,$05050504,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505
tile072 long $2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A002A,$2A002A2A,$2A2A2A2A,$2A2A2A2A
        long $2A2A2A2A,$2A002A2A,$2A2A2A2A,$2A2A2A2A,$002B2B2B,$2B002B2B,$2B2B2B2B,$2B2B2B2B
        long $002B0000,$2B002B00,$2B2B0000,$002B2B2B,$003B0000,$00003B3B,$3B003B3B,$003B3B3B
        long $004B0000,$4B004B2C,$4B004B0B,$004B4B4B,$002C002C,$4B002C4B,$2C002C2C,$002C2C2C
        long $002C002C,$3C002C00,$2C003C2C,$002C2C2C,$4C3C3C4C,$3C4C3C4C,$3C4C3C3C,$3C3C3C3C
        long $044C044C,$044C4C4C,$4C044C4C,$4C044C4C,$044C4C04,$0404044C,$4C04044C,$4C040404
        long $04040404,$4C040404,$04040404,$044C0404,$04040404,$05040404,$04040404,$04050404
        long $05050505,$04050505,$05050505,$05040505,$05050505,$05050505,$05050505,$05050505
tile073 long $2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A
        long $2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2B2B2B2B,$2B2B2B2B,$2B2B2B2B,$2B2B2B2B
        long $00000000,$2B2B2B00,$2B000000,$2B2B002B,$3B004B3B,$003B003B,$002B4B3B,$3B3B003B
        long $0B004B4B,$004B004B,$004B4B4B,$4B4B004B,$2C002C2C,$002C002C,$002C2C2C,$2C2C002C
        long $3C002C2C,$3C2C002C,$2C000000,$00003C2C,$3C4C3C3C,$3C3C4C3C,$3C3C4C4C,$3C4C3C3C
        long $044C4C04,$4C044C4C,$044C4C04,$4C4C044C,$04044C04,$4C4C044C,$04044C04,$044C044C
        long $04040404,$04040404,$04040404,$04040404,$04040404,$04040404,$04040404,$04040404
        long $05050505,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505
tile074 long $2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A
        long $2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2B2B2B2B,$2B2B2B2B,$2B2B2B2B,$2B2B2B2B
        long $2B2B002B,$2B000000,$0000002B,$2B2B2B2B,$003B003B,$3B2B4B3B,$2B4B3B00,$3B3B3B00
        long $4B4B004B,$4B4B0000,$00000000,$4B4B4B00,$2C2C0000,$2C002C2C,$2C2C2C00,$2C2C2C2C
        long $002C002C,$2C3C0000,$0000002C,$2C2C2C00,$4C3C3C4C,$3C3C3C4C,$4C4C4C4C,$3C3C3C3C
        long $044C4C04,$4C044C4C,$4C4C0C4C,$4C4C044C,$04044C04,$4C04044C,$04040404,$044C0404
        long $04040404,$04040404,$044C0404,$04044C04,$04040404,$04040404,$04050404,$04040504
        long $05050505,$05050505,$05040505,$05050405,$05050505,$05050505,$05050505,$05050505
tile075 long $2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A
        long $2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2B2B2B2B,$2B2B2B2B,$2B2B2B2B,$2B2B2B2B
        long $2B2B2B2B,$2B2B2B2B,$2B2B2B2B,$2B2B2B2B,$3B3B3B3B,$3B3B3B3B,$3B3B3B3B,$3B3B3B3B
        long $4B4B4B4B,$4B4B4B4B,$4B4B4B4B,$4B4B4B4B,$2C2C2C2C,$2C2C2C2C,$2C2C2C2C,$2C2C2C2C
        long $2C2C2C2C,$2C2C2C2C,$2C2C2C2C,$2C2C2C2C,$3C3C3C3C,$3C3C3C3C,$3C3C3C3C,$3C3C3C3C
        long $4C4C044C,$044C4C4C,$4C4C4C4C,$4C4C4C4C,$044C0404,$04040404,$0404044C,$04040404
        long $04044C04,$044C0404,$04040404,$04040404,$04040504,$04050404,$04040404,$04040404
        long $05050405,$05040505,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505
tile076 long $2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A
        long $2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2A2A2A2A,$2B2B2B2B,$2B2B2B2B,$2B2B2B2B,$2B2B2B2B
        long $2B2B2B2B,$2B2B2B2B,$2B2B2B2B,$2B2B2B2B,$3B3B3B3B,$3B3B3B3B,$3B3B3B3B,$3B3B3B3B
        long $4B4B4B4B,$4B4B4B4B,$4B4B4B4B,$4B4B4B4B,$2C2C2C2C,$2C2C2C2C,$2C2C2C2C,$2C2C2C2C
        long $2C2C2C2C,$2C2C2C2C,$2C2C2C2C,$2C2C2C2C,$3C3C3C3C,$3C3C3C3C,$3C3C3C3C,$3C3C3C3C
        long $4C4C4C4C,$4C4C044C,$4C4C4C4C,$0C043C4C,$04040404,$044C0404,$04040404,$044C0404
        long $4C040404,$04040404,$04040404,$04040404,$05040404,$04040404,$04040404,$04040404
        long $04050505,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505,$05050505
        
spri000 long $00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$9BCA8BAB,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$CA9A0000,$59890102,$0000CA99,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$AB7B0200,$9ACA8BAB,$009A0202,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$0102029A,$01010101,$CA590201,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$9A000000,$59019A02,$02CB0202,$598A0149,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$02020000,$59010259,$5A5B5A02,$02020102,$0000009A,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$599A0000,$59029B99,$02020202,$9AAB5959,$00000002,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$9A000000,$9902BB59,$9ACAAB59,$CBAB02D8,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$02990248,$CA8ACACA,$02017A02,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$49000000,$89010158,$7A020259,$89019901,$00006A7A,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$79000000,$7A7A7A6A,$48480179,$01987901,$6A584801,$6A7A7A6B,$0000006A,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$7A6A7900,$6B6B7A6B,$4801797A,$88488888,$79880158,$7A6B7A6A,$0000797A,$00000000,$00000000,$58010101,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$7A7A7979,$7A7A6B7A,$797A7A6A,$58584801,$7A6A7901,$6A7A6A7A,$00796A7A,$00000000,$01010000,$00580101,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$6B7A7A79,$6A6B7A6A,$7A6A7A6B,$8888797A,$7A6A6A6A,$6A6A6A6A,$0079796A,$02020000,$01010101,$00000058,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$6A6A6A58,$7A696A7A,$7A6B7A7A,$6A797A6A,$6A7A7A6A,$8878797A,$00797979,$02595959,$00480159,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$79797968,$69786A79,$6A6A6A6A,$6A6A7A6A,$796A7A79,$48787858,$59590168,$01D85902,$00000059,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$9B9BAA99,$6878AABA,$796A6A79,$7979796A,$68787979,$48784868,$02020101,$01010101,$00000001,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$ACACCABA,$48A99BAB,$79797978,$58588879,$78486878,$01014988,$02010159,$99480101,$00000099,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$99000000,$ACACCAAA,$7899BA9B,$78787868,$68686868,$5959E858,$01010159,$01989848,$BABA9998,$000000AA,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$A9000000,$ACAC9BAA,$7898A9BA,$68788878,$79584878,$01595901,$480101E8,$9899A948,$AABABA98,$00000099,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$99000000,$9B9B02A9,$5898019A,$48685878,$59017901,$4801E859,$58584858,$01A9A859,$9899AAAA,$000000A8,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$A9000000,$BB9B9A02,$01999B8B,$48485959,$D8015959,$58585801,$58480158,$98A89901,$989898A8,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$01000000,$049BBA02,$59BAAC8C,$590159D8,$48010101,$58585858,$00880101,$98010101,$00009801,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$01000000,$AC9BBA88,$01599B04,$C8480159,$58584848,$48585858,$00014878,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$78000000,$BAAAAA48,$0199D899,$48787848,$58585858,$4878C858,$00019848,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$01989988,$58380159,$01484848,$48484848,$58489899,$00010178,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$48580000,$48784878,$58785858,$7858C898,$485888C8,$00009801,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$58000000,$58485848,$A8A89848,$589899A9,$58880158,$00010101,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$48584878,$A9A9A898,$88589801,$88887988,$58787978,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$58487800,$A8995858,$79785898,$79797979,$01797878,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$78886800,$78487979,$68787878,$78797978,$78796879,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$79584800,$78587879,$58786868,$78787978,$68787879,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$78797800,$78797978,$79784868,$69797978,$88797878,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$78787800,$68797979,$68787878,$6A796A78,$78797879,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$78780000,$78687868,$79797878,$796A7988,$00787979,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$68680000,$78787879,$78797868,$79797979,$00005879,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$88780000,$78787858,$79797878,$79797979,$00007879,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$68000000,$78787879,$79797868,$79797979,$00007879,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$68000000,$68787868,$78796878,$79025902,$00007968,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$88000000,$78787868,$59897868,$029A028A,$00000159,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$78686888,$59018868,$7A595999,$00009999,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$88888858,$01795888,$01990199,$00000058,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $00000000,$00000000,$00000000,$00000000,$00000000,$58585800,$58028858,$78785858,$00005901,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$88000000,$89018878,$02028A02,$00009802,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000
        long $0AE80000,$FAFAFAFA,$E80AFAFA,$00000000,$FAF94800,$E80AFAFA,$017A4878,$79980179,$00000198,$EA480000,$FAFAFAFA,$FAFAFAFA,$000049FA,$FAFAF900,$FAFAFAFA,$0000F9FA,$FAFAF800,$38E80AFA,$48E84848,$00000000,$FAFAEA48,$01EAFAFA,$99017858,$99598901,$00007902,$F9480000,$E90AFAFA,$49F8E901,$4800E8E8,$FAFAFA0A,$484801F9,$000048E8
        long $FAFAFA01,$000000E9,$00000000,$E8000000,$F902FA0A,$E80AFAFA,$FAFAD858,$595902FA,$EAF90299,$0A48F90A,$48E9FAFA,$00000000,$D8000000,$01EAFAFA,$00000000,$00000000,$EAFAFAE9,$EAF90149,$0048E9F9,$0A010000,$0138F9FA,$F8EAFAFA,$FA020188,$9902EAFA,$FAFA0A02,$EA4878E9,$E90AFAFA,$0001F849,$F9380000,$E839FAFA,$F90A02F9,$000000E8
        long $FAFAFAF9,$FAFAFAFA,$F8FAFAFA,$FA0A0100,$F80000E9,$590AFAFA,$0A015888,$0AFAFAFA,$39FAFAFA,$F9480058,$FAFAFAFA,$0AFAFAFA,$FAE800E9,$FAFAFAFA,$FAFAFAFA,$00480AFA,$0AFAFA02,$E84848F8,$EAFAFA0A,$49FAFAF9,$E8000000,$49EAFAFA,$98887888,$FAFAFAFA,$58E9FAFA,$EA480000,$0AF9020A,$FAFAFAEA,$0AF901FA,$38E9FAFA,$FAE9E848,$00EAFAFA
        long $E9FAFAF9,$00000048,$FAFAFA01,$FAFAFAFA,$FAFAFAFA,$FAFAFAFA,$0178D8FA,$FAFAEA59,$0000F9FA,$00000000,$00000000,$FA0A0100,$EA02F9FA,$00F8FAFA,$F9680000,$48EAFAFA,$0AFAFAE9,$000000E8,$FAFAFAE8,$FAFAFAFA,$FAFAFAFA,$FAFAFAFA,$590149FA,$FAFAFADB,$0049FAFA,$00000000,$00000000,$FAEA0000,$F9F90AFA,$0049FAFA,$49580000,$48F9FAFA
        long $FAFAFA01,$78000049,$0AFAFAF9,$484848F8,$49E84848,$E90AFAFA,$DA0200E8,$FAFAFAFA,$E8FAFAFA,$F9F97800,$00000001,$FAFAF948,$4901D80A,$E8EAFAFA,$0AE80000,$00F9FAFA,$FAFAF848,$0AEA0AFA,$01FAFAFA,$00000000,$F8000000,$01EAFAFA,$0ADA0000,$59DAFAFA,$FAFAFA02,$FA0248F8,$FAFAFAFA,$FAFAFAFA,$4800680A,$FAFAFAEA,$EA0AEA0A,$00480AFA
        long $EA380000,$FAFAFAFA,$78E8F9FA,$00000000,$E8000000,$F80AFAFA,$FAFAF948,$018902FA,$FAFAE801,$0AE9F9FA,$FAFAFAFA,$E80AFAFA,$00000000,$FA0A4900,$0AFAFAFA,$000078E9,$00000000,$48484800,$00000000,$00000000,$00000000,$00000000,$48000000,$01588848,$00000001,$00000000,$48484800,$00006848,$00000000,$78000000,$00784848,$00000000
        